
/**
 *	Copyright (c) 1997-98 
 *	NorthEast Parallel Architectures Center, Syracuse University. 
 * All Rights Reserved. Permission to use, copy, modify, and distribute this
 * software and its documentation for educational, research and non-profit
 * purposes, without fee, and without a written agreement is hereby granted,
 * provided that the above copyright notice and this paragraph appear in all
 * copies. Permission to incorporate this software into commercial products may
 * be obtained by contacting the NorthEast Parallel Architectures Center. 
 *
 * The software program and documentation are supplied "as is",
 * without any accompanying services from NPAC. NPAC does not
 * warrant that the operation of the program will be uninterrupted or
 * error-free. The end-user understands that the program was developed for
 * research purposes and is advised not to rely exclusively on the program for
 * any reason.
 *
 */

package edu.syr.npac.webflow.exception;

/** 
 * property Exception, which occurs due to problems hooking properties in the
 * Webflow runtime system.
 * 
 * @version     0.1  6 Oct 1998
 * @author      Shrideep Pallickara
 *
 */

public class propertyException extends webflowException  {
  /** The type of the exception */
  public int type;
  private String additionalInfo= " ";

  public propertyException() {
    super();
    //type = UNKNOWN;
  }

  public
  propertyException(int type) {
    super();
    this.type = type;
  }
  
  public int
  getType() {
    return(type);
  }
  
  public String
  typeToString(int type) {
    
    switch(type) {
    case NO_PROPERTIES:
      return ("No properties listed for this object" + getAdditionalInfo());
    case NO_SUCH_PROPERTY:
      return ("No such property " + getAdditionalInfo());      
    case PROPERTY_TYPE_MISMATCH:
      return ("Property type mis-match occured between " + 
	      getAdditionalInfo());
    case NO_READ_METHOD:
      return ("No read method associated with property " + 
	      getAdditionalInfo());
    case NO_WRITE_METHOD:
      return ("No write method associated with property " + 
	      getAdditionalInfo());
    }
    return ("Reason is unknown");
  }
  
  public void setAdditionalInfo(String _info) {
    additionalInfo = _info;
  }
  
  public String getAdditionalInfo() {
    return additionalInfo;
  }
  
  /** The various types of property exceptions that can be thrown. */ 
  public static final int NO_PROPERTIES                   = 100;
  public static final int NO_SUCH_PROPERTY                = 101;
  public static final int PROPERTY_TYPE_MISMATCH          = 102;
  public static final int NO_READ_METHOD                  = 103;
  public static final int NO_WRITE_METHOD                 = 104;
}
