/* 
 *	Copyright (c) 1997-98 
 *	NorthEast Parallel Architectures Center, Syracuse University. 
 * All Rights Reserved. Permission to use, copy, modify, and distribute this
 * software and its documentation for educational, research and non-profit
 * purposes, without fee, and without a written agreement is hereby granted,
 * provided that the above copyright notice and this paragraph appear in all
 * copies. Permission to incorporate this software into commercial products may
 * be obtained by contacting the NorthEast Parallel Architectures Center. 
 *
 * The software program and documentation are supplied "as is",
 * without any accompanying services from NPAC. NPAC does not
 * warrant that the operation of the program will be uninterrupted or
 * error-free. The end-user understands that the program was developed for
 * research purposes and is advised not to rely exclusively on the program for
 * any reason.
 *
 */

package edu.syr.npac.webflow.exception;

/** 
 * webflow Exception, which occurs due to some non-permissible event of the
 * Webflow runtime system.
 * 
 * @version     0.1 6 Oct 1998
 * @author      Shrideep Pallickara
 *
 */

public class webflowException extends org.omg.CORBA.UserException {
  
  public static final int UNKNOWN = 99;
  /** The type of the exception */
  public int type;
  public String info="Reason is unknown";
  
  
  public webflowException() {
    super();
    type = UNKNOWN;
  }
  
  public
  webflowException(int type) {
    super();
    this.type = type;
  }
  
  public webflowException(webflowException e) {
    super();
    type = e.getType();
    info = e.typeToString(type);
  }
  /** Return the type of the webflow Exception */
  
  public int
    getType() {
      return(type);
  }

  public String
    typeToString(int type) {
    return info;
  }
}

