/**
 *	Copyright (c) 1997-98 
 *	NorthEast Parallel Architectures Center, Syracuse University. 
 * All Rights Reserved. Permission to use, copy, modify, and distribute this
 * software and its documentation for educational, research and non-profit
 * purposes, without fee, and without a written agreement is hereby granted,
 * provided that the above copyright notice and this paragraph appear in all
 * copies. Permission to incorporate this software into commercial products may
 * be obtained by contacting the NorthEast Parallel Architectures Center. 
 *
 * The software program and documentation are supplied "as is",
 * without any accompanying services from NPAC. NPAC does not
 * warrant that the operation of the program will be uninterrupted or
 * error-free. The end-user understands that the program was developed for
 * research purposes and is advised not to rely exclusively on the program for
 * any reason.
 *
 */

package edu.syr.npac.webflow.impl.connection;

import java.util.*;
import java.beans.*;
import java.lang.reflect.*;

/**
 * propertyLinker - links properties in different objects. 
 *
 *
 * @version     0.5  28 Sep 1998
 * @author      Shrideep Pallickara
 *
 */

public class connectionManagerImpl 
extends edu.syr.npac.webflow.connection._connectionManagerImplBase {
  
  private Hashtable connections = new Hashtable();

  /** Construct a persistently named object. */
  public connectionManagerImpl(java.lang.String name) {
    super(name);
  }
  
  /** Construct a transient object. */
  public connectionManagerImpl() {
    super();
  }

  public edu.syr.npac.webflow.connection.connectionObject 
  createConnectionObject(String _objectName) {
    try {
      /* Initialize the ORB */
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
      edu.syr.npac.webflow.connection.connectionObject _connection = 
	new connectionObjectImpl(_objectName);
      orb.connect(_connection);
      
      connections.put(_objectName, _connection);
      return _connection;
    } catch (Exception e) {
      System.out.println(e);
      return null;
    }
  }

  public void compute(java.lang.String _connectionObjectName) {
    try {
      if (connections.containsKey(_connectionObjectName)) {
	((edu.syr.npac.webflow.connection.connectionObject)connections.get(_connectionObjectName)).compute();
	System.out.println("Computing here ...... ");
      }
    } catch (edu.syr.npac.webflow.exception.webflowException e) {
      System.out.println(e.typeToString(e.getType()));
    }
  }

  public String[] listConnectionObjects() {
    System.out.println("Starting to list the connections");
    if(connections.isEmpty()) {
      System.out.println("Sorry no connections listed here ....");
      return null;
    }
    else { 
      Enumeration e = connections.keys();
      String [] s =new String[connections.size()];
      int i=0;
      while (e.hasMoreElements()) {
	s[i++] =(java.lang.String)e.nextElement();
      }
      return s;
    }   
  }

}






