/**
 *	Copyright (c) 1997-98 
 *	NorthEast Parallel Architectures Center, Syracuse University. 
 * All Rights Reserved. Permission to use, copy, modify, and distribute this
 * software and its documentation for educational, research and non-profit
 * purposes, without fee, and without a written agreement is hereby granted,
 * provided that the above copyright notice and this paragraph appear in all
 * copies. Permission to incorporate this software into commercial products may
 * be obtained by contacting the NorthEast Parallel Architectures Center. 
 *
 * The software program and documentation are supplied "as is",
 * without any accompanying services from NPAC. NPAC does not
 * warrant that the operation of the program will be uninterrupted or
 * error-free. The end-user understands that the program was developed for
 * research purposes and is advised not to rely exclusively on the program for
 * any reason.
 *
 */

package edu.syr.npac.webflow.impl.connection;

import java.util.*;
import java.beans.*;
import java.lang.reflect.*;
import edu.syr.npac.webflow.exception.*;

public class connectionParser {
  propertyLinker linker = new propertyLinker();
  Hashtable moduleInfo = new Hashtable();
  Hashtable runInfo   = new Hashtable();
  
  public void parseAndInvoke(String command) 
       throws propertyException{
    StringTokenizer adder = new StringTokenizer(command, "+");
    Object target = null;
    while(adder.hasMoreTokens()) {
      StringTokenizer arrow = new StringTokenizer(adder.nextToken(), ">");
      StringTokenizer dotter= new StringTokenizer(arrow.nextToken(),".");
      
      String obj1 = dotter.nextToken();
      Object source = moduleInfo.get(obj1);
      String prop1 =  dotter.nextToken();
      dotter= new StringTokenizer(arrow.nextToken(), ".");
      target = moduleInfo.get(dotter.nextToken());
      String prop2 =  dotter.nextToken();
      
      if (runInfo.get(obj1).equals("NO")) {
	( (edu.syr.npac.webflow.module.Module) source).run();
	runInfo.remove(obj1);
	runInfo.put(obj1, "YES");
      }
      linker.hookPropertiesTogether(source, prop1, target, prop2);
    }
    ( (edu.syr.npac.webflow.module.Module) target).run();
    updateRunInfo();
  }
  
  public void addNode(String nodeName, 
		      edu.syr.npac.webflow.module.Module _module) {
    if (!moduleInfo.containsKey(nodeName)) {
      moduleInfo.put(nodeName, _module._clone());
      runInfo.put(nodeName, "NO");
    }
    System.out.println("Size of Table now = " + moduleInfo.size());
  }
  
  public void removeNode(String nodeName, 
			 edu.syr.npac.webflow.module.Module _module)  {
    if (moduleInfo.containsKey(nodeName)) {
      moduleInfo.remove(nodeName);
      runInfo.remove(nodeName);
    }
  }

  public edu.syr.npac.webflow.module.Module getNode(String nodeName) {
    if (moduleInfo.containsKey(nodeName)) {
      System.out.println("Returning the value " +
			  (edu.syr.npac.webflow.module.Module)moduleInfo.get(nodeName));
      return (edu.syr.npac.webflow.module.Module) moduleInfo.get(nodeName);
    }
    return null;
  }

  public Object invoke(String nodeName, String sourcePropName) {
    Object sourceObject= moduleInfo.get(nodeName);
    PropertyDescriptor sourceProperties[];
    sourceProperties = getProperties(sourceObject);
    PropertyDescriptor sourceProp;
    sourceProp = null;
    for ( int i =0; i < sourceProperties.length -1; i++) {
      System.out.println(sourceProperties[i]);
      if ((sourceProperties[i].getDisplayName()).equals(sourcePropName)) {
	sourceProp = sourceProperties[i];
	break;
      }
    }
    Method getter = sourceProp.getReadMethod();
    if (getter == null) {
      System.out.println("Sorry dude .... u screwed up somewhere");
      return null;
    }
    
    try {
      Object args[] = {};
      Object value = getter.invoke(sourceObject, args);
      return value;
    } catch (Exception ex) {
      System.out.println("Get outta here");
    } 
    return null;
  }

  private void updateRunInfo() {
    runInfo.clear();
   synchronized (moduleInfo) {
      Enumeration e = moduleInfo.keys();
      while (e.hasMoreElements()) {
	runInfo.put(e.nextElement(), "NO");
      }
    }
  }

   private PropertyDescriptor[] getProperties(Object anyObject) {
    
    try {
      return ( Introspector.getBeanInfo(anyObject.getClass()).getPropertyDescriptors());
    } catch (Exception e) {
      System.out.println("Error listing the properties "); 
      return null;
    }
  }
}
