package edu.syr.npac.webflow.impl.manager;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import java.util.*;

public class nameSpaceWalker {
  static int  Level=1;
  NamingContext context;
  Vector nameSpaceInfo = new Vector();
 
  public String[] listNameContextsAndObjects(String name) {
    org.omg.CORBA.ORB orb;
    NamingContext root;
    
    orb = org.omg.CORBA.ORB.init();
    try {
      root = NamingContextHelper.bind(orb, name);
    }
    catch(Exception e) {
      e.printStackTrace();
      try {
	System.out.println("\t...using the NameService");
	root = (NamingContext)orb.resolve_initial_references("NameService");
      } catch (org.omg.CORBA.ORBPackage.InvalidName invalidName) {
	System.out.println("\t...using bind()");
	root = NamingContextHelper.bind(orb);
      }
    }
    
    listContextInfo(root);
    Level=1;
    return recursionInfo();
  }
  
  private void listContextInfo(NamingContext tempContext) {
    BindingListHolder bl     = new BindingListHolder();
    BindingIteratorHolder bi = new BindingIteratorHolder();
    int howMany = 0;
    String line=" ";

    tempContext.list(howMany, bl, bi);

    int i=0;
    for (BindingHolder binding = new BindingHolder();
	 bi.value.next_one(binding); ) {
      for (int j=0; j <= Level; j ++)
	line += "***";
      line += i++ + ": " + toString(binding.value);
      //nameSpaceInfo.addElement(line);
      String temp[] = parseBindingInfo(toString(binding.value));
      nameSpaceInfo.addElement(Level + "."+i+" " + temp[0]+" "+ temp[1]);
      if (temp[0].equals("ncontext")) {
	Level++;
	recursiveContext(temp[1], tempContext);
      }
      line=" ";
    }
    Level--;
  }

  private void recursiveContext(String name, NamingContext _t) {
    try {
      context = _t;
      org.omg.CORBA.Object tmpObject = context.resolve(toName(name));
      if (tmpObject == null)
	System.out.println("resolved to null...");
      else
	{
	  NamingContext tmpContext = NamingContextHelper.narrow(tmpObject);
	  if (tmpContext == null)
	    System.out.println(new StringBuffer("resolved to ").append(tmpObject._repository_id()).toString());
	  else {
	    context = tmpContext;
	    listContextInfo(context);
	  }
	}
    } catch (Exception e) {
      e.printStackTrace();
      System.out.println(name + " -> " + context);
    }
  }
  
  private static String toString(Binding binding) {
    LNameFactory factory;
    LName lname;
    factory = com.visigenic.vbroker.services.CosNaming.LFactory.instance();
    lname = factory.create_lname();
    lname.from_idl_form(binding.binding_name);
    String typeName[] = { "nobject", "ncontext" };
    return typeName[binding.binding_type.value()] + ",name=" + lname + "]";
  } 
  
  private static NameComponent[] toName(String name) 
       throws org.omg.CORBA.UserException 
  {
    LNameFactory factory = 
      com.visigenic.vbroker.services.CosNaming.LFactory.instance();
    LName lname=factory.create_lname();
    StringTokenizer slasher = new StringTokenizer(name, "/");
    int index=1;
    while(slasher.hasMoreTokens()) {
      LNameComponent component=factory.create_lname_component();
      String nameComponent=slasher.nextToken();
      StringTokenizer dotter=
	new StringTokenizer(nameComponent, ".");
      component.set_id(dotter.hasMoreTokens() ? dotter.nextToken() : "");
      component.set_kind(dotter.hasMoreTokens() ? dotter.nextToken() : "");
      lname.insert_component(index++, component);
    }
    return lname.to_idl_form();
  }

  private String[] parseBindingInfo(String _space) {
    String info[] = new String[2];
    
    StringTokenizer commaToken = new StringTokenizer(_space, ",");
    info[0] = commaToken.nextToken();
    StringTokenizer extractor = new StringTokenizer(commaToken.nextToken(),
						    "=");
    extractor.nextToken();
    extractor.nextToken();
    info[1] = extractor.nextToken();
    return info;
  }
  
  private String[] recursionInfo() {
    String temp[] = new String[nameSpaceInfo.size()];
    nameSpaceInfo.copyInto(temp);
    nameSpaceInfo.removeAllElements();
    return temp;
  }
}


