package edu.syr.npac.webflow.impl.module.imaging;

import org.omg.CosNaming.*;
import java.util.*;

public class CompositeModule
extends edu.syr.npac.webflow.module.imaging._ImageModuleImplBase {
  
  private int[] pixel;
  private int imgw;
  private int imgh;
  private String composition;
  private edu.syr.npac.webflow.module.imaging.ImageModule[] modules;


  /** Construct a persistently named object. */
  public CompositeModule(java.lang.String name) {
    super(name);
    composition=name;
  }
  
  /** Construct a transient object. */
  public CompositeModule() {
    super();
  }
  
  public void setWidth(int nimgw) {
    imgw = nimgw;
    System.out.println("Set the width");
  }
  
  public int getWidth(){ 
    return imgw;
  }
  
  public void setHeight(int nimgh) {
    imgh=nimgh;
    System.out.println("Set the height");
  }
  
  public int getHeight() {
    return imgh;
  }
  
  public void setPixels(int[] pixels) {
    pixel = new int[pixels.length];
    System.arraycopy(pixels, 0, pixel, 0, pixels.length);
    System.out.println("Set the pixels");
  }
  
  public int[] getPixels(){
    return pixel;
  }
  
  
  private NameComponent[] toName(String name) 
       throws org.omg.CORBA.UserException {
	 LNameFactory factory = 
	   com.visigenic.vbroker.services.CosNaming.LFactory.instance();
	 LName lname=factory.create_lname();
	 StringTokenizer slasher = new StringTokenizer(name, "/");
	 int index=1;
	 while(slasher.hasMoreTokens()) {
	   LNameComponent component=factory.create_lname_component();
	   String nameComponent=slasher.nextToken();
	   StringTokenizer dotter=
	     new StringTokenizer(nameComponent, ".");
	   component.set_id(dotter.hasMoreTokens() ? dotter.nextToken() : "");
	   component.set_kind(dotter.hasMoreTokens() ? dotter.nextToken() : "");
	   lname.insert_component(index++, component);
	 }
	 return lname.to_idl_form();
  }
  
  
  /**
   * run the module code
   */ 
  public void run(){
    System.out.println("Invoked Filtering on the server side");
    try {
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
      org.omg.CosNaming.NamingContext rootContext =
	org.omg.CosNaming.NamingContextHelper.bind(orb, "NPAC/1");
      StringTokenizer slasher = new StringTokenizer(composition, "/");
      modules = 
	new edu.syr.npac.webflow.module.imaging.ImageModule[slasher.countTokens()];
      int index=0;
      while(slasher.hasMoreTokens()) {
	String filterName = slasher.nextToken();
	NameComponent []name = 
	  toName("WebFlow/ApplicationDomain/Imaging/" + filterName);
	org.omg.CORBA.Object object=rootContext.resolve(name);
	modules[index] = 
	  edu.syr.npac.webflow.module.imaging.ImageModuleHelper.narrow(object);
	index++;
      }
    } catch(org.omg.CORBA.UserException e) {
      System.out.println("Exception: " + e);
    }	
    

    for (int i=0; i < modules.length; i++) {
      modules[i].setPixels(pixel);
      modules[i].setWidth(imgw); 
      modules[i].setHeight(imgh);
      modules[i].run();
      pixel = modules[i].getPixels();
      imgw  = modules[i].getWidth();
      imgh  = modules[i].getHeight();
    }
  }
  
  /**
   * deallocate all resources allocated by the module. Destroy the module
   */
  public void destroy(){
    
  }
}

