package edu.syr.npac.webflow.impl.module.imaging;

public class ConvexFilter 
extends edu.syr.npac.webflow.module.imaging._ImageModuleImplBase {
  
  private int[] pixel;
  private int imgw;
  private int imgh;
  
  /** Construct a persistently named object. */
  public ConvexFilter(java.lang.String name) {
    super(name);
  }
  
  /** Construct a transient object. */
  public ConvexFilter() {
    super();
  }
  
  
  public void setWidth(int nimgw) {
    imgw = nimgw;
    System.out.println("Set the width");
  }
  
  public int getWidth(){ 
    return imgw;
  }
  
  public void setHeight(int nimgh) {
    imgh=nimgh;
    System.out.println("Set the height");
  }
  
  public int getHeight() {
    return imgh;
  }
  
  public void setPixels(int[] pixels) {
    pixel = new int[pixels.length];
    System.arraycopy(pixels, 0, pixel, 0, pixels.length);
    System.out.println("Set the pixels");
  }
  
  public int[] getPixels(){
    return pixel;
  }
  
  private void filter(int[] npixel, int nimgw, int nimgh) {
    System.out.println("Convex Filtering begins on the server-side....");
    int radius = nimgw/2;
    int _pixel[] = new int[nimgw * nimgh];
    int wpixel[] = new int[nimgw];
    
    for (int j=0; j< nimgh; j++) {
      int a = j - nimgh/2;
      int b = a*a;
      for (int i=0; i <nimgw; i++) {
	int c = i - nimgw/2;
	int d = c*c;
	double d1 =  Math.sqrt((double)(b+d));
	if ((int)d1 < radius) {
	  double d2 = d1 / radius;
	  if (d2 <= 0.5)
	    d2=0.5;
	  double d3 = d2 * c;
	  double d4 = d2 * a;
	  int _val1 = nimgw/2 + (int)d3;
	  int _val2 = nimgh/2 + (int)d4;
	  wpixel[i] = npixel[_val2* nimgw + _val1];
	}
	else
	  wpixel[i] =0;
      }
      System.arraycopy(wpixel,0, _pixel, j*nimgw, nimgw);
    }
    System.arraycopy(_pixel,0, pixel, 0, _pixel.length); 
  }
  
  /**
   * run the module code
   */ 
  public void run(){
    filter(pixel, imgw, imgh);
    System.out.println("Invoked Filtering on the server side");
  }
  
  /**
   * deallocate all resources allocated by the module. Destroy the module
   */
  public void destroy(){
    
  }
  
}


