import java.sql.*;

class BankDB {
	
    private Connection conn;
    private String username_;
    private String password_;
    private long trNo_;
    private String zone_;
    private String time_;

    public void open(String username, String password, long trNo,
            String time, String zone) {
        username_ = username;
        password_ = password;
        trNo_ = trNo;
        time_ = time;
        zone_ = zone;

        try {
        Class.forName ("oracle.jdbc.driver.OracleDriver");
            conn = DriverManager.getConnection ("jdbc:oracle:oci7:", 
                                  "cwou", "Jessica");
        } catch (Exception ex) {
            System.err.println("BankDB: Exception->" + ex);
        }
    }

    public String querySaving() {
        String msg = null;
        try {
        CallableStatement cstmt = 
                      conn.prepareCall("begin ? := banking.query_s(?, ?, ?, ?); end;");
        cstmt.registerOutParameter(1, Types.FLOAT);
        cstmt.setString(2, username_);
        cstmt.setLong(3, trNo_);
        cstmt.setString(4, time_);
        cstmt.setString(5, zone_);
        cstmt.execute ();
        float amount = cstmt.getFloat(1);
	cstmt.close();
        msg = "Saving Account: " + Float.toString(amount) + "\n";
        } catch (Exception ex) {
            System.err.println("BankDB: Exception->" + ex);
        }
        return msg;
    }	

    public String queryChecking() {
        String msg = null;
       try {
        CallableStatement cstmt =
                  conn.prepareCall("begin ? := banking.query_c(?, ?, ?, ?); end;");
        cstmt.registerOutParameter(1, Types.FLOAT);
        cstmt.setString(2, username_);
        cstmt.setLong(3, trNo_);
        cstmt.setString(4, time_);
        cstmt.setString(5, zone_);
        cstmt.execute ();
        float amount = cstmt.getFloat(1);
        cstmt.close();
        msg = "Checking Account: " + Float.toString(amount) + "\n";
        } catch (Exception ex) {
            System.err.println("BankDB: Exception->" + ex);
        }
        return msg;
    }

    public String transferSC(float trAmount) {
        String msg = null;
     try {
        CallableStatement cstmt =
            conn.prepareCall("begin ? := banking.transfer_s_c(?, ?, ?, ?, ?, ?, ?); end;");
        cstmt.registerOutParameter(1, Types.INTEGER);
        cstmt.setString(2, username_);
        cstmt.setLong(3, trNo_);
        cstmt.setFloat(4, trAmount);
        cstmt.setString(5, time_);
        cstmt.setString(6, zone_);
        cstmt.registerOutParameter(7, Types.FLOAT);
        cstmt.registerOutParameter(8, Types.FLOAT);
        cstmt.execute ();
        int flag = cstmt.getInt(1);
        float saving = cstmt.getFloat(7);
        float checking = cstmt.getFloat(8);
        cstmt.close();
        msg = Float.toString(trAmount) + 
                     " transfered from Saving to Checking\n" +
                     "Saving Account: " + Float.toString(saving) + "\n" +
                     "Checking account: " + Float.toString(checking) + "\n";
        } catch (Exception ex) {
            System.err.println("BankDB: Exception->" + ex);
        }
        return msg;
    }

    public String transferCS(float trAmount) {
        String msg = null;
      try {
        CallableStatement cstmt =
            conn.prepareCall("begin ? := banking.transfer_c_s(?, ?, ?, ?, ?, ?, ?); end;");
        cstmt.registerOutParameter(1, Types.INTEGER);
        cstmt.setString(2, username_);
        cstmt.setLong(3, trNo_);
        cstmt.setFloat(4, trAmount);
        cstmt.setString(5, time_);
        cstmt.setString(6, zone_);
        cstmt.registerOutParameter(7, Types.FLOAT);
        cstmt.registerOutParameter(8, Types.FLOAT);
        cstmt.execute ();
        int flag = cstmt.getInt(1);
        float saving = cstmt.getFloat(7);
        float checking = cstmt.getFloat(8);
        cstmt.close();
        msg = Float.toString(trAmount) +
                     " transfered from Saving to Checking\n" +
                     "Saving Account: " + Float.toString(saving) + "\n" +
                     "Checking account: " + Float.toString(checking) + "\n";
        } catch (Exception ex) {
            System.err.println("BankDB: Exception->" + ex);
        }
        return msg;
    }

    public void close() {
        try {
        conn.close();
        } catch (Exception ex) {
            System.err.println("BankDB: Exception->" + ex);
        }
    }

    /* Testing 
    public static void main(String[] argv) 
            throws SQLException, ClassNotFoundException {
        BankDB db = new BankDB();
        db.open("cwou", "Jessica", 1, "Mar 13 09:43:55 1998", "EST");
        System.out.println("QuerySaving: " + db.querySaving());
        System.out.println("QueryChecking: " + db.queryChecking());
        System.out.println("TransferCS: " + db.transferCS((float)1500));
        System.out.println("TransferSC: " + db.transferSC((float)1000));
        db.close();
    }
    */
}
