import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.util.Properties;
import java.util.*;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import com.sun.CORBA.iiop.*;

import AdministratorICoordinator.*;
/*
class AdministratorBeepingThread extends Thread {

    private AdministratorICoordinator.Administration admin_;
    private boolean stopFlag_;
    private long beeps = 1;

    public AdministratorBeepingThread(AdministratorServer.Transaction tr) {
        transaction_ = tr;
    }

    public void setStopFlag(boolean flag) {
        stopFlag_ = flag;
    }

    public void run() {
        try {
            while (true) {
                this.sleep(45000);
                if (admin_.beeping(++beeps)) {
                    if (stopFlag_) {
                        return;
                    }
                } else {
                    System.out.println("Administrator: Transaction connection failed\n");
                }
            }
        } catch (Exception ex) {
            System.err.println("Administrator: Thread Exception-> " + ex) ;
        }
    }
}
*/
public
class AdministratorApplet extends Applet implements ActionListener {
    /** ORB
    **/
    private static AdministratorICoordinator.Administration admin_;
    private static AdministratorICoordinator.AdministratorManager adminManager_;
    
    private Insets mInsets                 = new Insets(3,3,3,3);

    private Label       adminLabel;
    private Label       usernameLabel;
    private TextField   usernameField;
    private Label       passwordLabel;
    private TextField   passwordField;

    private Button      connectButton;

    private Button      exitButton;
    private Button      addButton;
    private Button      deleteButton;
    private Button      updateButton;
    private Button      searchButton;
    private Button      showButton;

    private Label       adminUserIDLabel;
    private TextField   adminUserIDField;
    private Label       adminLastNameLabel;
    private TextField   adminLastNameField;
    private Label       adminFirstNameLabel;
    private TextField   adminFirstNameField;
    private Label       adminAddressLabel;
    private TextArea    adminAddressArea;
    private Label       adminHPhoneLabel;
    private TextField   adminHPhoneField;
    private Label       adminWPhoneLabel;
    private TextField   adminWPhoneField;

    private Button      OKButton;
    private Button      clearButton;

    private Label       messageLabel;
    private TextArea    messageArea;

    private boolean     isConnectToICoordinator = false;

    private String      currentAction;
    private String      prevAction;

    private long        startTime;
    private long        stopTime;

    // private AdministratorBeepingThread beepingThread;

    public
    void init() {
      super.init();
      setSize(450, 640);
      createGui();
      usernameField.requestFocus();
    }

    /** Initialize ORB connection **/
   
    protected
    void setORBConnectionToICoordinator() {
      Properties props = new Properties();
      props.put("org.omg.CORBA.ORBClass", "com.sun.CORBA.iiop.ORB");
      props.put("org.omg.CORBA.ORBInitialHost", "osprey8.npac.syr.edu");
      props.put("org.omg.CORBA.ORBInitialPort", "9966");

      try {
        // create and initialize the ORB
        org.omg.CORBA.ORB orb =  org.omg.CORBA.ORB.init(this, props);

        // get the root naming context
        org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
        NamingContext ncRef = NamingContextHelper.narrow(objRef);

        // resolve the Object Reference in Naming
        NameComponent nc = new NameComponent("NPAC_ICoordinator", "");
        NameComponent path[] = {nc};
        adminManager_ = 
    AdministratorICoordinator.AdministratorManagerHelper.narrow(ncRef.resolve(path));
      }
      catch (Exception ex) {
        System.out.println("Administrator: ORB-ICoordinator Exception-> " + ex) ;
      }
    }

    protected 
    Button makeButton(String name,
                      int row,
                      GridBagLayout gridbag,
                      GridBagConstraints c) {

        c.gridy = row;
        Button button = new Button(name);
        button.addActionListener(this);
        gridbag.setConstraints(button, c);
        add(button);

        return button;
    }

    protected 
    Label makeLabel(String name,
                    int row,
                    int size,
                    GridBagLayout gridbag,
                    GridBagConstraints c) {

        c.gridy = row;
        Label label = new Label(name, Label.CENTER);
        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gridbag.setConstraints(label, c);
        add(label);
  
        return label;
    }

    protected 
    TextField  makeTextField(String name,
                             int row,
                             int length,
                             boolean passwd,
                             GridBagLayout gridbag,
                             GridBagConstraints c) {

        c.gridy = row;
        TextField field = new TextField(length);
        if (passwd) {
            field.setEchoChar('*');
        }
        field.addActionListener(this);
        gridbag.setConstraints(field, c);
        add(field);

        return field;
    }

    protected 
    TextArea makeTextArea(String name,
                          int row,
                          int height,
                          int width,
                          GridBagLayout gridbag,
                          GridBagConstraints c) {

        c.gridy = row;
        TextArea area = new TextArea(name, height, width);
        gridbag.setConstraints(area, c);
        add(area);

        return area;
    }

    public
    void createGui() {
      setBackground(Color.lightGray);

      GridBagLayout gb = new GridBagLayout();
      GridBagConstraints gbc = new GridBagConstraints();
      setLayout(gb);

      int row = 0;

      gbc.anchor      = GridBagConstraints.NORTH;
      gbc.fill        = GridBagConstraints.BOTH;
      gbc.gridx       = 0;
      gbc.gridwidth   = 2;
      gbc.gridheight  = 2;
      gbc.weightx     = 1;
      gbc.weighty     = 1;
      adminLabel = makeLabel("NPAC Administrator", row, 16, gb, gbc);

      row += 3;

      gbc.anchor      = GridBagConstraints.CENTER;
      gbc.fill        = GridBagConstraints.REMAINDER;
      gbc.gridwidth   = 1;
      gbc.gridheight  = 1;
      usernameLabel = makeLabel("Username: ", row, 12, gb, gbc);

      gbc.gridx       = 1;
      usernameField = makeTextField("", row, 30, false, gb, gbc);

      row += 2;

      gbc.gridx       = 0;
      passwordLabel = makeLabel("Password: ", row, 12, gb, gbc);

      gbc.gridx       = 1;
      passwordField = makeTextField("", row, 30, true, gb, gbc);

      row += 2;

      gbc.gridx       = 0;
      gbc.gridwidth   = 2;
      gbc.gridheight  = 2;
      connectButton = makeButton("Connect", row, gb, gbc);

      row += 5;

      gbc.gridwidth   = 1;
      gbc.gridheight  = 1;
      addButton = makeButton("New User", row, gb, gbc);
      addButton.setEnabled(false);
      gbc.gridx       = 1;
      deleteButton = makeButton("Delete User", row, gb, gbc);
      deleteButton.setEnabled(false);

      row += 1;
      gbc.gridx       = 0;
      updateButton = makeButton("Update User", row, gb, gbc);
      updateButton.setEnabled(false);
      gbc.gridx       = 1;
      searchButton = makeButton("Search User", row, gb, gbc);
      searchButton.setEnabled(false);

      row += 1;
      gbc.gridx       = 0;
      showButton = makeButton("Show Balance", row, gb, gbc);
      showButton.setEnabled(false);
      gbc.gridx       = 1;
      exitButton = makeButton("Exit", row, gb, gbc);
      exitButton.setEnabled(false);

      row += 2;
      gbc.gridwidth   = 1;
      gbc.gridx       = 0;
      adminUserIDLabel = makeLabel("User ID: ", row, 12, gb, gbc);
      adminUserIDLabel.setEnabled(false);

      gbc.gridx       = 1;
      adminUserIDField = makeTextField("", row, 30, false, gb, gbc);
      adminUserIDField.setEnabled(false);

      row += 2;
      gbc.gridx       = 0;
      adminLastNameLabel = makeLabel("Last Name: ", row, 12, gb, gbc);
      adminLastNameLabel.setEnabled(false);

      gbc.gridx       = 1;
      adminLastNameField = makeTextField("", row, 30, false, gb, gbc);
      adminLastNameField.setEnabled(false);

      row += 2;
      gbc.gridx       = 0;
      adminFirstNameLabel = makeLabel("First Name: ", row, 12, gb, gbc);
      adminFirstNameLabel.setEnabled(false);

      gbc.gridx       = 1;
      adminFirstNameField = makeTextField("", row, 30, false, gb, gbc);
      adminFirstNameField.setEnabled(false);

      row += 2;
      gbc.gridx       = 0;
      adminAddressLabel = makeLabel("Address: ", row, 12, gb, gbc);
      adminAddressLabel.setEnabled(false);

      gbc.gridx       = 1;
      adminAddressArea = makeTextArea("", row, 4, 40, gb, gbc);
      adminAddressArea.setEnabled(false);

      row += 2;
      gbc.gridx       = 0;
      adminHPhoneLabel = makeLabel("Home Phone: ", row, 12, gb, gbc);
      adminHPhoneLabel.setEnabled(false);

      gbc.gridx       = 1;
      adminHPhoneField = makeTextField("", row, 30, false, gb, gbc);
      adminHPhoneField.setEnabled(false);

      row += 2;
      gbc.gridx       = 0;
      adminWPhoneLabel = makeLabel("Work Phone: ", row, 12, gb, gbc);
      adminWPhoneLabel.setEnabled(false);

      gbc.gridx       = 1;
      adminWPhoneField = makeTextField("", row, 30, false, gb, gbc);
      adminWPhoneField.setEnabled(false);

      row += 5;
      gbc.gridx       = 0;
      OKButton = makeButton("  OK  ", row, gb, gbc);
      OKButton.setEnabled(false);

      gbc.gridx       = 1;
      clearButton = makeButton("Clear", row, gb, gbc);
      clearButton.setEnabled(false);

      row += 5;

      gbc.anchor      = GridBagConstraints.SOUTH;
      gbc.fill        = GridBagConstraints.NONE;
      gbc.gridx       = 0;
      gbc.gridwidth   = 2;
      messageLabel = makeLabel("Message Box", row, 16, gb, gbc);

      row += 2;

      messageArea = makeTextArea("", row, 10, 60, gb, gbc);
   }

    protected
    void changeConnectDisplay(boolean f1, boolean f2) {
         connectButton.setEnabled(f1);
         usernameLabel.setEnabled(f1);
         usernameField.setText("");
         usernameField.setEnabled(f1);
         passwordLabel.setEnabled(f1);
         passwordField.setText("");
         passwordField.setEnabled(f1);
         addButton.setEnabled(f2);
         deleteButton.setEnabled(f2);
         updateButton.setEnabled(f2);
         searchButton.setEnabled(f2);
         showButton.setEnabled(f2);
         exitButton.setEnabled(f2);
    }

    protected
    void changeDisplay(boolean f1, boolean f2, boolean f3, boolean f4,
                       boolean f5, boolean f6, boolean f7, boolean clean) {
         if (clean) {
             adminUserIDField.setText("");
             adminLastNameField.setText("");
             adminFirstNameField.setText("");
             adminAddressArea.replaceRange("", 0, messageArea.getText().length());
             adminHPhoneField.setText("");
             adminWPhoneField.setText("");
         }
         adminUserIDLabel.setEnabled(f1);
         adminUserIDField.setEnabled(f1);
         adminLastNameLabel.setEnabled(f2);
         adminLastNameField.setEnabled(f2);
         adminFirstNameLabel.setEnabled(f3);
         adminFirstNameField.setEnabled(f3);
         adminAddressLabel.setEnabled(f4);
         adminAddressArea.setEnabled(f4);
         adminHPhoneLabel.setEnabled(f5);
         adminHPhoneField.setEnabled(f5);
         adminWPhoneLabel.setEnabled(f6);
         adminWPhoneField.setEnabled(f6);
         OKButton.setEnabled(f7);
         if (currentAction.equals("Exit")) {
             clearButton.setEnabled(false);
         } else {
             clearButton.setEnabled(f7);
         }
    }

   /**
    *  Handle action events from various controls
    *  Overrides Component.action().
    */
   public
   void actionPerformed(ActionEvent pe) {
     // User selected month from the choice
     String actionLabel = pe.getActionCommand();

     if (actionLabel.equals("Connect")) {
         messageArea.replaceRange("", 0, messageArea.getText().length());
         String userid = usernameField.getText();
         String passwd = passwordField.getText();
         if (userid.length() == 0) {
             messageArea.replaceRange("Null username!  Try again!\n", 0, 
                                      messageArea.getText().length());
             return;
         }
         if (passwd.length() == 0) {
             messageArea.replaceRange("Null password!  Try again!\n", 0,
                                      messageArea.getText().length());
             return;
         }
         getAppletContext().showStatus("Connecting to Internal Coordinator");
         /*
         if (!isConnectToICoordinator) {
             setORBConnectionToICoordinator();
             isConnectToICoordinator = true;
         }
         if ((admin_ = adminManager_.connect(userid, passwd)) == null) {
             messageArea.replaceRange("Wrong Username/Password.", 0, 
                                      messageArea.getText().length());
             getAppletContext().showStatus("Verification failed");
             return;
         }
         */
         startTime = System.currentTimeMillis();
         messageArea.append("Connected to Internal Coordinator\n");

         Date time = new Date();
         messageArea.append(time.toString() + "\n");

         // Start beeping thread to infrom Server
         /*
         beepingThread = new AdministratorBeepingThread(transaction_);
         beepingThread.setPriority(java.lang.Thread.NORM_PRIORITY+1);
         beepingThread.setStopFlag(false);
         beepingThread.start();
         */

         // Change the applet display
         changeConnectDisplay(false, true);
         currentAction = "Connect";
     }
     if (actionLabel.equals("New User")) {
         getAppletContext().showStatus("New User");
         changeDisplay(false, true, true, true, true, true, true, true);
         adminLastNameField.requestFocus();
         currentAction = "New User";
         messageArea.append("New User\n");
     }
     if (actionLabel.equals("Delete User")) {
         getAppletContext().showStatus("Delete User");
         changeDisplay(true, true, true, false, true, false, true, true);
         adminUserIDField.requestFocus();
         currentAction = "Delete User";
         messageArea.append("Delete User\n");
     }
     if (actionLabel.equals("Search User")) {
         getAppletContext().showStatus("Search User");
         changeDisplay(true, true, true, false, true, false, true, true);
         adminUserIDField.requestFocus();
         currentAction = "Search User";
         messageArea.append("Search User\n");
     }
     if (actionLabel.equals("Update User")) {
         getAppletContext().showStatus("Update User");
         changeDisplay(true, true, true, false, true, false, true, true);
         adminUserIDField.requestFocus();
         currentAction = "Update User";
         messageArea.append("Update User\n");
     }
     if (actionLabel.equals("Show Balance")) {
         getAppletContext().showStatus("Show Balance");
         changeDisplay(true, true, true, false, true, false, true, true);
         adminUserIDField.requestFocus();
         currentAction = "Show Balance";
         messageArea.append("Show Balance\n");
     }
     if (actionLabel.equals("Exit")) {
         currentAction = "Exit";
         changeDisplay(false, false, false, false, false, false, true, true);
     }
     if (actionLabel.equals("  OK  ")) {
         if (currentAction.equals("New User")) {
             changeDisplay(false, false, false, false, false, false, false, true);
             getAppletContext().showStatus("Adding New User");
             messageArea.append("New User - Done\n");
         }
         if (currentAction.equals("Delete User")) {
             prevAction = currentAction;
             currentAction = "Search User";
             changeDisplay(true, false, false, false, false, false, true, true);
             getAppletContext().showStatus("Deleting User");
         }
         if (currentAction.equals("Search User")) {
             if (prevAction.equals("Delete User")) {
                 messageArea.append("Deleted User - Done\n");
             }
             if (prevAction.equals("Update User")) {
                 messageArea.append("Update User - Done\n");
             }
             if (prevAction.equals("Show Balance")) {
                 messageArea.append("Balance\n");
             }
             changeDisplay(false, false, false, false, false, false, false, true);
         }
         if (currentAction.equals("Show Balance")) {
             prevAction = currentAction;
             currentAction = "Show Balance";
             changeDisplay(true, false, false, false, false, false, true, true);
             getAppletContext().showStatus("Showing Balance");
         }
         if (currentAction.equals("Update User")) {
             prevAction = currentAction;
             currentAction = "Search User";
             changeDisplay(true, true, true, false, true, false, true, true);
             getAppletContext().showStatus("Updating User");
         }
         if (currentAction.equals("Exit")) {
             getAppletContext().showStatus("Exiting");
             // adminManager.disconnect();
             // beepingThread.stop(); // beepingThread.destroy();
             // beepingThread.setStopFlag(true);
             stopTime = System.currentTimeMillis();
             messageArea.append("\nElapsed Time: " +
                                  Float.toString((float)(stopTime-startTime)/1000) +
                                  "seconds\n");
             changeConnectDisplay(true, false);
             changeDisplay(false, false, false, false, false, false, false, true);
             usernameField.requestFocus();
             getAppletContext().showStatus("Lost Connection");
         }
      }
     if (actionLabel.equals("Clear")) {
         if (currentAction.equals("New User")) {
             changeDisplay(false, true, true, true, true, true, true, true);
             adminLastNameField.requestFocus();
         }
         if (currentAction.equals("Delete User")) {
             changeDisplay(true, true, true, false, true, false, true, true);
             adminUserIDField.requestFocus();
         }
         if (currentAction.equals("Search User")) {
             changeDisplay(true, true, true, false, true, false, true, true);
             if (prevAction.equals("Delete User")) {
                prevAction = "";
                currentAction = "Delete User";
             }
             if (prevAction.equals("Update User")) {
                prevAction = "";
                currentAction = "Update User";
             }
             if (prevAction.equals("Show Balance")) {
                prevAction = "";
                currentAction = "Show Balance";
             }
             adminUserIDField.requestFocus();
         }
         if (currentAction.equals("Show Balance")) {
             changeDisplay(true, false, false, false, false, false, true, true);
             adminUserIDField.requestFocus();
         }
         if (currentAction.equals("Update User")) {
             prevAction = currentAction;
             currentAction = "Search User";
             changeDisplay(true, true, true, true, true, true, true, true);
         }
     }
   }

    public void destroy() {
        adminManager_.disconnect();
        // beepingThread.stop(); // this.beepingThread.destroy();
    }

    /**
     *  Paint nice raized 3D background.
     *  Overrides Component.paint().
     */
    public void
    paint(Graphics pg)
    {
        pg.setColor(Color.black);
        pg.drawLine(1, 0, getBounds().width-2, 0);
        pg.drawLine(0, 1, 0, getBounds().height-2);
        pg.drawLine(1, getBounds().height-1, getBounds().width - 2, getBounds().height - 1);
        pg.drawLine(getBounds().width - 1, 1, getBounds().width - 1, getBounds().height - 2);

        pg.setColor(getBackground());
        //pg.draw3DRect(1, 1, getBounds().width - 3, getBounds().height - 3, true);
        pg.fill3DRect(1, 1, getBounds().width - 2, getBounds().height - 2, true);
    }

    /**
     *  For better looks, let Layout Manager leave some margin.
     */
	public
	Insets
	getInsets()
	{
	    return mInsets;
	}
}
