DROP INDEX saving_account_idx
/
DROP TABLE saving_account
/
DROP INDEX checking_account_idx
/
DROP TABLE checking_account
/
DROP INDEX customer_idx
/
DROP TABLE customer
/
DROP INDEX log_idx
/
DROP TABLE transaction_log
/
DROP TABLE transaction_type
/
DROP INDEX admin_idx
/
DROP TABLE admin_log
/

CREATE TABLE customer
       (userid	        VARCHAR2(10) CONSTRAINT pk_customer PRIMARY KEY
                                     CONSTRAINT upper_customer
                                     CHECK (userid = UPPER(userid)),
	lastname	VARCHAR2(20) CONSTRAINT nn_lastname NOT NULL
                                     CONSTRAINT upper_lastname
                                     CHECK (lastname = UPPER(lastname)),
	firstname	VARCHAR2(30) CONSTRAINT nn_firstname NOT NULL
                                     CONSTRAINT upper_firstname
                                     CHECK (firstname = UPPER(firstname)),
	address		VARCHAR2(80) CONSTRAINT nn_address NOT NULL
                                     CONSTRAINT upper_address
                                     CHECK (address = UPPER(address)),
        phoneno1        VARCHAR2(20) CONSTRAINT nn_phoneno1 NOT NULL,
        phoneno2        VARCHAR2(20),
        status          CHAR(1)      CONSTRAINT nn_status NOT NULL)
/
CREATE INDEX customer_idx on customer(userid, lastname, firstname)
/
CREATE TABLE saving_account
       (userid          VARCHAR2(10) CONSTRAINT nn_sid NOT NULL
                                     CONSTRAINT upper_sid
                                     CHECK (userid = UPPER(userid)),
        amount          NUMBER(12,2) CONSTRAINT nn_samount NOT NULL)
/
CREATE INDEX saving_account_idx on saving_account(userid)
/
CREATE TABLE checking_account
       (userid          VARCHAR2(10) CONSTRAINT nn_cid NOT NULL
                                     CONSTRAINT upper_cid
                                     CHECK (userid = UPPER(userid)),
        amount          NUMBER(12,2) CONSTRAINT nn_camount NOT NULL)
/
CREATE INDEX checking_account_idx on checking_account(userid)
/
CREATE TABLE transaction_type
       (type            NUMBER(2) CONSTRAINT pk_transaction_type PRIMARY KEY,
        description     VARCHAR2(80) CONSTRAINT nn_description NOT NULL)
/
CREATE TABLE transaction_log
       (transactionno   NUMBER(20) CONSTRAINT nn_transactionno NOT NULL,
        userid          VARCHAR2(10) CONSTRAINT nn_userid NOT NULL
                                     CONSTRAINT upper_userid
                                     CHECK (userid = UPPER(userid)),
        type            NUMBER(2) CONSTRAINT nn_type NOT NULL,
        amount          NUMBER(12,2),
        status          NUMBER(1),
        trdate          DATE DEFAULT SYSDATE,
        zone            VARCHAR2(5))
/
CREATE INDEX log_idx on transaction_log(userid, transactionno, trdate)
/
CREATE TABLE admin_log
       (userid          VARCHAR2(10) CONSTRAINT nn_auid NOT NULL
                                     CONSTRAINT upper_auid
                                     CHECK (userid = UPPER(userid)),
        customerid      VARCHAR2(10) CONSTRAINT nn_acuid NOT NULL
                                     CONSTRAINT upper_acuid
                                     CHECK (customerid = UPPER(customerid)),
        operation       VARCHAR2(256) CONSTRAINT nn_op NOT NULL,
        admin_date      DATE DEFAULT SYSDATE,
        zone            VARCHAR2(5))
/
CREATE INDEX admin_idx on admin_log(userid, customerid)
/
