
import org.omg.CORBA.*;
import com.sun.CORBA.iiop.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;   

import ICoordinatorDB.*;

class 
AdminDBServiceServantImpl extends ICoordinatorDB._AdminDBServiceImplBase {
    private AdminDB adb;

    public 
    AdminDBServiceServantImpl() {
        adb = new AdminDB();
    }

    public boolean 
    open(String username, String password, String time, String zone) {
        try {
            adb.open(username, password, time, zone);
            return true;
        } catch (Exception ex) {
            System.err.println("AdminDBServer.open() Exception ->" + ex);
            return false;
        }
    }

    public boolean
    addUser(String userid, String lastName, String firstName, String address, 
            String hPhone, String wPhone, String status, float checking, 
            float saving, String time, String zone) {
        try {
            return(adb.addUser(userid, lastName, firstName, address, hPhone, wPhone, 
                                status, checking, saving, time, zone));
        } catch (Exception ex) {
            System.err.println("AdminDBServer.addUser() Exception ->" + ex);
           return false;
        }
    }

    public boolean
    deleteUser(String userid, String time, String zone) {
        try {
            return(adb.deleteUser(userid, time, zone));
        } catch (Exception ex) {
            System.err.println("AdminDBServer.deleteUser() Exception ->" + ex);
            return false;
        }
    }	

    public String 
    searchUser(String userid, String lastName, String firstName, String hPhone) {
        String msg = null;
        try {
            msg = adb.searchUser(userid, lastName, firstName, hPhone);
        } catch (Exception ex) {
            System.err.println("AdminDBServer.searchUser() Exception ->" + ex);
        }
        return msg;
    }

    public String
    showBalance(String userid) {
        String msg = null;
        try {
            msg = adb.showBalance(userid);
        } catch (Exception ex) {
            System.err.println("AdminDBServer.showBalance() Exception ->" + ex);
        }
        return msg;
    }

    public boolean
    updateUser(String userid, String lastName, String firstName, String address, 
               String hPhone, String wPhone, String status, float checking, 
               float saving, String time, String zone) {
        try {
            return(adb.updateUser(userid, lastName, firstName, address, hPhone, wPhone,
                                 status, checking, saving, time, zone));
        } catch (Exception ex) {
            System.err.println("AdminDBServer.updateUser() Exception ->" + ex);
            return false;
        }
    }

    public void 
    close(String time, String zone) {
        try {
            adb.close(time, zone);
        } catch (Exception ex) {
            System.err.println("AdminDBServer.close() Exception ->" + ex);
        }
    }

/* not developed yet
    public String
    searchTransHistory(long trno, String userid, int ttype, int tstatus, String tdate) {
        String msg = null;
        try {
            msg = adb.searchTransHistory(trno, userid, ttype, tstatus, tdate);
        } catch (Exception ex) {
            System.err.println("AdminDBServer.searchTransHistory() Exception ->" + ex);
        }
        return msg;
    }

    public String
    searchAdminHistory(String userid, String op, String adate) {
        String msg = null;
        try {
            msg = adb.searchAdminHistory(userid, op, adate);
        } catch (Exception ex) {
            System.err.println("AdminDBServer.searchAdminHistory() Exception ->" + ex);
        }
        return msg;
    }
*/
}

class AdminDBIServantImpl extends ICoordinatorDB._AdminDBIImplBase {
    private int numServiceObjects = 10;
    AdminDBServiceServantImpl[] adbs = new
                              AdminDBServiceServantImpl[numServiceObjects];

    public AdminDBIServantImpl(org.omg.CORBA.ORB orb) {
        for (int i = 0 ;i < numServiceObjects; i++) {
            adbs[i] = new AdminDBServiceServantImpl();
            orb.connect(adbs[i]);
        } 
    }

    public synchronized ICoordinatorDB.AdminDBService 
    reserve(int id){
        return adbs[id];
    }

    public synchronized void 
    release(int id) {
    }
}

public class AdminDBServer {
    public static void 
    main(String[] args) {
        try {
            // create and initialize ORB
            org.omg.CORBA.ORB theOrb_ =  org.omg.CORBA.ORB.init(args, null);
            org.omg.CORBA.Object objRef =
                         theOrb_.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);
            AdminDBIServantImpl dbi = new AdminDBIServantImpl(theOrb_);
            theOrb_.connect(dbi);
            NameComponent nc = new NameComponent("AdminDBServer", "");
            NameComponent path[] = {nc};
            ncRef.rebind(path, dbi);
            System.out.println("AdminDBServer started");

            // wait for invocations from clients
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync) {
               sync.wait();
            }
        } catch (Exception ex) {
            System.err.println("AdminDBServer.main() Exception -> " + ex);
        }
    }
}

