import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.util.Properties;
import java.util.*;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import com.sun.CORBA.iiop.*;

import AdministratorICoordinator.*;

class
AdminControlPanel extends Panel {
    private Button      exitButton;
    private Button      addButton;
    private Button      deleteButton;
    private Button      updateButton;
    private Button      searchButton;
    private Button      printButton;
    private ActionListener    al;
    
    public AdminControlPanel(EventListener a) {
        al = (ActionListener)a;

        setLayout(new FlowLayout());

        addButton = makeButton("New User");
        deleteButton = makeButton("Delete User");
        updateButton = makeButton("Update User");
        searchButton = makeButton("Search User");
        printButton = makeButton("Print");
        exitButton = makeButton("Exit");
    }

    protected
    Button makeButton(String name) {
        Button button = new Button(name);
        button.addActionListener(al);
        add(button);
        return button;
    }
}

class
AdminFormPanel extends Panel {
    private Insets mInsets                 = new Insets(3,3,3,3);
    private Label       adminUserIDLabel;
    public  TextField   adminUserIDField;
    private Label       adminLastNameLabel;
    public  TextField   adminLastNameField;
    private Label       adminFirstNameLabel;
    public  TextField   adminFirstNameField;
    private Label       adminAddressLabel;
    public  TextArea    adminAddressArea;
    private Label       adminHPhoneLabel;
    public  TextField   adminHPhoneField;
    private Label       adminWPhoneLabel;
    public  TextField   adminWPhoneField;
    private Label       adminStatusLabel;
    public  TextField   adminStatusField;
    private Label       adminCheckingLabel;
    public  TextField   adminCheckingField;
    private Label       adminSavingLabel;
    public  TextField   adminSavingField;

    private ActionListener    al;

    public AdminFormPanel(EventListener a) {
        al = (ActionListener)a;

        GridBagLayout gb = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        setLayout(gb);
      
        int row = 2;
        gbc.anchor      = GridBagConstraints.EAST;
        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridwidth   = 1;
        gbc.gridheight  = 1;
        gbc.gridx       = 0;
        adminUserIDLabel = makeLabel("User ID: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminUserIDField = makeTextField("", row, 30, false, gb, gbc);

        row += 2;
        gbc.gridx       = 0;
        adminLastNameLabel = makeLabel("Last Name: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminLastNameField = makeTextField("", row, 30, false, gb, gbc);

        row += 2;
        gbc.gridx       = 0;
        adminFirstNameLabel = makeLabel("First Name: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminFirstNameField = makeTextField("", row, 30, false, gb, gbc);

        row += 2;
        gbc.gridx       = 0;
        adminAddressLabel = makeLabel("Address: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminAddressArea = makeTextArea("", row, 4, 40, gb, gbc);

        row += 2;
        gbc.gridx       = 0;
        adminHPhoneLabel = makeLabel("Home Phone: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminHPhoneField = makeTextField("", row, 30, false, gb, gbc);

        row += 2;
        gbc.gridx       = 0;
        adminWPhoneLabel = makeLabel("Work Phone: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminWPhoneField = makeTextField("", row, 30, false, gb, gbc);
        row += 2;
        gbc.gridx       = 0;
        adminStatusLabel = makeLabel("Status: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminStatusField = makeTextField("", row, 30, false, gb, gbc);

        row += 5;
        gbc.gridx       = 0;
        adminCheckingLabel = makeLabel("Checking Account: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminCheckingField = makeTextField("", row, 20, false, gb, gbc);

        row += 2;
        gbc.gridx       = 0;
        adminSavingLabel = makeLabel("Saving Account: ", row, 12, gb, gbc);

        gbc.gridx       = 1;
        adminSavingField = makeTextField("", row, 20, false, gb, gbc);
    }

    protected
    Label makeLabel(String name,
                    int row,
                    int size,
                    GridBagLayout gridbag,
                    GridBagConstraints c) {

        c.gridy = row;
        Label label = new Label(name, Label.RIGHT);
        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gridbag.setConstraints(label, c);
        add(label);

        return label;
    }

    protected
    TextField  makeTextField(String name,
                             int row,
                             int length,
                             boolean passwd,
                             GridBagLayout gridbag,
                             GridBagConstraints c) {

        c.gridy = row;
        TextField field = new TextField(length);
        if (passwd) {
            field.setEchoChar('*');
        }
        field.addActionListener(al);
        gridbag.setConstraints(field, c);
        add(field);

        return field;
    }

    protected
    TextArea makeTextArea(String name,
                          int row,
                          int h,
                          int w,
                          GridBagLayout gridbag,
                          GridBagConstraints c) {

        c.gridy = row;
        TextArea area = new TextArea(name, h, w);
        gridbag.setConstraints(area, c);
        add(area);

        return area;
    }

    public void
    setBalanceVisible(boolean f) {
        adminCheckingLabel.setVisible(f);
        adminCheckingField.setVisible(f);
        adminSavingLabel.setVisible(f);
        adminSavingField.setVisible(f);
    }

    public void
    setNonSearchVisible(boolean f) {
        adminAddressLabel.setVisible(f);
        adminAddressArea.setVisible(f);
        adminWPhoneLabel.setVisible(f);
        adminWPhoneField.setVisible(f);
        adminStatusLabel.setVisible(f);
        adminStatusField.setVisible(f);
    }

    public void
    setTextEditable(boolean f) {
        adminUserIDField.setEditable(f);
        adminLastNameField.setEditable(f);
        adminFirstNameField.setEditable(f);
        adminAddressArea.setEditable(f);
        adminHPhoneField.setEditable(f);
        adminWPhoneField.setEditable(f);
        adminStatusField.setEditable(f);
        adminCheckingField.setEditable(f);
        adminSavingField.setEditable(f);
    }

    public void
    clearAllTexts() {
        adminUserIDField.setText("");
        adminLastNameField.setText("");
        adminFirstNameField.setText("");
        adminAddressArea.setText("");
        adminHPhoneField.setText("");
        adminWPhoneField.setText("");
        adminStatusField.setText("");
        adminCheckingField.setText("");
        adminSavingField.setText("");
    }

    public void
    setAllTexts(String s1, String s2, String s3, String s4, String s5,
                String s6, String s7) {
        adminUserIDField.setText(s1);
        adminLastNameField.setText(s2);
        adminFirstNameField.setText(s3);
        adminAddressArea.setText(s4);
        adminHPhoneField.setText(s5);
        adminWPhoneField.setText(s6);
        adminStatusField.setText(s7);
    }           
}

class
AdminButtonPanel extends Panel {

    public  Button      OKButton;
    public  Button      cancelButton;
    public  Button      clearButton;
    public  Button      showButton;
    private ActionListener    al;

    public AdminButtonPanel(EventListener a) {
        al = (ActionListener)a;
        setLayout(new FlowLayout());

        OKButton = new Button("  OK  ");
        OKButton.addActionListener(al);
        add(OKButton);
        clearButton = new Button("Clear");
        clearButton.addActionListener(al);
        add(clearButton);
        cancelButton = new Button("Cancel");
        cancelButton.addActionListener(al);
        add(cancelButton);
        showButton = new Button("Show Balance");
        showButton.addActionListener(al);
        add(showButton);
    }
}

class
AdminDisplayPanel extends Panel {
    public  java.awt.List  list;
    private ItemListener   il;

    public AdminDisplayPanel(EventListener a) {
        il = (ItemListener)a;

        setLayout(new GridLayout(2, 1));
        Label label = new Label("User List", Label.CENTER);
        label.setFont(new Font("Helvetica", Font.BOLD, 16));
        add(label);
        list = new java.awt.List(5);
        list.addItemListener(il);
        add(list);
    }

    public void 
    addItem(String name) {
        list.add(name);
    }

    public void
    removeAllItems() {
        list.removeAll();
    }
}

class 
AdminMainPanel extends Panel {
    public AdminMainPanel() {
        setLayout(new BorderLayout());
    }
}

public class 
AdministratorApplet extends Applet implements ActionListener, ItemListener {
    private static AdministratorICoordinator.Administration admin_;
    private static AdministratorICoordinator.AdministrationManager adminManager_;
    private HeaderPanel           hp;
    private ConnectPanel          cp;
    private AdminControlPanel     acp;
    private AdminFormPanel        afp;
    private AdminDisplayPanel     adp;
    private MessageBoxPanel       mbp;
    private AdminButtonPanel      abp;
    private AdminMainPanel        amp;

    private ConfirmFrame          confirmFrame;

    private boolean     isConnectToICoordinator = false;

    private int         currentSelection = 0;
    private String      currentAction;
    private String      mainAction = " ";

    private String      selectedUser;
    private Hashtable   resultMap;

    private String      adminUser;
    private boolean     isShowBalance = false;
    private long        startTime;
    private long        stopTime;


    public
    void init() {
        setSize(540, 560);
        setBackground(Color.lightGray);
        arrangeDisplay();
        confirmFrame = new ConfirmFrame(this);
        confirmFrame.setVisible(false);
        resultMap = new Hashtable();
    }

    protected
    void arrangeDisplay() {
        setLayout(new BorderLayout());

        hp = new HeaderPanel(this, "NPAC Administrator");
        add(hp, "North");

        cp = new ConnectPanel(this);
        add(cp, "Center");

        mbp  = new MessageBoxPanel(this, 72, 8);
        add(mbp, "South");
        
        amp = new AdminMainPanel();
        amp.add(acp = new AdminControlPanel(this), "North");
        amp.add(afp = new AdminFormPanel(this), "Center");
        amp.add(abp = new AdminButtonPanel(this), "South");

        adp = new AdminDisplayPanel(this);
    }

    /** Initialize ORB connection **/
   
    protected
    void setORBConnectionToICoordinator() {
      Properties props = new Properties();
      props.put("org.omg.CORBA.ORBClass", "com.sun.CORBA.iiop.ORB");
      props.put("org.omg.CORBA.ORBInitialHost", "osprey6.npac.syr.edu");
      props.put("org.omg.CORBA.ORBInitialPort", "9966");

      try {
        // create and initialize the ORB
        org.omg.CORBA.ORB orb =  org.omg.CORBA.ORB.init(this, props);

        // get the root naming context
        org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
        NamingContext ncRef = NamingContextHelper.narrow(objRef);

        // resolve the Object Reference in Naming
        NameComponent nc = new NameComponent("InternalCoordinator", "");
        NameComponent path[] = {nc};
        adminManager_ = 
    AdministratorICoordinator.AdministrationManagerHelper.narrow(ncRef.resolve(path));
      }
      catch (Exception ex) {
        System.out.println("Administrator: ORB-ICoordinator Exception-> " + ex) ;
      }
    }

    protected void
    getHashedResults() {
        resultMap.clear();
        String s = admin_.searchUser(afp.adminUserIDField.getText().toUpperCase(),
                                    afp.adminLastNameField.getText().toUpperCase(),
                                    afp.adminFirstNameField.getText().toUpperCase(),
                                    afp.adminHPhoneField.getText().toUpperCase());
        StringTokenizer st = new StringTokenizer(s, "|");
        while (st.hasMoreTokens()) {
            String record = st.nextToken();
            StringTokenizer rst = new StringTokenizer(record, "+");
            String uid = rst.nextToken();
            String name = rst.nextToken();
            adp.addItem(uid + " <" + name + ">");
        }
    }

    protected void
    selectUser(String userid) {
        String s;
        if ((s = (String)resultMap.get(userid)) != null) {
            StringTokenizer st = new StringTokenizer(s, "+");
            afp.setAllTexts(st.nextToken(), st.nextToken(), st.nextToken(),
                            st.nextToken(), st.nextToken(), st.nextToken(),
                            st.nextToken());
        } else {
            s = admin_.getUserData(userid);
            StringTokenizer st = new StringTokenizer(s, "+");
            resultMap.put(st.nextToken(), s);
            afp.setAllTexts(userid, st.nextToken(), st.nextToken(),
                            st.nextToken(), st.nextToken(), st.nextToken(),
                            st.nextToken());
        }
    }
       
   public
   void actionPerformed(ActionEvent pe) {
     // User selected month from the choice
     String actionLabel = pe.getActionCommand();

     if (actionLabel.equals("Connect")) {
         mbp.messageArea.replaceRange("", 0, mbp.messageArea.getText().length());
         adminUser = "CWOU";
         String passwd = "Jessica";
/*
         adminUser = cp.connectUserField.getText().toUpperCase();
         String passwd = cp.connectPasswordField.getText();
         if (userid.length() == 0) {
             mbp.messageArea.replaceRange("Null username!  Try again!\n", 0, 
                                      mbp.messageArea.getText().length());
             return;
         }
         if (passwd.length() == 0) {
             mbp.messageArea.replaceRange("Null password!  Try again!\n", 0,
                                      mbp.messageArea.getText().length());
             return;
         }

         getAppletContext().showStatus("Connecting to Internal Coordinator");
*/        
         if (!isConnectToICoordinator) {
             setORBConnectionToICoordinator();
             isConnectToICoordinator = true;
         }
         Date connTime = new Date();
         if ((admin_ = adminManager_.connect(adminUser, passwd, 
                                             connTime.toString())) == null) {
             mbp.messageArea.replaceRange("Wrong Username/Password.", 0, 
                                      mbp.messageArea.getText().length());
             getAppletContext().showStatus("Verification failed");
             return;
         }
         mbp.messageArea.append(connTime.toString() + "\n");
         startTime = System.currentTimeMillis();
         mbp.messageArea.append("Connected to Internal Coordinator\n");

         // Change the applet display
         currentAction = "Connect";
         remove(cp);
         add(amp, "Center");
         afp.setVisible(false);
         abp.setVisible(false);
     }
     if (actionLabel.equals("New User")) {
         getAppletContext().showStatus("New User");
         currentAction = "New User";
         acp.setVisible(false);
         afp.setVisible(true);
         afp.setNonSearchVisible(true);
         afp.setBalanceVisible(true);
         afp.setTextEditable(true);
         afp.clearAllTexts();
         abp.setVisible(true);
         abp.showButton.setVisible(false);
         mbp.messageArea.append("New User\n");
     }
     if (actionLabel.equals("Delete User")) {
         getAppletContext().showStatus("Delete User");
         mainAction = "Delete User";
         currentAction = "Search User";
         acp.setVisible(false);
         afp.setVisible(true);
         afp.setTextEditable(true);
         afp.setNonSearchVisible(false);
         afp.setBalanceVisible(false);
         afp.clearAllTexts();
         abp.setVisible(true);
         abp.showButton.setVisible(false);
         mbp.messageArea.append("Delete User\n");
     }
     if (actionLabel.equals("Search User")) {
         getAppletContext().showStatus("Search User");
         mainAction = "Search User";
         currentAction = "Search User";
         acp.setVisible(false);
         afp.setVisible(true);
         afp.setTextEditable(true);
         afp.setNonSearchVisible(false);
         afp.setBalanceVisible(false);
         afp.clearAllTexts();
         abp.setVisible(true);
         abp.showButton.setVisible(false);
         mbp.messageArea.append("Search User\n");
     }
     if (actionLabel.equals("Update User")) {
         getAppletContext().showStatus("Update User");
         mainAction = "Update User";
         currentAction = "Search User";
         acp.setVisible(false);
         afp.setVisible(true);
         afp.setTextEditable(true);
         afp.setNonSearchVisible(false);
         afp.setBalanceVisible(false);
         afp.clearAllTexts();
         abp.setVisible(true);
         abp.showButton.setVisible(false);
         mbp.messageArea.append("Update User\n");
     }
     if (actionLabel.equals("Print")) {
         getAppletContext().showStatus("Printing Message Box");
         try {
             PrintWriter out = 
                 new PrintWriter(new FileWriter(adminUser + ".log"));
             out.print(mbp.messageArea.getText());
             out.close();
         } catch (Exception ex) {
             System.err.println("Client: I/O Exception -> " + ex);
         }
         getAppletContext().showStatus("Done Printing");
     }
     if (actionLabel.equals("Show Balance")) {
         if (selectedUser == null) return;
         if (currentAction.equals("Search User")) {
             getAppletContext().showStatus("Show Balance");
             currentAction = "Show Balance";
             isShowBalance = true;
             acp.setVisible(false);
             afp.setVisible(true);
             abp.setVisible(true);
             abp.OKButton.setVisible(false);
             abp.clearButton.setVisible(false);
             abp.showButton.setVisible(false);
             StringTokenizer stsb = 
                 new StringTokenizer(admin_.showBalance(selectedUser), "+");
             afp.adminCheckingField.setText(stsb.nextToken());
             afp.adminSavingField.setText(stsb.nextToken());
             afp.setBalanceVisible(true);
             mbp.messageArea.append("Show Balance\n");
         }
     }
     if (actionLabel.equals("Exit")) {
         currentAction = "Exit";
         mainAction = " ";
         afp.clearAllTexts();
         cp.connectUserField.setText("");
         cp.connectPasswordField.setText("");
         getAppletContext().showStatus("Exiting");
         Date disconnTime = new Date();
         adminManager_.disconnect(admin_, disconnTime.toString());
         stopTime = System.currentTimeMillis();
         mbp.messageArea.append("\nElapsed Time: " +
                              Float.toString((float)(stopTime-startTime)/1000) +
                              "seconds\n");
         getAppletContext().showStatus("Lost Connection");
         remove(amp);
         add(cp);
     }
     if (actionLabel.equals("  OK  ")) {
         if (currentAction.equals("Search User")) {
             afp.setTextEditable(false);
             afp.setNonSearchVisible(true);
             abp.OKButton.setVisible(true);
             abp.showButton.setVisible(true);
             abp.clearButton.setVisible(false);

             if (mainAction.equals("Delete User")) {
                 if (currentSelection == 1) {
                     getAppletContext().showStatus("Deleting " + selectedUser);
                     confirmFrame.setMessage("deleting", selectedUser);
                     confirmFrame.setVisible(true);
                 } else {
                     remove(mbp);
                     add(adp, "South");
                     getHashedResults();
                     currentSelection = 1;
                     getAppletContext().showStatus("Select a user from User List");
                 }
             } else if (mainAction.equals("Update User")) {
                 if (currentSelection == 2) {
                     getAppletContext().showStatus("Updating " + selectedUser);
                     confirmFrame.setMessage("updating", selectedUser); 
                     confirmFrame.setVisible(true);
                 } else {
                     remove(mbp);
                     add(adp, "South");
                     getHashedResults();
                     currentSelection = 2;
                     afp.setTextEditable(true);
                     afp.adminUserIDField.setEditable(false);
                 }
             } else {
                 if (currentSelection != 3) {
                     remove(mbp);
                     add(adp, "South");
                     getHashedResults();
                     currentSelection = 3;
                     abp.OKButton.setVisible(false);
                 }
                 getAppletContext().showStatus("Select a user from User List");
             }
         } else if (currentAction.equals("New User")) {
             getAppletContext().showStatus("Adding user");
             confirmFrame.setMessage("adding", afp.adminUserIDField.getText());
             confirmFrame.setVisible(true);
             getAppletContext().showStatus("Add another user");
         }
     }
     if (actionLabel.equals("Clear")) {
         afp.clearAllTexts();
     }
     if (actionLabel.equals("Cancel")) {
         if (currentAction.equals("Show Balance")) {
             abp.showButton.setVisible(true);
             if (!mainAction.equals("Search User")) {
                 abp.OKButton.setVisible(true);
                 afp.adminCheckingField.setText("");
                 afp.adminSavingField.setText("");
             }
             afp.setBalanceVisible(false);
             isShowBalance = false;
             currentAction = "Search User";
         } else {
             mainAction = " ";
             currentAction = " ";
             if (afp.isVisible()) {
                 afp.setVisible(false);
             }
             if (!mbp.isVisible()) {
                 mbp.setVisible(true);
             }
             acp.setVisible(true);
             if (isAncestorOf(adp)) {
                 adp.removeAllItems();
                 remove(adp);
             }
             if (!isAncestorOf(mbp)) {
                 add(mbp, "South");
             }
             if (!abp.clearButton.isVisible()) {
                 abp.clearButton.setVisible(true);
             }
             if (!abp.OKButton.isVisible()) {
                 abp.OKButton.setVisible(true);
             }
             abp.setVisible(false);
         }
         currentSelection = 0;
         selectedUser = null;
     }
     if (actionLabel.equals("Yes")) {
         if (mainAction.equals("Update User")) {
             confirmFrame.setVisible(false);
             getAppletContext().showStatus("Updating");
             Date timeu = new Date();
             if (!isShowBalance) {
                 StringTokenizer stu =
                     new StringTokenizer(admin_.showBalance(selectedUser), "+");
                 afp.adminCheckingField.setText(stu.nextToken());
                 afp.adminSavingField.setText(stu.nextToken());
             }
             if (admin_.updateUser(afp.adminUserIDField.getText().toUpperCase(),
                                   afp.adminLastNameField.getText().toUpperCase(),
                                   afp.adminFirstNameField.getText().toUpperCase(),
                                   afp.adminAddressArea.getText().toUpperCase(),
                                   afp.adminHPhoneField.getText().toUpperCase(),
                                   afp.adminWPhoneField.getText().toUpperCase(),
                                   afp.adminStatusField.getText().toUpperCase(),
               Float.valueOf(afp.adminCheckingField.getText()).floatValue(),
               Float.valueOf(afp.adminSavingField.getText()).floatValue(),
                                   timeu.toString())) {
                 getAppletContext().showStatus("Successfully updated");
                 mbp.messageArea.append("Update User - Done\n");
             } else {
                 getAppletContext().showStatus("Updating failed");
                 mbp.messageArea.append("Update User - Failed\n");
             }
         } else if (mainAction.equals("Delete User")) {
             confirmFrame.setVisible(false);
             getAppletContext().showStatus("Deleting");
             Date timed = new Date();
             if (admin_.deleteUser(afp.adminUserIDField.getText().toUpperCase(),
                                   timed.toString())) {
                 getAppletContext().showStatus("Successfully deleted");
                 mbp.messageArea.append("Delete User - Done\n");
             } else {
                 getAppletContext().showStatus("Deleting failed");
                 mbp.messageArea.append("Delete User - Failed\n");
             }
         } else if (mainAction.equals("New User")) {
             confirmFrame.setVisible(false);
             getAppletContext().showStatus("Adding");
             Date timea = new Date();
             if (admin_.addUser(afp.adminUserIDField.getText().toUpperCase(),
                                afp.adminLastNameField.getText().toUpperCase(),
                                afp.adminFirstNameField.getText().toUpperCase(),
                                afp.adminAddressArea.getText().toUpperCase(),
                                afp.adminHPhoneField.getText().toUpperCase(),
                                afp.adminWPhoneField.getText().toUpperCase(),
                                afp.adminStatusField.getText().toUpperCase(),
                 Float.valueOf(afp.adminCheckingField.getText()).floatValue(),
                 Float.valueOf(afp.adminSavingField.getText()).floatValue(),
                                timea.toString())) {
                 getAppletContext().showStatus("Successfully added");
                 mbp.messageArea.append("Add User - Done\n");
             } else {
                 getAppletContext().showStatus("adding failed");
                 mbp.messageArea.append("Add User - Failed\n");
             }
         }
     }
     if (actionLabel.equals("No")) {
         confirmFrame.setVisible(false);
     }
     validate();
   }

    public void 
    itemStateChanged(ItemEvent ie) {
        String actionLabel = adp.list.getSelectedItem();
        getAppletContext().showStatus("Selecting " + actionLabel);
        StringTokenizer st = new StringTokenizer(actionLabel);
        selectedUser = st.nextToken();
        selectUser(selectedUser);
        if (isShowBalance) {
             StringTokenizer stsb =
                 new StringTokenizer(admin_.showBalance(selectedUser), "+");
             afp.adminCheckingField.setText(stsb.nextToken());
             afp.adminSavingField.setText(stsb.nextToken());
        }
    }

    public void 
    destroy() {
        Date disconnTime = new Date();
        adminManager_.disconnect(admin_, disconnTime.toString());
    }

    /**
     *  Paint nice raized 3D background.
     *  Overrides Component.paint().
     */
    public void
    paint(Graphics pg)
    {
        pg.setColor(Color.black);
        pg.drawLine(1, 0, getBounds().width-2, 0);
        pg.drawLine(0, 1, 0, getBounds().height-2);
        pg.drawLine(1, getBounds().height-1, getBounds().width - 2, getBounds().height - 1);
        pg.drawLine(getBounds().width - 1, 1, getBounds().width - 1, getBounds().height - 2);

        pg.setColor(getBackground());
        //pg.draw3DRect(1, 1, getBounds().width - 3, getBounds().height - 3, true);
        pg.fill3DRect(1, 1, getBounds().width - 2, getBounds().height - 2, true);
    }
}
