import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.applet.Applet;

class ConnectPanel extends Panel {
    private Insets mInsets                 = new Insets(3,3,3,3);
    private Label       connectLabel;
    private Label       connectNameLabel;
    private Label       connectUserLabel;
    private Label       connectPasswordLabel;
    public  TextField   connectUserField;
    public  TextField   connectPasswordField;
    private Button      connectButton;
    private GridBagLayout gb = new GridBagLayout();
    private GridBagConstraints gbc = new GridBagConstraints();
    private int row = 0;
    private ActionListener al;

    public ConnectPanel (EventListener a) {
        al = (ActionListener)a;

        setBackground(Color.lightGray);
        setLayout(gb);

        gbc.anchor      = GridBagConstraints.CENTER;
        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridwidth   = GridBagConstraints.REMAINDER;
        gbc.gridx       = 0;
        gbc.gridy       = row;
        gbc.gridwidth   = 1;
        gbc.gridheight  = 1;
        connectUserLabel = makeLabel("Account: ", 12, 1);

        gbc.gridx       = 1;
        connectUserField = makeTextField("", false);

        row += 2;

        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridx       = 0;
        connectPasswordLabel = makeLabel("Password: ", 12, 1);

        gbc.fill        = GridBagConstraints.NONE;
        gbc.gridx       = 1;
        connectPasswordField = makeTextField("", true);

        row += 2;

        gbc.gridx       = 0;
        gbc.gridwidth   = GridBagConstraints.REMAINDER;
        connectButton = makeButton("Connect");

    }

    protected
    TextField  makeTextField(String name,
                             boolean passwd) {

        gbc.gridy = row;
        TextField field = new TextField(20);
        if (passwd) {
            field.setEchoChar('*');
        }
        field.addActionListener(al);
        gb.setConstraints(field, gbc);
        add(field);

        return field;
    }

    protected
    Label makeLabel(String name,
                    int size,
                    int position) {

        gbc.gridy = row;
        Label label;
        if (position == 0) {
            label = new Label(name, Label.CENTER);
        } else {
            label = new Label(name, Label.RIGHT);
        }

        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gb.setConstraints(label, gbc);
        add(label);

        return label;
    }

    protected
    Button makeButton(String name) {

        gbc.gridy = row;
        Button button = new Button(name);
        button.addActionListener(al);
        gb.setConstraints(button, gbc);
        add(button);

        return button;
    }

    public Insets
    getInsets()
    {
        return mInsets;
    }
}
