import java.io.*;
import java.net.*;
import java.awt.*;

public class Coordinator {
    private int                   numThreads;
    private static int            maxThreads = 10;
    private CoordinatorServerInfo csi;
    private CoordinatorKeyPair    ckp;

    protected Coordinator() {};

    protected void init() {
        numThreads = 0;
        csi = new CoordinatorServerInfo();
        System.out.println("Generating key pair....");
        ckp = new CoordinatorKeyPair();
        System.out.println("Ready....");
    }

    protected void run() {
        try {

            // Start the main thread to check available server status
            new CoordinatorMainThread(csi, ckp).start();

            // Start thread for Console
            new CoordinatorManagerThread(csi).start();

            // start infinite loop to wait for clients' connections
            int i = 1;
            ServerSocket s = new ServerSocket(12511, 20);
            for (;;) {
                if (numThreads < maxThreads) {
                    Socket incoming = s.accept();
                    System.out.println("Spawning Service Thread " + i);
                    incoming.setSoTimeout(600000);
                    new CoordinatorThreadSocketHandler(incoming, i, csi, ckp).start();
                    i++;
                }
            }
        } catch (Exception ex) {
            System.err.println("Coordinator Exception->" + ex);
        }
    }

    public void releaseThread() {
        numThreads--;
    }
        
    public static void main(String[] args) {
        System.out.println("Coordinator Started");
        Coordinator s = new Coordinator();
        s.init();
        s.run();
    }
}
