import java.io.*;
import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;

public class CoordinatorKeyPair {

    private PublicKey           coordinatorPublicKey;
    private PrivateKey          coordinatorPrivateKey;
    private byte[]              coordinatorEncodedPublicKey;

    public CoordinatorKeyPair() {
        try {
            // Coordinator's public/private keys generator
            // This will be replaced by reading keys from keys repository
            KeyPairGenerator coordinatorKeyGen = KeyPairGenerator.getInstance("DSA");
            coordinatorKeyGen.initialize(1024, new SecureRandom());
            KeyPair kPair = coordinatorKeyGen.generateKeyPair();
            coordinatorPublicKey = kPair.getPublic();
            coordinatorPrivateKey = kPair.getPrivate();
            coordinatorEncodedPublicKey = coordinatorPublicKey.getEncoded();
        } catch (Exception ex) {
            System.err.println("CoordinatorKeyPair Exception-> " + ex);
        }
    }

    public byte[] getEncodedPublicKey() {
        return this.coordinatorEncodedPublicKey;
    }

    public PublicKey getPublicKey() {
        return this.coordinatorPublicKey;
    }

    public PrivateKey getPrivateKey() {
        return this.coordinatorPrivateKey;
    }
}
