import java.io.*;
import java.util.*;

import ConsoleCoordinator.*;

public class 
CoordinatorManagerServantImpl extends ConsoleCoordinator._CoordinatorManagerImplBase {
    private CoordinatorServerInfo       csi;

    public CoordinatorManagerServantImpl(CoordinatorServerInfo c) {
        csi = c;
    }

    public synchronized int numServers() {
        return csi.numServers();
    }

    public String[] refresh() {
        int numKeys = csi.numServers();
        String[] returnString = new String[numKeys];
        int i = 0;
        for (Enumeration e = csi.getAllServerIDs(); e.hasMoreElements();) {
            Integer id  = (Integer)e.nextElement();
            CoordinatorServerStatus css = csi.getServerStatus(id);
            CoordinatorServer cs = csi.getServer(id);

            StringBuffer sb = new StringBuffer();
            sb.append(id.toString() + " " );
            sb.append(cs.host + " ");
            sb.append(Integer.toString(cs.port) + " ");
            sb.append(Integer.toString(css.total) + " " );
            sb.append(Integer.toString(css.available) + " ");
            if (css.status) {
                sb.append("Online");
            } else {
                sb.append("Offline");
            }
            returnString[i++] = sb.toString();
        }
        return returnString;
    }

    public synchronized boolean startup() {
        int numKeys = csi.numServers();
        boolean flag = true;
        for (Enumeration e = csi.getAllServerIDs(); e.hasMoreElements();) {
            Integer id  = (Integer)e.nextElement();
            CoordinatorServerStatus css = csi.getServerStatus(id);
            if (!css.status) {
                css.status = true;
            } else {
                flag = false;
            }
        }
        return flag;
    }

    public synchronized boolean shutdown() {
        int numKeys = csi.numServers();
        boolean flag = true;
        for (Enumeration e = csi.getAllServerIDs(); e.hasMoreElements();) {
            Integer id  = (Integer)e.nextElement();
            CoordinatorServerStatus css = csi.getServerStatus(id);
            if (css.status) {
                css.status = false;
            } else {
                flag = false;
            }
        }
        return flag;
    }

    public synchronized boolean authentication(String username, String password) {
        // username/password hashtable and file will be added later
        if (username.equals("CWOU")) {
            if (password.equals("Jessica")) {
                return true;
            }
        }
        System.out.println("Username: " + username + "/" + password);
        return false;

    }

    public synchronized boolean start(int id) {
        CoordinatorServerStatus css = csi.getServerStatus(id);
        boolean flag = true;
        if (!css.status) {
            csi.updateServerStatus(id, true);
        } else {
            flag = false;
        }
        return flag;
    }

    public synchronized boolean stop(int id) {
        CoordinatorServerStatus css = csi.getServerStatus(id);
        boolean flag = true;
        if (css.status) {
            csi.updateServerStatus(id, false);
        } else {
            flag = false;
        }
        return flag;
    }
}
