import java.io.*;
import java.net.*;

import org.omg.CORBA.*;
import com.sun.CORBA.iiop.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

public class CoordinatorManagerThread extends Thread {
    private CoordinatorServerInfo    csi;
    public static org.omg.CORBA.ORB theOrb_;

    public CoordinatorManagerThread(CoordinatorServerInfo c) {
        csi = c;
    }

    public void run() {

        String[] argv = new String[2];
        argv[0] = "-ORBInitialPort";
        argv[1] = "9966";

        try {
            theOrb_ =  org.omg.CORBA.ORB.init(argv, null);

            org.omg.CORBA.Object objRef = theOrb_.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);

            CoordinatorManagerServantImpl cmsi = new CoordinatorManagerServantImpl(csi);
            theOrb_.connect(cmsi);

            NameComponent nc = new NameComponent("Coordinator", "");
            NameComponent path[] = {nc};
            ncRef.rebind(path, cmsi);

            System.out.println("CoordinatorManagerThread Started");

            // wait for invocations from clients
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync) {
               sync.wait();
            }
        } catch (Exception ex) {
            System.err.println("CoordinatorManagerThread Exception->" + ex);
        }
    }
}
