import java.awt.*;
import java.awt.event.*;
import java.applet.*;

class
MessageBoxPanel extends Panel {
    private Insets mInsets                 = new Insets(3,3,3,3);

    private Label       messageLabel;
    public  TextArea    messageArea;
    private Applet      parent;
    private int         width;
    private int         height;

    public MessageBoxPanel(Applet a, int w, int h) {
        parent = a;
        width = w;
        height = h;

        GridBagLayout gb = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        setLayout(gb);

        int row = 2;
        gbc.anchor      = GridBagConstraints.CENTER;
        gbc.fill        = GridBagConstraints.REMAINDER;
        gbc.gridwidth   = 1;
        gbc.gridheight  = 1;
        gbc.gridx       = 0;
        messageLabel = makeLabel("Message Box", row, 16, gb, gbc);

        row += 2;

        messageArea = makeTextArea("", row, height, width, gb, gbc);
    }

    protected
    Label makeLabel(String name,
                    int row,
                    int size,
                    GridBagLayout gridbag,
                    GridBagConstraints c) {

        c.gridy = row;
        Label label = new Label(name, Label.CENTER);
        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gridbag.setConstraints(label, c);
        add(label);

        return label;
    }

    protected
    TextArea makeTextArea(String name,
                          int row,
                          int h,
                          int w,
                          GridBagLayout gridbag,
                          GridBagConstraints c) {

        c.gridy = row;
        TextArea area = new TextArea(name, h, w);
        gridbag.setConstraints(area, c);
        add(area);

        return area;
    }
}
