import java.io.*;
import java.net.*;
import java.security.*;
import javax.crypto.*;


public class ServerFailedSocketHandler extends Thread {

    private Socket                 socket;
    private ServerSecuredComm      ssc;

    public ServerFailedSocketHandler() {}
    
    public ServerFailedSocketHandler(Socket s) {
        socket = s;
    }

    public void run() {
        try {

            // initialize the socket connection and all message control objects
            int i = 0;
            if (!ssc.init()) {
                System.err.println("ServerFailedSocketHandler.run() failed");
                ssc.done();
                return;
            }

            System.err.println("Too many service threads!");
            ssc.setupMessage((int)0, "Too many connections.");
            ssc.send();
        } catch (Exception ex) {
            System.err.println("ServerFailedSocketHandler Exception-> " + ex);
        }
        ssc.done();
    }
}
