import java.io.*;
import java.util.*;

import MonitorServer.*;

public class
ServerManagerServantImpl extends MonitorServer._MonitorImplBase {
    private ServerServiceInfo            ssi;

    public ServerManagerServantImpl(ServerServiceInfo s) {
        ssi = s;
    }

    public boolean connect(String username, String password) {
        // put verification procedures
        return true;
    }

    public String[] getActiveServiceStatus() {
        StringBuffer asb = new StringBuffer();
        for (Enumeration e = ssi.getAllServiceIDs(); e.hasMoreElements();) {
            Long id  = (Long)e.nextElement();
            ServerServiceStatus sss = ssi.getServiceStatus(id);

            if (sss.status > 0) {
                StringBuffer sb = new StringBuffer();
                sb.append(id.toString() + " ");
                sb.append(sss.user + " " );
                sb.append(sss.host + " " );
                sb.append(sss.connectTime + " " );
                if (sss.transactionType > 4) {
                    sb.append("Connect ");
                } else if (sss.transactionType > 2) {
                    sb.append("Transfer ");
                } else if (sss.transactionType > 0) {
                    sb.append("Query ");
                } else {
                    sb.append("Quit ");
                }
                asb.append(sb.toString() + "+");
            }
        }
        StringTokenizer st = new StringTokenizer(asb.toString(), "+");
        String[] returnString = new String[st.countTokens()];
        int i = 0;
        while (st.hasMoreTokens()) {
            returnString[i++] = st.nextToken();
        }
        return returnString;
    }

    public String[] getIdleServiceStatus() {
        StringBuffer asb = new StringBuffer();
        for (Enumeration e = ssi.getAllServiceIDs(); e.hasMoreElements();) {
            Long id  = (Long)e.nextElement();
            ServerServiceStatus sss = ssi.getServiceStatus(id);

            if (sss.status == 0) {
                StringBuffer sb = new StringBuffer();
                sb.append(id.toString() + " ");
                sb.append(sss.user + " " );
                sb.append(sss.host + " " );
                sb.append(sss.connectTime + " " );
                if (sss.transactionType > 4) {
                    sb.append("Connect ");
                } else if (sss.transactionType > 2) {
                    sb.append("Transfer");
                } else if (sss.transactionType > 0) {
                    sb.append("Query");
                } else {
                    sb.append("Quit");
                }
                asb.append(sb.toString() + "+");
            }
        }
        StringTokenizer st = new StringTokenizer(asb.toString(), "+");
        String[] returnString = new String[st.countTokens()];
        int i = 0;
        while (st.hasMoreTokens()) {
            returnString[i++] = st.nextToken();
        }
        return returnString;
    }

    public void moveUp(int id) {
        ServerServiceStatus sss = ssi.getServiceStatus(id);
        if (sss.status == 0) ssi.updateServiceStatus(new Long(id), 1);
    }

    public void moveDown(int id) {
        ServerServiceStatus sss = ssi.getServiceStatus(id);
        ssi.updateServiceStatus(new Long(id), sss.status - 1);
    }
}
