import java.io.*;
import java.net.*;

import org.omg.CORBA.*;
import com.sun.CORBA.iiop.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

public class ServerManagerThread extends Thread {
    private ServerServiceInfo        ssi;
    public static org.omg.CORBA.ORB theOrb_;
    private String                  id;

    public ServerManagerThread(ServerServiceInfo ss, String s) {
        ssi = ss;
        id = s;
    }

    public void run() {

        String[] argv = new String[2];
        argv[0] = "-ORBInitialPort";
        argv[1] = "9966";

        try {
            theOrb_ =  org.omg.CORBA.ORB.init(argv, null);

            org.omg.CORBA.Object objRef = theOrb_.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);

            ServerManagerServantImpl smsi = new ServerManagerServantImpl(ssi);
            theOrb_.connect(smsi);

            NameComponent nc = new NameComponent("Server", "");
            NameComponent path[] = {nc};
            ncRef.rebind(path, smsi);

            System.out.println("ServerManagerThread Started");

            // wait for invocations from clients
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync) {
                sync.wait();
            }
        } catch (Exception ex) {
            System.err.println("ServerManagerThread Exception->" + ex);
        }
    }
}
