import java.io.*;
import java.util.*;
import java.net.*;

public class ServerServiceInfo {
    private Hashtable           statusH;
    private Hashtable           socketH;

    public ServerServiceInfo() {
        statusH = new Hashtable();
        socketH = new Hashtable();
    }

    public synchronized void putService(long id, String user, String host,
           String connectTime, Socket s) {
        ServerServiceStatus sss = new ServerServiceStatus();
        sss.id = id;
        sss.user = user;
        sss.host = host;
        sss.connectTime = connectTime;
        sss.transactionType = 6;
        sss.status = 1;
        statusH.put(new Long(id), sss);

        ServerSocketInfo ssi = new ServerSocketInfo(id, s);
        socketH.put(new Long(id), ssi);
    }

    public synchronized void removeService(long l) {
        Long id = new Long(l);
        statusH.remove(id);
        socketH.remove(id);
    }

    public synchronized void removeService(Long id) {
        statusH.remove(id);
        socketH.remove(id);
    }

    public synchronized int numServices() {
        return this.statusH.size();
    }

    public synchronized void updateServiceStatus(long i, int status) {
        Long id = new Long(i);
        ServerServiceStatus sss = getServiceStatus(id);
        statusH.remove(id);
        sss.status = status;
        statusH.put(id, sss);
    }

    public synchronized void updateServiceStatus(Long id, int status) {
        ServerServiceStatus sss = getServiceStatus(id);
        statusH.remove(id);
        sss.status = status;
        statusH.put(id, sss);
    }

    public synchronized void updateServiceTransaction(long l, int transactionType) {
        Long id = new Long(l);
        ServerServiceStatus sss = getServiceStatus(id);
        statusH.remove(id);
        sss.transactionType = transactionType;
        statusH.put(id, sss);
    }

    public ServerSocketInfo getSocket(long l) {
        return (ServerSocketInfo)socketH.get(new Long(l));
    }

    public ServerSocketInfo getSocket(Long id) {
        return (ServerSocketInfo)socketH.get(id);
    }

    public ServerServiceStatus getServiceStatus(long l) {
        return (ServerServiceStatus)statusH.get(new Long(l));
    }

    public ServerServiceStatus getServiceStatus(Long id) {
        return (ServerServiceStatus)statusH.get(id);
    }

    public Enumeration getAllServiceIDs() {
        return statusH.keys();
    }
}
