import java.io.*;
import java.util.*;

public class ServerServiceThread extends Thread {
    private ServerServiceInfo    ssi;
    private ThreadGroup          tg;

    public ServerServiceThread(ServerServiceInfo s, ThreadGroup t) {
        ssi = s;
        tg = t;
    }

    public void run() {
        while (true) {
            try {
                sleep(300000);
                int numThreads = tg.activeCount();
                Thread[] t = new Thread[numThreads];
                tg.enumerate(t);
                
                for (int i = 0; i < numThreads; i++) {
                    long id = Long.parseLong(t[i].getName());
                    ServerServiceStatus sss = ssi.getServiceStatus(id);
                    if (sss != null) {
                        if (sss.status < 0) {
                            ssi.getSocket(id).socket.close();
                            ssi.removeService(id);
                        }
                    }
                }
            } catch (Exception e) {
                System.err.println("ServerServiceThread Exception-> " + e);
            }
        }
    }
}
            
