import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.util.*;
import java.net.*;

public
class SocketClientApplet extends Applet implements ActionListener {
    
    private Insets              mInsets = new Insets(3,3,3,3);

    private Button              startButton;

    private Label               registerLabel;
    private Label               registerUserLabel;
    private Label               registerPasswordLabel;
    private TextField           registerUserField;
    private TextField           registerPasswordField;
    private Button              registerButton;

    private Button              queryButton;
    private Button              transferButton;

    private Button              queryCButton;
    private Button              querySButton;

    private Label               transferLabel;
    private TextField           transferField;
    private Button              transferCSButton;
    private Button              transferSCButton;
    
    private Button              disconnectButton;
    private Button              printButton;

    private Label               messageLabel;
    private TextArea            messageArea;

    private String              serverName;
    private int                 portNo;
    private long                transactionNo;
    private boolean             isConnectToCoordinator = false;

    private ClientSecuredComm   csc;

    private static float        dumb = (int)0;

    private long startTime;
    private long stopTime;

    public
    void init() {
        super.init();
        setSize(320, 350);
        createGui();
    }

    protected 
    Button makeButton(String name,
                      int row,
                      GridBagLayout gridbag,
                      GridBagConstraints c) {

        c.gridy = row;
        Button button = new Button(name);
        button.addActionListener(this);
        gridbag.setConstraints(button, c);
        add(button);

        return button;
    }

    protected 
    Label makeLabel(String name,
                    int row,
                    int size,
                    GridBagLayout gridbag,
                    GridBagConstraints c) {

        c.gridy = row;
        Label label = new Label(name, Label.CENTER);
        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gridbag.setConstraints(label, c);
        add(label);
  
        return label;
    }

    protected 
    TextField  makeTextField(String name,
                             int row,
                             boolean passwd,
                             GridBagLayout gridbag,
                             GridBagConstraints c) {

        c.gridy = row;
        TextField field = new TextField(15);
        if (passwd) {
            field.setEchoChar('*');
        }
        field.addActionListener(this);
        gridbag.setConstraints(field, c);
        add(field);

        return field;
    }

    protected 
    TextArea makeTextArea(String name,
                          int row,
                          GridBagLayout gridbag,
                          GridBagConstraints c) {

        c.gridy = row;
        TextArea area = new TextArea(name, 6, 60);
        gridbag.setConstraints(area, c);
        add(area);

        return area;
    }

    public
    void createGui() {
      setBackground(Color.lightGray);

      GridBagLayout gb = new GridBagLayout();
      GridBagConstraints gbc = new GridBagConstraints();
      setLayout(gb);

      int row = 0;

      gbc.anchor      = GridBagConstraints.NORTH;
      gbc.fill        = GridBagConstraints.BOTH;
      gbc.gridx       = 0;
      gbc.gridwidth   = 2;
      gbc.gridheight  = 2;
      gbc.weightx     = 1;
      gbc.weighty     = 1;
      registerLabel = makeLabel("NPAC Client", row, 16, gb, gbc);

      row += 10;

      gbc.anchor      = GridBagConstraints.CENTER;
      gbc.fill        = GridBagConstraints.NONE;
      gbc.gridheight  = 1;

      startButton = makeButton("Start", row, gb, gbc);

      row += 3;

      gbc.gridwidth   = 1;
      registerUserLabel = makeLabel("Account: ", row, 12, gb, gbc);
      registerUserLabel.setVisible(false);

      gbc.gridx       = 1;
      registerUserField = makeTextField("", row, false, gb, gbc);
      registerUserField.setVisible(false);

      row += 2;

      gbc.gridx       = 0;
      registerPasswordLabel = makeLabel("Password: ", row, 12, gb, gbc);
      registerPasswordLabel.setVisible(false);

      gbc.gridx       = 1;
      registerPasswordField = makeTextField("", row, true, gb, gbc);
      registerPasswordField.setVisible(false);

      row += 2;

      gbc.gridx       = 0;
      gbc.gridwidth   = 2;
      gbc.gridheight  = 2;
      registerButton = makeButton("Connect", row, gb, gbc);
      registerButton.setVisible(false);

      row += 2;

      gbc.gridwidth   = 1;
      gbc.gridheight  = 1;
      queryButton = makeButton("Query", row, gb, gbc);
      queryButton.setVisible(false);

      gbc.gridx       = 1;
      transferButton = makeButton("Transfer", row, gb, gbc);
      transferButton.setVisible(false);

      row += 5;

      gbc.gridx       = 0;
      querySButton = makeButton("Saving Account", row, gb, gbc);
      querySButton.setVisible(false);

      gbc.gridx       = 1;
      queryCButton = makeButton("Checking Account", row, gb, gbc);
      queryCButton.setVisible(false);

      row += 5;

      gbc.gridx       = 0;
      transferLabel = makeLabel("Transfer Amount: ", row, 12, gb, gbc);
      transferLabel.setVisible(false);

      gbc.gridx       = 1;
      transferField = makeTextField("0", row, false, gb, gbc);
      transferField.setVisible(false);

      row += 2;

      gbc.gridx       = 0;
      transferSCButton = makeButton("Saving ==> Checking", row, gb, gbc);
      transferSCButton.setVisible(false);

      gbc.gridx       = 1;
      transferCSButton = makeButton("Checking ==> Saving", row, gb, gbc);
      transferCSButton.setVisible(false);

      row += 5;

      gbc.gridx       = 0;
      printButton = makeButton("Print", row, gb, gbc);
      printButton.setVisible(false);

      gbc.gridx       = 1;
      disconnectButton = makeButton("Exit", row, gb, gbc);
      disconnectButton.setVisible(false);

      row += 5;

      gbc.anchor      = GridBagConstraints.SOUTH;
      gbc.fill        = GridBagConstraints.NONE;
      gbc.gridx       = 0;
      gbc.gridwidth   = 2;
      messageLabel = makeLabel("Transaction Log", row, 16, gb, gbc);

      row += 2;

      messageArea = makeTextArea("", row, gb, gbc);
      messageArea.setEditable(false);
   }

    public boolean connectToCoordinator() {
       
        try {
            // Connect to Server at osprey6.npac.syr.edu:12511
            Socket socket = new Socket("osprey6.npac.syr.edu", 12511);
            ClientSecuredComm tmpcsc = new ClientSecuredComm(socket);

            if (!tmpcsc.init()) {
                messageArea.append("Key verification failed");
                System.exit(1);
            }

            ReturnMessage rm;
            if (tmpcsc.receive()) {
                rm = (ReturnMessage)tmpcsc.getMessage();
                messageArea.replaceRange(rm.msg, 0, messageArea.getText().length());

                if (rm.type <= 1024) return false;
            } else {
                return false;
            }
            serverName = rm.msg;
            portNo = rm.type;

            if (tmpcsc.receive()) {
                rm = (ReturnMessage)tmpcsc.getMessage();
                if (rm.type == 2) {
                    transactionNo = Integer.parseInt(rm.msg);
                    messageArea.append("\nTransaction No. " + rm.msg + "\n");
                }
            } else {
                return false;
            }

            return true;
        } catch (Exception ex) {
            System.err.println("Client Exception-> " + ex);
        }
        return false;
    }

    public boolean connectToServer(String host, int port) {

        try {
            Socket socket = new Socket(host, port);
            csc = new ClientSecuredComm(socket);

            if (!csc.init()) {
                messageArea.append("Key verification failed\n");
                System.exit(1);
            }

            ReturnMessage rm;
            if (csc.receive()) {
                rm = (ReturnMessage)csc.getMessage();
                messageArea.append(rm.msg + "\n");

                if (rm.type == 0) return false;
            } else {
                return false;
            }
            return true;
        } catch (Exception ex) {
            System.err.println("Client Exception-> " + ex);
        }
        return false;
    }

   /**
    *  Handle action events from various controls
    *  Overrides Component.action().
    */
    public
    void actionPerformed(ActionEvent pe) {
        // User selected month from the choice
        String actionLabel = pe.getActionCommand();
        ReturnMessage rm;

        if (actionLabel.equals("Start")) {
            messageArea.replaceRange("", 0, messageArea.getText().length());
            if (connectToCoordinator()) {
                if (connectToServer(serverName, portNo)) {
                    startTime = System.currentTimeMillis();
                    startButton.setVisible(false);
                    registerButton.setVisible(true);
                    registerUserLabel.setVisible(true);
                    registerUserField.setText("");
                    registerUserField.requestFocus();
                    registerUserField.setVisible(true);
                    registerPasswordLabel.setVisible(true);
                    registerPasswordField.setText("");
                    registerPasswordField.setVisible(true);
                }
            } else {
                messageArea.replaceRange("No server available.", 
                                        0, messageArea.getText().length());
                getAppletContext().showStatus("No server available");
            }
        }
        if (actionLabel.equals("Connect")) {
            String userid = registerUserField.getText().toUpperCase();
            String passwd = registerPasswordField.getText();
            if (userid.length() == 0) {
                messageArea.append("Null username!  Try again!\n");
                return;
            }
            if (passwd.length() == 0) {
                messageArea.append("Null password!  Try again!\n");
                return;
            }
            getAppletContext().showStatus("Connecting to NPAC Coordinator");

            // Set user information and send it to server
            csc.setupMessage(userid, passwd, transactionNo);
            csc.send();

            // set current time information and send it to server
            Date time = new Date();
            messageArea.append(time.toString() + "\n");
            csc.setupMessage(10, time.toString());
            csc.send();

            // Receive the message from the server
            if (!csc.receive()) {
                messageArea.append("Error: returned message authentication failed.\n");
                return;
            } else {
                rm = (ReturnMessage)csc.getMessage();
                messageArea.append(rm.msg + "\n");

                if (rm.type == 1) {
                    // Change the applet display after successful 
                    // username/password authentication
                    registerButton.setVisible(false);
                    registerUserLabel.setVisible(false);
                    registerUserField.setText("");
                    registerUserField.setVisible(false);
                    registerPasswordLabel.setVisible(false);
                    registerPasswordField.setText("");
                    registerPasswordField.setVisible(false);
                    queryButton.setVisible(true);
                    transferButton.setVisible(true);
                    printButton.setVisible(true);
                    disconnectButton.setVisible(true);
                } else {
                    messageArea.append("Username/Password verification failed.\n");
                }
            }
        }
        if (actionLabel.equals("Query")) {
            getAppletContext().showStatus("Query");
            querySButton.setVisible(true);
            queryCButton.setVisible(true);
            transferLabel.setVisible(false);
            transferCSButton.setVisible(false);
            transferSCButton.setVisible(false);
            transferField.setVisible(false);
            messageArea.append("Query\n");
        }
        if (actionLabel.equals("Transfer")) {
            getAppletContext().showStatus("Transfer");
            querySButton.setVisible(false);
            queryCButton.setVisible(false);
            transferCSButton.setVisible(true);
            transferSCButton.setVisible(true);
            transferField.setVisible(true);
            transferField.requestFocus();
            transferLabel.setVisible(true);
            messageArea.append("Transfer\n");
        }
        if (actionLabel.equals("Saving Account")) {
            getAppletContext().showStatus("Querying Saving Account");
            csc.setupMessage((int)1, dumb);
            csc.send();
            if (!csc.receive()) {
                messageArea.append("Error: returned message authentication failed.\n");
            } else {
                rm = (ReturnMessage)csc.getMessage();
                if (rm.type >= 2) {
                    messageArea.append(rm.msg + "\n");
                } else {
                    messageArea.append("Wrong Message Type.\n Please try again.");
                }
            }
        }
        if (actionLabel.equals("Checking Account")) {
            getAppletContext().showStatus("Querying Checking Account");
            csc.setupMessage((int)2, dumb);
            csc.send();
            if (!csc.receive()) {
                messageArea.append("Error: returned message authentication failed.\n");
            } else {
                rm = (ReturnMessage)csc.getMessage();
                if (rm.type >= 2) {
                    messageArea.append(rm.msg + "\n");
                } else {
                    messageArea.append("Wrong Message Type.\n Please try again.");
                }
            }
        }
        if (actionLabel.equals("Checking ==> Saving")) {
            String amount = transferField.getText();
            getAppletContext().showStatus("Transfering " + amount +  
                                                    " from Checking to Saving");
            float amountValue = Float.valueOf(amount).floatValue();
            csc.setupMessage((int)3, amountValue);
            csc.send();
            if (!csc.receive()) {
                messageArea.append("Error: returned message authentication failed.\n");
            } else {
                rm = (ReturnMessage)csc.getMessage();
                if (rm.type >= 2) {
                    messageArea.append(rm.msg + "\n");
                } else {
                    messageArea.append("Wrong Message Type.\n Please try again.");
                }
            }
            transferField.setText("");
        }
        if (actionLabel.equals("Saving ==> Checking")) {
            String amount = transferField.getText();
            getAppletContext().showStatus("Transfering " + amount + 
                                                    " from Saving to Checking");
            float amountValue = Float.valueOf(amount).floatValue();
            csc.setupMessage((int)4, amountValue);
            csc.send();
            if (!csc.receive()) {
                messageArea.append("Error: returned message authentication failed.\n");
            } else {
                rm = (ReturnMessage)csc.getMessage();
                if (rm.type >= 2) {
                    messageArea.append(rm.msg + "\n");
                } else {
                    messageArea.append("Wrong Message Type.\n Please try again.");
                }
            }
            transferField.setText("");
        }
        if (actionLabel.equals("Print")) {
            getAppletContext().showStatus("Printing Trasaction Log");
            try {
                PrintWriter out = 
                    new PrintWriter(new FileWriter(Long.toString(transactionNo) + ".log"));
                out.print(messageArea.getText());
                out.close();
            } catch (Exception ex) {
                System.err.println("Client: I/O Exception -> " + ex);
            }
            getAppletContext().showStatus("Done Printing");
        }
        if (actionLabel.equals("Exit")) {
            csc.setupMessage((int)0, dumb);
            csc.send();
            csc.done();
            stopTime = System.currentTimeMillis();
            messageArea.replaceRange("\nTransaction Elapsed Time: " + 
                                  Float.toString((float)(stopTime-startTime)/1000) + 
                                  "seconds\n", 0, messageArea.getText().length());
            startButton.setVisible(true);
            registerPasswordField.setText("");
            queryButton.setVisible(false);
            transferButton.setVisible(false);
            printButton.setVisible(false);
            disconnectButton.setVisible(false);
            queryCButton.setVisible(false);
            querySButton.setVisible(false);
            transferCSButton.setVisible(false);
            transferSCButton.setVisible(false);
            transferLabel.setVisible(false);
            transferField.setVisible(false);
            transferField.setText("");
        }
        validate();
    }

    public void destroy() {
        csc.setupMessage((int)0, dumb);
        csc.send();
        csc.done();
    }

    /**
     *  Paint nice raized 3D background.
     *  Overrides Component.paint().
     */
    public void
    paint(Graphics pg)
    {
        pg.setColor(Color.black);
        pg.drawLine(1, 0, getBounds().width-2, 0);
        pg.drawLine(0, 1, 0, getBounds().height-2);
        pg.drawLine(1, getBounds().height-1, getBounds().width - 2, getBounds().height - 1);
        pg.drawLine(getBounds().width - 1, 1, getBounds().width - 1, getBounds().height - 2);

        pg.setColor(getBackground());
        //pg.draw3DRect(1, 1, getBounds().width - 3, getBounds().height - 3, true);
        pg.fill3DRect(1, 1, getBounds().width - 2, getBounds().height - 2, true);
    }

    /**
     *  For better looks, let Layout Manager leave some margin.
     */
	public
	Insets
	getInsets()
	{
	    return mInsets;
	}
}
