import java.io.*;
import java.util.Properties;
import java.util.*;
import org.omg.CORBA.*;
import com.sun.CORBA.iiop.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

public class TransactionServantImpl {
    private long                         trNo = 0;
    private boolean                      inUse;
    private String                       username;
    private String                       password;
    private String                       time;
    private String                       zone;
    private BankDB                       bdb;

    public TransactionServantImpl() {
    }

    public boolean init(String u, String p, long n, String s) {
        trNo = n;
        username = u;
        password = p;
        setTime(s);

        if (userVerification()) {
            bdb = new BankDB();
            return true;
        } 
        return false;
    }

    public boolean userVerification() {
        // put verification procedures
        return true;
    }

    protected boolean open() {
        System.out.println("DB Open: " + this.username + "/" +  this.password + "/" + this.trNo);

        if (!bdb.open(this.username, this.password, this.trNo, this.time,
                  this.zone)) {
            System.err.println("Transaction Error: DB connection failed");
            return false;
        }

        return true;
    }

    protected void close() {

        System.out.println("DB Close");
        try {
            bdb.close();
        } catch (Exception ex) {
            System.err.println("TransactionServantImpl.close() Exception-> " + ex);
        }
    }

    public void setTime(String s) {
        StringTokenizer st = new StringTokenizer(s);
        st.nextToken();
        String tmptime = st.nextToken() + " " + st.nextToken() + " " +
                 st.nextToken();
        zone = st.nextToken();
        time = tmptime + " " + st.nextToken();
    }

    public synchronized String queryCheckingAccount() {
        return bdb.queryChecking();
    }

    public synchronized String querySavingAccount() {
        return bdb.querySaving();
    }

    public synchronized
        String transferFromCheckingToSaving(float amount) {
         return bdb.transferCS(amount);
    }

    public synchronized
        String transferFromSavingToChecking(float amount) {
        return bdb.transferSC(amount);
    }
}
