import java.awt.*;
import java.util.*;
import JSci.chemistry.*;
import JSci.chemistry.periodictable.*;

/**
* Periodic Table.
* @author Mark Hale
* @version 1.1
*/
public final class PeriodicTable extends Frame {
        private GridBagLayout gb;
        private GridBagConstraints gbc;
        private Hashtable elements;
        public static void main(String argv[]) {
                new PeriodicTable();
        }
        public PeriodicTable() {
                super("Periodic Table");
                createElements();
                createTable();
                resize(600,300);
                show();
        }
        private void createElements() {
                elements=new Hashtable(110);
                elements.put("H",new Hydrogen());
                elements.put("He",new Helium());
                elements.put("Li",new Lithium());
                elements.put("Be",new Beryllium());
                elements.put("B",new Boron());
                elements.put("C",new Carbon());
                elements.put("N",new Nitrogen());
                elements.put("O",new Oxygen());
                elements.put("F",new Fluorine());
                elements.put("Ne",new Neon());
                elements.put("Na",new Sodium());
                elements.put("Mg",new Magnesium());
                elements.put("Al",new Aluminium());
                elements.put("Si",new Silicon());
                elements.put("P",new Phosphorus());
                elements.put("S",new Sulphur());
                elements.put("Cl",new Chlorine());
                elements.put("Ar",new Argon());
                elements.put("K",new Potassium());
                elements.put("Ca",new Calcium());
                elements.put("Sc",new Scandium());
                elements.put("Ti",new Titanium());
                elements.put("V",new Vanadium());
                elements.put("Cr",new Chromium());
                elements.put("Mn",new Manganese());
                elements.put("Fe",new Iron());
                elements.put("Co",new Cobalt());
                elements.put("Ni",new Nickel());
                elements.put("Cu",new Copper());
                elements.put("Zn",new Zinc());
                elements.put("Ga",new Gallium());
                elements.put("Ge",new Germanium());
                elements.put("As",new Arsenic());
                elements.put("Se",new Selenium());
                elements.put("Br",new Bromine());
                elements.put("Kr",new Krypton());
                elements.put("Rb",new Rubidium());
                elements.put("Sr",new Strontium());
                elements.put("Y",new Yttrium());
                elements.put("Zr",new Zirconium());
                elements.put("Nb",new Niobium());
                elements.put("Mo",new Molybdenum());
                elements.put("Tc",new Technetium());
                elements.put("Ru",new Ruthenium());
                elements.put("Rh",new Rhodium());
                elements.put("Pd",new Palladium());
                elements.put("Ag",new Silver());
                elements.put("Cd",new Cadmium());
                elements.put("In",new Indium());
                elements.put("Sn",new Tin());
                elements.put("Sb",new Antimony());
                elements.put("Te",new Tellurium());
                elements.put("I",new Iodine());
                elements.put("Xe",new Xenon());
                elements.put("Cs",new Caesium());
                elements.put("Ba",new Barium());
                elements.put("La",new Lanthanum());
                elements.put("Hf",new Hafnium());
                elements.put("Ta",new Tantalum());
                elements.put("W",new Tungsten());
                elements.put("Re",new Rhenium());
                elements.put("Os",new Osmium());
                elements.put("Ir",new Iridium());
                elements.put("Pt",new Platinum());
                elements.put("Au",new Gold());
                elements.put("Hg",new Mercury());
                elements.put("Tl",new Thallium());
                elements.put("Pb",new Lead());
                elements.put("Bi",new Bismuth());
                elements.put("Po",new Polonium());
                elements.put("At",new Astatine());
                elements.put("Rn",new Radon());
                elements.put("Fr",new Francium());
                elements.put("Ra",new Radium());
                elements.put("Ac",new Actinium());
                elements.put("Unq",new Unnilquadium());
                elements.put("Unp",new Unnilpentium());
                elements.put("Unh",new Unnilhexium());
                elements.put("Uns",new Unnilseptium());
                elements.put("Uno",new Unniloctium());
                elements.put("Une",new Unnilennium());
                elements.put("Unn",new Ununnilium());
                elements.put("Ce",new Cerium());
                elements.put("Pr",new Praseodymium());
                elements.put("Nd",new Neodymium());
                elements.put("Pm",new Promethium());
                elements.put("Sm",new Samarium());
                elements.put("Eu",new Europium());
                elements.put("Gd",new Gadolinium());
                elements.put("Tb",new Terbium());
                elements.put("Dy",new Dysprosium());
                elements.put("Ho",new Holmium());
                elements.put("Er",new Erbium());
                elements.put("Tm",new Thulium());
                elements.put("Yb",new Ytterbium());
                elements.put("Lu",new Lutetium());
                elements.put("Th",new Thorium());
                elements.put("Pa",new Protactinium());
                elements.put("U",new Uranium());
                elements.put("Np",new Neptunium());
                elements.put("Pu",new Plutonium());
                elements.put("Am",new Americium());
                elements.put("Cm",new Curium());
                elements.put("Bk",new Berkelium());
                elements.put("Cf",new Californium());
                elements.put("Es",new Einsteinium());
                elements.put("Fm",new Fermium());
                elements.put("Md",new Mendelevium());
                elements.put("No",new Nobelium());
                elements.put("Lr",new Lawrencium());
        }
        private void createTable() {
                gb=new GridBagLayout();
                gbc=new GridBagConstraints();
                gbc.fill=GridBagConstraints.BOTH;
                setLayout(gb);
                gbc.gridx=gbc.gridy=0;
                createButton("H");
                gbc.gridx=17;
                createButton("He");
                gbc.gridx=0;
                gbc.gridy++;
                createButton("Li");
                gbc.gridx=1;
                createButton("Be");
                gbc.gridx=12;
                createButton("B");
                gbc.gridx++;
                createButton("C");
                gbc.gridx++;
                createButton("N");
                gbc.gridx++;
                createButton("O");
                gbc.gridx++;
                createButton("F");
                gbc.gridx++;
                createButton("Ne");
                gbc.gridx=0;
                gbc.gridy++;
                createButton("Na");
                gbc.gridx=1;
                createButton("Mg");
                gbc.gridx=12;
                createButton("Al");
                gbc.gridx++;
                createButton("Si");
                gbc.gridx++;
                createButton("P");
                gbc.gridx++;
                createButton("S");
                gbc.gridx++;
                createButton("Cl");
                gbc.gridx++;
                createButton("Ar");
                gbc.gridx=0;
                gbc.gridy++;
                createButton("K");
                gbc.gridx++;
                createButton("Ca");
                gbc.gridx++;
                createButton("Sc");
                gbc.gridx++;
                createButton("Ti");
                gbc.gridx++;
                createButton("V");
                gbc.gridx++;
                createButton("Cr");
                gbc.gridx++;
                createButton("Mn");
                gbc.gridx++;
                createButton("Fe");
                gbc.gridx++;
                createButton("Co");
                gbc.gridx++;
                createButton("Ni");
                gbc.gridx++;
                createButton("Cu");
                gbc.gridx++;
                createButton("Zn");
                gbc.gridx++;
                createButton("Ga");
                gbc.gridx++;
                createButton("Ge");
                gbc.gridx++;
                createButton("As");
                gbc.gridx++;
                createButton("Se");
                gbc.gridx++;
                createButton("Br");
                gbc.gridx++;
                createButton("Kr");
                gbc.gridx=0;
                gbc.gridy++;
                createButton("Rb");
                gbc.gridx++;
                createButton("Sr");
                gbc.gridx++;
                createButton("Y");
                gbc.gridx++;
                createButton("Zr");
                gbc.gridx++;
                createButton("Nb");
                gbc.gridx++;
                createButton("Mo");
                gbc.gridx++;
                createButton("Tc");
                gbc.gridx++;
                createButton("Ru");
                gbc.gridx++;
                createButton("Rh");
                gbc.gridx++;
                createButton("Pd");
                gbc.gridx++;
                createButton("Ag");
                gbc.gridx++;
                createButton("Cd");
                gbc.gridx++;
                createButton("In");
                gbc.gridx++;
                createButton("Sn");
                gbc.gridx++;
                createButton("Sb");
                gbc.gridx++;
                createButton("Te");
                gbc.gridx++;
                createButton("I");
                gbc.gridx++;
                createButton("Xe");
                gbc.gridx=0;
                gbc.gridy++;
                createButton("Cs");
                gbc.gridx++;
                createButton("Ba");
                gbc.gridx++;
                createButton("La");
                gbc.gridx++;
                createButton("Hf");
                gbc.gridx++;
                createButton("Ta");
                gbc.gridx++;
                createButton("W");
                gbc.gridx++;
                createButton("Re");
                gbc.gridx++;
                createButton("Os");
                gbc.gridx++;
                createButton("Ir");
                gbc.gridx++;
                createButton("Pt");
                gbc.gridx++;
                createButton("Au");
                gbc.gridx++;
                createButton("Hg");
                gbc.gridx++;
                createButton("Tl");
                gbc.gridx++;
                createButton("Pb");
                gbc.gridx++;
                createButton("Bi");
                gbc.gridx++;
                createButton("Po");
                gbc.gridx++;
                createButton("At");
                gbc.gridx++;
                createButton("Rn");
                gbc.gridx=0;
                gbc.gridy++;
                createButton("Fr");
                gbc.gridx++;
                createButton("Ra");
                gbc.gridx++;
                createButton("Ac");
                gbc.gridx++;
                createButton("Unq");
                gbc.gridx++;
                createButton("Unp");
                gbc.gridx++;
                createButton("Unh");
                gbc.gridx++;
                createButton("Uns");
                gbc.gridx++;
                createButton("Uno");
                gbc.gridx++;
                createButton("Une");
                gbc.gridx++;
                createButton("Unn");
                gbc.gridx=0;
                gbc.gridy++;
                Label blankline=new Label("");
                gb.setConstraints(blankline,gbc);
                add(blankline);
                gbc.gridx=2;
                gbc.gridy++;
                createButton("Ce");
                gbc.gridx++;
                createButton("Pr");
                gbc.gridx++;
                createButton("Nd");
                gbc.gridx++;
                createButton("Pm");
                gbc.gridx++;
                createButton("Sm");
                gbc.gridx++;
                createButton("Eu");
                gbc.gridx++;
                createButton("Gd");
                gbc.gridx++;
                createButton("Tb");
                gbc.gridx++;
                createButton("Dy");
                gbc.gridx++;
                createButton("Ho");
                gbc.gridx++;
                createButton("Er");
                gbc.gridx++;
                createButton("Tm");
                gbc.gridx++;
                createButton("Yb");
                gbc.gridx++;
                createButton("Lu");
                gbc.gridx=2;
                gbc.gridy++;
                createButton("Th");
                gbc.gridx++;
                createButton("Pa");
                gbc.gridx++;
                createButton("U");
                gbc.gridx++;
                createButton("Np");
                gbc.gridx++;
                createButton("Pu");
                gbc.gridx++;
                createButton("Am");
                gbc.gridx++;
                createButton("Cm");
                gbc.gridx++;
                createButton("Bk");
                gbc.gridx++;
                createButton("Cf");
                gbc.gridx++;
                createButton("Es");
                gbc.gridx++;
                createButton("Fm");
                gbc.gridx++;
                createButton("Md");
                gbc.gridx++;
                createButton("No");
                gbc.gridx++;
                createButton("Lr");
        }
        private void createButton(String label) {
                Button but=new Button(label);
                gb.setConstraints(but,gbc);
                add(but);
        }
        public boolean handleEvent(Event evt) {
                if(evt.id==Event.WINDOW_DESTROY) {
                        dispose();
                        System.exit(0);
                        return true;
                } else
                        return super.handleEvent(evt);
        }
        public boolean action(Event evt, Object obj) {
                if(evt.target instanceof Button) {
                        new InfoDialog(this,(Element)elements.get(obj));
                        return true;
                } else
                        return super.action(evt,obj);
        }
}

class InfoDialog extends Dialog {
        private static String extractTitle(Element e) {
                String str=e.getClass().getName();
                return str.substring(str.lastIndexOf('.')+1);
        }
        private void displayNumber(double x) {
                if(x==x)
                        add(new Label(String.valueOf(x)));
                else
                        add(new Label("Unknown"));
        }
        public InfoDialog(Frame parent,Element e) {
                super(parent,extractTitle(e),false);
                setLayout(new GridLayout(11,2));
                add(new Label("Atomic Number"));
                add(new Label(String.valueOf(e.atomicNumber())));
                add(new Label("Mass Number"));
                add(new Label(String.valueOf(e.massNumber())));
                add(new Label("Density"));
                displayNumber(e.density());
                add(new Label("Boiling Point"));
                displayNumber(e.boilingPoint());
                add(new Label("Melting Point"));
                displayNumber(e.meltingPoint());
                add(new Label("Atomic Radius"));
                displayNumber(e.atomicRadius());
                add(new Label("Covalent Radius"));
                displayNumber(e.covalentRadius());
                add(new Label("Electronegativity"));
                displayNumber(e.electronegativity());
                add(new Label("Specific Heat"));
                displayNumber(e.specificHeat());
                add(new Label("Electrical Conductivity"));
                displayNumber(e.electricalConductivity());
                add(new Label("Thermal Conductivity"));
                displayNumber(e.thermalConductivity());
                resize(300,300);
                show();
        }
        public boolean handleEvent(Event evt) {
                if(evt.id==Event.WINDOW_DESTROY) {
                        dispose();
                        return true;
                } else
                        return super.handleEvent(evt);
        }
}

