
#include "JSci.hpp"
#include "JSci_maths_Complex.h"


JNIEXPORT jobject JNICALL Java_JSci_maths_Complex_polar(JNIEnv *env, jclass self, jdouble mod, jdouble arg)
{
   jmethodID midReal=env->GetMethodID(self,"real","()D");
   jmethodID midImag=env->GetMethodID(self,"imag","()D");
   jmethodID midCon=env->GetMethodID(self,"<init>","(DD)V");
   return env->NewObject(self,midCon,mod*cos(arg),mod*sin(arg));
}

JNIEXPORT jdouble JNICALL Java_JSci_maths_Complex_mod(JNIEnv *env, jobject self)
{
   jclass cls=env->GetObjectClass(self);
   jfieldID fidRe=env->GetFieldID(cls,"re","D");
   jfieldID fidIm=env->GetFieldID(cls,"im","D");
   jdouble real=env->GetDoubleField(self,fidRe);
   jdouble imag=env->GetDoubleField(self,fidIm);
   if(real==0.0 && imag==0.0)
      return 0.0;
   jdouble reAbs=fabs(real);
   jdouble imAbs=fabs(imag);
   if(reAbs<imAbs)
      return imAbs*sqrt(1.0+(real/imag)*(real/imag));
   else
      return reAbs*sqrt(1.0+(imag/real)*(imag/real));
}

JNIEXPORT jdouble JNICALL Java_JSci_maths_Complex_arg(JNIEnv *env, jobject self)
{
   jclass cls=env->GetObjectClass(self);
   jfieldID fidRe=env->GetFieldID(cls,"re","D");
   jfieldID fidIm=env->GetFieldID(cls,"im","D");
   jdouble real=env->GetDoubleField(self,fidRe);
   jdouble imag=env->GetDoubleField(self,fidIm);
   if(real==0.0 && imag==0.0)
      return 0.0;
   else if(real<0.0) {
      if(imag>=0.0)
         return atan(imag/real)+PI;
      else
         return atan(imag/real)-PI;
   } else
         return atan(imag/real);
}

