
#include "JSci.hpp"
#include "JSci_maths_DoubleVector.h"


JNIEXPORT jdouble JNICALL Java_JSci_maths_DoubleVector_norm__I(JNIEnv *env, jobject self, jint n)
{
   jclass cls=env->GetObjectClass(self);
   jfieldID vecFID=env->GetFieldID(cls,"vector","[D");
   jdoubleArray vectorj=(jdoubleArray)env->GetObjectField(self,vecFID);
   jdouble *vector=env->GetDoubleArrayElements(vectorj,0);
   jint len=env->GetArrayLength(vectorj);
   jdouble answer=pow(vector[0],n);
   for(jint i=1;i<len;i++)
      answer+=pow(vector[i],n);
   env->ReleaseDoubleArrayElements(vectorj,vector,0);
   return pow(answer,1.0/n);
}

JNIEXPORT jdouble JNICALL Java_JSci_maths_DoubleVector_norm__(JNIEnv *env, jobject self)
{
   jclass cls=env->GetObjectClass(self);
   jfieldID vecFID=env->GetFieldID(cls,"vector","[D");
   jdoubleArray vectorj=(jdoubleArray)env->GetObjectField(self,vecFID);
   jdouble *vector=env->GetDoubleArrayElements(vectorj,0);
   jint len=env->GetArrayLength(vectorj);
   jdouble answer=vector[0]*vector[0];
   for(jint i=1;i<len;i++)
      answer+=vector[i]*vector[i];
   env->ReleaseDoubleArrayElements(vectorj,vector,0);
   return sqrt(answer);
}

JNIEXPORT jdouble JNICALL Java_JSci_maths_DoubleVector_infNorm(JNIEnv *env, jobject self)
{
   jclass cls=env->GetObjectClass(self);
   jfieldID vecFID=env->GetFieldID(cls,"vector","[D");
   jdoubleArray vectorj=(jdoubleArray)env->GetObjectField(self,vecFID);
   jdouble *vector=env->GetDoubleArrayElements(vectorj,0);
   jint len=env->GetArrayLength(vectorj);
   jdouble infNorm=vector[0];
   for(jint i=1;i<len;i++) {
      if(vector[i]>infNorm)
         infNorm=vector[i];
   }
   env->ReleaseDoubleArrayElements(vectorj,vector,0);
   return infNorm;
}

