
#include "JSci.hpp"
#include "JSci_maths_FourierMath.h"


JNIEXPORT jboolean JNICALL Java_JSci_maths_FourierMath_isPowerOf2(JNIEnv *env, jclass self, jint x)
{
   jint BITS_PER_WORD=32;
   jint i,y;
   for(i=1,y=2;i<BITS_PER_WORD;i++,y<<=1) {
      if(x==y)
         return JNI_TRUE;
   }
   return JNI_FALSE;
}

JNIEXPORT jint JNICALL Java_JSci_maths_FourierMath_numberOfBitsNeeded(JNIEnv *env, jclass self, jint pwrOf2)
{
   jint i;
   if(pwrOf2<2) {
      jclass excCls=env->FindClass("java/lang/IllegalArgumentException");
      env->ThrowNew(excCls,NULL);
   }
   for(i=0;;i++) {
      if((pwrOf2&(1<<i))>0)
         return i;
   }
}

JNIEXPORT jint JNICALL Java_JSci_maths_FourierMath_reverseBits(JNIEnv *env, jclass self, jint index, jint numBits)
{
   jint i,rev;
   for(i=rev=0;i<numBits;i++) {
      rev=(rev<<1)|(index&1);
      index>>=1;
   }
   return rev;
}

