
#include "JSci.hpp"
#include "JSci_maths_SpecialMath.h"


JNIEXPORT jdouble JNICALL Java_JSci_maths_SpecialMath_chebyshev(JNIEnv *env, jclass self, jdouble x, jdoubleArray seriesj)
{
   jdouble twox,b0=0.0,b1=0.0,b2=0.0;
   twox=2.0*x;
   jsize len=(jsize)env->GetArrayLength(seriesj);
   jdouble *series=(jdouble*)env->GetDoubleArrayElements(seriesj,0);
   for(int i=len-1;i>-1;i--) {
      b2=b1;
      b1=b0;
      b0=twox*b1-b2+series[i];
   }
   env->ReleaseDoubleArrayElements(seriesj,series,0);
   return 0.5*(b0-b2);
}

