package JSci.chemistry.periodictable;

/**
* A class representing platinum.
* @version 1.5
* @author Mark Hale
*/
public final class Platinum extends TransitionMetal {
        /**
        * Constructs platinum.
        */
        public Platinum() {}
        /**
        * Returns the atomic number.
        * @return 78
        */
        public int atomicNumber() {return 78;}
        /**
        * Returns the mass number.
        * @return 195
        */
        public int massNumber() {return 195;}
        /**
        * Returns the electronegativity.
        * @return 2.28
        */
        public double electronegativity() {return 2.28;}
        /**
        * Returns the covalent radius.
        * @return 1.30
        */
        public double covalentRadius() {return 1.30;}
        /**
        * Returns the atomic radius.
        * @return 1.83
        */
        public double atomicRadius() {return 1.83;}
        /**
        * Returns the melting point.
        * @return 2045.0
        */
        public double meltingPoint() {return 2045.0;}
        /**
        * Returns the boiling point.
        * @return 4100.0
        */
        public double boilingPoint() {return 4100.0;}
        /**
        * Returns the density (293K).
        * @return 21.45
        */
        public double density() {return 21.45;}
        /**
        * Returns the specific heat.
        * @return 0.13
        */
        public double specificHeat() {return 0.13;}
        /**
        * Returns the electrical conductivity.
        * @return 0.0966e6
        */
        public double electricalConductivity() {return 0.0966e6;}
        /**
        * Returns the thermal conductivity.
        * @return 0.716
        */
        public double thermalConductivity() {return 0.716;}
        /**
        * Returns the chemical symbol.
        * @return Pt
        */
        public String toString() {
                return new String("Pt");
        }
}

