package JSci.chemistry.periodictable;

/**
* A class representing unniloctium.
* @version 1.5
* @author Mark Hale
*/
public final class Unniloctium extends TransitionMetal {
        /**
        * Constructs unniloctium.
        */
        public Unniloctium() {}
        /**
        * Returns the atomic number.
        * @return 108
        */
        public int atomicNumber() {return 108;}
        /**
        * Returns the mass number.
        * @return 265
        */
        public int massNumber() {return 265;}
        /**
        * Returns the electronegativity.
        * @return Unknown
        */
        public double electronegativity() {return Double.NaN;}
        /**
        * Returns the covalent radius.
        * @return Unknown
        */
        public double covalentRadius() {return Double.NaN;}
        /**
        * Returns the atomic radius.
        * @return Unknown
        */
        public double atomicRadius() {return Double.NaN;}
        /**
        * Returns the melting point.
        * @return Unknown
        */
        public double meltingPoint() {return Double.NaN;}
        /**
        * Returns the boiling point.
        * @return Unknown
        */
        public double boilingPoint() {return Double.NaN;}
        /**
        * Returns the density (293K).
        * @return Unknown
        */
        public double density() {return Double.NaN;}
        /**
        * Returns the specific heat.
        * @return Unknown
        */
        public double specificHeat() {return Double.NaN;}
        /**
        * Returns the electrical conductivity.
        * @return Unknown
        */
        public double electricalConductivity() {return Double.NaN;}
        /**
        * Returns the thermal conductivity.
        * @return Unknown
        */
        public double thermalConductivity() {return Double.NaN;}
        /**
        * Returns the chemical symbol.
        * @return Uno
        */
        public String toString() {
                return new String("Uno");
        }
}

