package JSci.io;

import java.io.*;
import JSci.maths.*;

/**
* Text file input stream, reads data text files.
* @version 1.0
* @author Mark Hale
*/
public final class TextFileInputStream extends FileInputStream {
        /**
        * Opens a text input file with the specified system dependent file name.
        * @param name the system dependent file name
        * @param ch the character that delimits data columns
        * @exception IOException If the file is not found.
        */
        public TextFileInputStream(String name) throws IOException {
                super(name);
        }
        /**
        * Opens a text input file with the specified File object.
        * @param file the file to be opened for reading
        * @param ch the character that delimits data columns
        * @exception IOException If the file is not found.
        */
        public TextFileInputStream(File file) throws IOException {
                super(file);
        }
        /**
        * Reads data into an array.
        * @param data an array
        */
        public void readData(double data[][]) throws IOException {
                StreamTokenizer st=new StreamTokenizer(this);
                st.quoteChar('\"');
                st.eolIsSignificant(true);
                for(int i=0;i<data.length;i++) {
                        for(int j=0;j<data[0].length;j++) {
                                while(st.nextToken()!=st.TT_NUMBER)
                                        ;
                                data[i][j]=st.nval;
                        }
                }
        }

}


