package JSci.maths;

/**
* The HilbertSpace class provides an abstract encapsulation for Hilbert spaces.
* @version 1.0
* @author Mark Hale
*/
public abstract class HilbertSpace extends VectorSpace {
        /**
        * Constructs a Hilbert space.
        */
        public HilbertSpace() {
        }
        /**
        * The scalar product law.
        * @param a a vector
        * @param b a vector
        */
        public abstract Complex scalarProduct(Object a, Object b);
}

