package JSci.maths;

/**
* This interface defines a math function.
* It will be used to pass user-defined math functions to some of
* the other maths classes, eg NumericalMath.
* @version 1.1
* @author Mark Hale
*/
public interface Mapping {
        /**
        * A user-defined math function.
        */
        double map(double x);
        /**
        * A user-defined complex math function.
        */
        Complex map(Complex z);
}

