package JSci.maths;

/**
* The Set class provides an encapsulation for sets.
* @version 1.1
* @author Mark Hale
*/
public class Set extends Object {
        /**
        * The set elements.
        */
        protected Object elements[];
        /**
        * Constructs a set.
        */
        protected Set() {
        }
        /**
        * Constructs a set.
        * @param array an array containing the set elements
        */
        public Set(Object array[]) {
                elements=new Object[array.length];
                for(int i=0;i<elements.length;i++)
                        elements[i]=array[i];
        }
        /**
        * Returns the number of elements in the set.
        */
        public final int size() {
                return elements.length;
        }
        /**
        * Returns an element from within the set.
        * @param n index of the element
        */
        public final Object getElement(int n) {
                return elements[n];
        }
        /**
        * Performs the union of this set with another.
        * @param s a set
        * @return the union of the two sets
        */
        public Set union(Set s) {
                boolean unique;
                int k;
                Object uObj[],tempObj[]=new Object[elements.length+s.size()];
                if(elements.length>s.size()) {
                        for(k=0;k<s.size();k++)
                                tempObj[k]=s.getElement(k);
                        for(int i=0;i<elements.length;i++) {
                                unique=true;
                                for(int j=0;j<s.size();j++) {
                                        if(elements[i].equals(tempObj[j]))
                                                unique=false;
                                }
                                if(unique)
                                        tempObj[k++]=elements[i];
                        }
                } else {
                        for(k=0;k<elements.length;k++)
                                tempObj[k]=elements[k];
                        for(int i=0;i<s.size();i++) {
                                unique=true;
                                for(int j=0;j<elements.length;j++) {
                                        if(s.getElement(i).equals(tempObj[j]))
                                                unique=false;
                                }
                                if(unique)
                                        tempObj[k++]=s.getElement(i);
                        }
                }
                uObj=new Object[k];
                for(k=0;k<uObj.length;k++) {
                        uObj[k]=tempObj[k];
                }
                return new Set(uObj);
        }
        /**
        * Performs the intersection of this set with another.
        * @param s a set
        * @return the intersection of the two sets
        */
        public Set intersection(Set s) {
                boolean unique;
                int k=0;
                Object tempObj[],iObj[];
                if(elements.length>s.size()) {
                        tempObj=new Object[elements.length];
                        for(int i=0;i<elements.length;i++) {
                                unique=true;
                                for(int j=0;j<s.size() && unique;j++) {
                                        if(elements[i].equals(s.getElement(j))) {
                                                tempObj[k++]=elements[i];
                                                unique=false;
                                        }
                                }
                        }
                } else {
                        tempObj=new Object[s.size()];
                        for(int i=0;i<s.size();i++) {
                                unique=true;
                                for(int j=0;j<elements.length && unique;j++) {
                                        if(s.getElement(i).equals(elements[j])) {
                                                tempObj[k++]=elements[j];
                                                unique=false;
                                        }
                                }
                        }
                }
                iObj=new Object[k];
                for(k=0;k<iObj.length;k++) {
                        iObj[k]=tempObj[k];
                }
                return new Set(iObj);
        }
}

