package JSci.maths;

/**
* The VectorSpace class provides an abstract encapsulation for vector spaces.
* @see HilbertSpace
* @version 1.1
* @author Mark Hale
*/
public abstract class VectorSpace extends Group {
        /**
        * Constructs a vector space.
        */
        public VectorSpace() {
        }
        /**
        * The scalar multiplication law.
        * @param a a scalar
        * @param v a vector
        */
        public abstract Object scalarMultiplication(Complex a, Object v);
}

