package JSci.physics.quantum;

/**
* The Projector class provides an object for encapsulating projector operators.
* @version 1.5
* @author Mark Hale
*/
public final class Projector extends Operator {
        /**
        * Constructs a projector from a ket vector.
        * @param ket a ket vector
        */
        public Projector(KetVector ket) {
                super(QuantumMath.multiply(ket,ket.toBraVector()).getRepresentation());
        }
}

