package JSci.physics.quantum;

import JSci.maths.*;

/**
* The SpinXOperator class provides an object that encapsulates the spin x operator.
* @version 1.5
* @author Mark Hale
*/
public final class SpinXOperator extends SpinOperator {
        private static final Complex pauliX[][]={
                {Complex.ZERO,Complex.ONE},
                {Complex.ONE,Complex.ZERO}
        };

        /**
        * Constructs a spin x operator.
        */
        public SpinXOperator() {
                super(pauliX);
        }
}

