package JSci.physics.quantum;

import JSci.maths.*;

/**
* The SpinYOperator class provides an object that encapsulates the spin y operator.
* @version 1.5
* @author Mark Hale
*/
public final class SpinYOperator extends SpinOperator {
        private static final Complex pauliY[][]={
                {Complex.ZERO,Complex.I},
                {Complex.MINUS_I,Complex.ZERO}
        };

        /**
        * Constructs a spin y operator.
        */
        public SpinYOperator() {
                super(pauliY);
        }
}

