package JSci.physics.quantum;

import JSci.maths.*;

/**
* The SpinZOperator class provides an object that encapsulates the spin z operator.
* @version 1.5
* @author Mark Hale
*/
public final class SpinZOperator extends SpinOperator {
        private static final Complex pauliZ[][]={
                {Complex.ONE,Complex.ZERO},
                {Complex.ZERO,Complex.MINUS_ONE}
        };

        /**
        * Constructs a spin z operator.
        */
        public SpinZOperator() {
                super(pauliZ);
        }
}

