package JSci.physics.relativity;

import JSci.maths.*;

/**
* The LorentzTensor class provides an object that encapsulates the Lorentz Tensor.
* @version 1.0
* @author Mark Hale
*/
public final class LorentzTensor extends Tensor {
        private double matrix[][];

        /**
        * Constructs a Lorentz tensor.
        * @param beta u/c
        */
        public LorentzTensor(double beta) {
                double gamma=1.0/Math.sqrt(1.0-beta*beta);
                matrix=new double[4][4];
                matrix[0][0]=matrix[1][1]=gamma;
                matrix[0][1]=matrix[1][0]=-beta*gamma;
                matrix[2][2]=matrix[3][3]=1.0;
        }
}

