/*	
	mboxtext.class 
					written by Fisayo Omojokun -- s0oaomoj@atlas.vcu.edu

	This class generates a moveable box object with a text label below it.
	It is unique in that it draws itself on the give graphics context and
	it movement can be controlled from an external class. 
*/



import java.awt.*;

public class mboxtext   {

//var declaration

	private int x,y;

	private String btext;
	private Font bf; 

	private int w = 0, h = 0;
	private Color bcolor;
	
//end vars

	
	public mboxtext(int _x,int _y, int _w,int _h, Color _c, String blabel, int FS)  {//class construct

		w = _w;			//box width
		h = _h;			//box height
		setX(_x);		
		setY(_y);
		setColor(_c);
		bf = new Font("Helvetica",Font.BOLD, FS);	//box label font
		setTexT(blabel);
	
	}//end constructor

	public void setX(int toX)  {
		x = toX;
	}//end setX

	public int getX()  {
		return x;
	}//end getX

	public void setY(int toY)  {
		y = toY;
	}//end setY

	public int getY()  {
		return y;
	}//end getY

	protected void setColor(Color toC)  {
		bcolor = toC;
	}//end setColor


	public void setTexT(String newT)   {
		btext = new String(newT); //create new string and initialize it to set value
	}//end setTexT

	public void show(Graphics offg)  {			// show's the object on the sent context
		offg.setColor(bcolor);
		offg.fill3DRect(x,y,w,h,true);			//draw box
	
		offg.setColor(Color.black);
		
		offg.drawLine(x+10,y+9,x+w-10,y+9);
		offg.drawLine(x+10,y+10,x+w-10,y+10);
		
		offg.drawLine(x+10,y+19,x+w-10,y+19);
		offg.drawLine(x+10,y+20,x+w-10,y+20);
		
		offg.drawLine(x+10,y+29,x+w-10,y+29);
		offg.drawLine(x+10,y+30,x+w-10,y+30);
		
		if (h >= 50) 
			offg.drawLine(x+10,y+40,x+w-10,y+40);
		
		offg.setFont(bf);		
		offg.drawString(btext,x-2,y+h+10);

	}//end show

}//end mboxtext
