/*	
	mserver.class 
					written by Fisayo Omojokun -- s0oaomoj@atlas.vcu.edu

	This class, similar to mboxtext, creates a server with the basic properties
	of the mboxtext class but include an option which allow the server to open and
	close.
				see mboxtext
*/


import java.awt.*;

public class mserver  {

//var declarations

	private int x,y,w,h,mmy;
	private int fsize;
	private Font sf; 
	private String btext;
	private Color bcolor;
	private boolean shi,ti;	// go ahead on open server
	private boolean motishi, motiti;  // server opened... closed?
	public boolean nowOpening, nowClosing;
	private int till = 0;
	private int untill = 0;
//end vars


	public mserver(int _x, int _y, int _w,int _h, Color _c, String blabel, int FS)  {	//constructor
	
		w = _w;
		h = _h;
		setX(_x);
		setY(_y);
		setColor(_c);
		setTexT(blabel);
		sf = new Font("Helvetica",Font.BOLD, FS);
		mmy = _y;
		shi = false;
		ti = false;
		motishi = false;
		motiti = false;
		nowOpening = false;
	
	}//end constructor

	public void setX(int toX)  {
		x = toX;
	}//end setX

	public int getX()  {
		return x;
	}//end getX

	public void setY(int toY)  {
		y = toY;
	}//end setY

	public int getY()  {
		return y;
	}//end getY

	protected void setColor(Color toC)  {
		bcolor = toC;
	}//end setColor


	public void setTexT(String newT)   {
		btext = new String(newT); //create new string and initialize it to set value
	}//end setTexT

	public void openup(int _till)  { // tell server to open
		shi = true;
		till = _till;
	}

	public void closeup(int _untill) {	//tell server to close
		ti = true;
		untill = _untill;
	}

	public boolean opendone() {			//is server done opening?
		return motishi;
	}//end opendone

	public boolean closedone() {		//is server done closing?
		return motiti;
	}//end closedone()

			   

	public void show(Graphics offg)  {
		

		offg.setColor(bcolor);
		offg.fillRect(x,y,w,h);
		offg.setColor(Color.black);
		
		offg.drawLine(x,y,x,y+h);
		offg.drawLine(x,y+h,x+w,y+h);
		offg.drawLine(x+w,y,x+w,y+h);

		offg.drawLine(x+w,y+h,x+w+20,y+h-20);
		offg.drawLine(x+20,y-20,x+w+20,y-20);
		offg.drawLine(x+w+20,y-20,x+w+20,y+h-20);
		offg.fillRect( x+15, y+20, w-20,(h>=100)?10:5 );
		offg.fillRect( x+15, y+40, w-20,(h>=100)?10:5 );
		offg.fillRect( x+15, y+60, w-20,(h>=100)?10:5 );
		offg.fillRect( x+15, y+80, w-20,(h>=100)?10:5 );
		offg.fillRect(x+30,y+100,5,(h>=100)?60:40 );
		offg.fillRect(x+50,y+100,5,(h>=100)?60:40 );
		offg.fillRect(x+70,y+100,5,(h>=100)?60:40 );
		
		offg.setFont(sf);
		offg.drawString(btext,x+10,y+h+20);

		offg.drawLine(x+w,y,x+w+20,y-20);  //right hatch
		offg.drawLine(x,y,x+20,y-20);		//left right hatch
		offg.drawLine(x,y,x+w,y);  // front hatch
		
		if (shi == true)   {
			nowOpening = true;
			offg.drawLine(x+20,y-20,x,mmy);
			offg.drawLine(x+w+20,y-20, x+w,mmy);
			offg.drawLine(x,mmy,x+w,mmy);
			if (mmy >= till)
				mmy-=2;
			else{
				motishi = true;
			}//end else
		}//end if
		
		if (ti == true)    {
			nowClosing = true;

			shi = false;		// must set shi to false so we can close
			offg.drawLine(x+20,y-20,x,mmy);
			offg.drawLine(x+w+20,y-20, x+w,mmy);
			offg.drawLine(x,mmy,x+w,mmy);
			if (mmy < untill)
				mmy+=2;
			else{
				motiti = true;
			}//end else
		}//end if


	}//end show

}//end mserver

