
/*	

  mydriver.class -- designed and written by Fisayo Omojokun s0oaomoj@atlas.vcu.edu

  This class is the "main driver" of the applet.  It is what runs and controls the 
  properties of the applet.

  This applets purpose is to use the concepts of algorithm animation and software simulation
  to simulation the concept of CGI and HTML forms.  When the applet is executed the user
  is shown a series of animations which explains this concept in a visual manner

*/


import java.awt.*;
import java.applet.Applet;
import java.net.*;

public class mydriver2 extends Applet implements Runnable {

//vars declaration
	
	private Panel dpanel;			//button panel
	private Canvas dcanvas;			//animation canvas
	
	mframe explain = new mframe();	//frame showing explanation
	
	private Thread animate;		//animation thread
	
	private boolean suspended=false; //thread suspension
	private mboxtext hform;			 // html form icon
	private mserver webserver;		 // server icon
	private mboxtext fr;			 // server html response icon
	Font Pf = new Font("Helvetica",Font.BOLD,10);  //panel and button fonts
	private Button GoButt,PButt,RButt;	//panel buttons

	public Graphics offgr;				//offscreen graphics context used for double buffering
	private Image offimg;				//offscreen image

	private int sleeps,cgsleep;			//thread sleeps
	
											
	private int imgw=800, imgh=500;		//canvas width and length

	private boolean GoAni = false, formmove = false;    //begin animation and begin first icons movement

	private int formw = 50,formh = 40, formx = 100, formy = 200, endformx = 310;  //htmlform dimensions
																				  // and end position

	private int servw = 90,servh = 180, //server dimensions
		
		// must set the following when setting servh

							midserver = 150,  //middle of server (200)

		servx = 400, servy = 150, openy = 94;		//server starting positions and hatch open y
		boolean openses = false, closeses = false;

		
	// gif  animation vars
	private int ccnt;
	private Image cgif[];
	private int totalImages = 4, current = 0;
	private	int cgx= 690 ,cgy=200;

	
	private Image cligif[];
	private int clx = 30 , cly= 230;

	private Image arrow;
	URL location;

	// gif animation vars end

	//http link variables

	Site voteballot, cgiprog, respballot;


	private boolean done1 = false;  // shown 1st Read me
	private boolean insertform = false, formIn = false;

	private mstring param, resp;
	private boolean sendparam = false, paramsent = false, reachcgi = false, reachserv = false, 
		respsent = false, sendresp = false;
	private int pary,parx,respy,respx;

	private boolean frsent = false, sendfr = false,
					reachcli = false;   //form sent? and sent form? and reached client?
	private int frw = 50, frh = 40, frx, fry, endfrx;
	private boolean showfr = false;

	private int ttlx = 490, ttly = 25;  //applet title positions
	private int ptdx = ttlx;			//titles moving dot position

	private boolean newgo = false;		//used to change begin animation to goto real form example

	private MediaTracker iT1,iT2;		//imagetracking devices insuring smooth loading

	private String mTitle;


	public void init() {
		
		

		iT1 = new MediaTracker(this);		//client icon's
		iT2 = new MediaTracker(this);		//cgi prog. icons

		cgif = new Image[totalImages];
		cligif = new Image[totalImages];


		for (ccnt = 1; ccnt <= cgif.length; ccnt++) {		//load all gif frames
			cligif[ccnt-1] = getImage(getDocumentBase(), "cligif" + ccnt + ".gif");
			cgif[ccnt-1] = getImage(getDocumentBase(), "cgif" + ccnt + ".gif");
			iT1.addImage(cligif[ccnt-1],ccnt-1);
			iT2.addImage(cgif[ccnt-1],ccnt-1);		

				
			try {iT1.waitForID(0);}
			catch (InterruptedException e) {}
		
			try {iT2.waitForID(0);}
			catch (InterruptedException e) {}
		}//end for



		arrow = getImage(getDocumentBase(), "arrow.gif");  //gif arrow pointing to cgi program

		dcanvas = new Canvas();
		dcanvas.resize(imgw,imgh);
		dpanel = new Panel();


		sleeps = 65;
		cgsleep = 55;
		
		offimg=createImage(imgw,imgh);
		offgr = offimg.getGraphics();

		
		frx = servx;    fry = servy + 110;   endfrx = (160 + clx);    //server response dimensions
//create animating objects
		hform = new mboxtext(formx,formy,formw,formh,Color.red,"HTML form", 12);
		webserver = new mserver(servx,servy,servw,servh,Color.lightGray,"SERVER",16);
		param = new mstring(servx+servw+5, cgy+10, Color.red, "PARAMETERS", 17);
		resp = new mstring(cgx,cgy+90,Color.black, "RESPONSE",17);
		fr = new mboxtext(frx,fry,frw,frh,Color.gray,"HTML page",12);
		
		

		
		
		dpanel.setFont(Pf);
		
		GoButt = new Button("Begin (submit form)");				//set up panel buttons
		GoButt.setFont(Pf);
		
		PButt = new Button("Pause Animation");
		PButt.setFont(Pf);
		
		RButt = new Button("Resume Animation");
		RButt.setFont(Pf);

		GoButt.setBackground(Color.gray);
		PButt.setBackground(Color.gray);
		RButt.setBackground(Color.gray);

		setLayout(new BorderLayout() );		//set layout to border layout

		add("Center",dcanvas);
		
		dpanel.setBackground(Color.black);
		
		add("South", dpanel);				//setup panel buttons
		
		dpanel.add(GoButt);	
		dpanel.add(PButt);
		dpanel.add(RButt);
		
		mTitle = new String("CGI animation -- by Fisayo Omojokun");
	
	
	}//end init

	public void start() {					//animation thread start
		
		if (animate == null) {
			animate = new Thread(this);
			animate.start();
		}
		explain.start();
	}//end start


	public void stop()  {					//animation thread stop
		explain.endframe();
		explain.stop();
		if (animate != null)  {
			animate.stop();
			animate = null;
		}
		
	}//end stop

	
	public void run()  {					//animation-application thread run
		
		while (true) {
			
			OpenSesame();
			EnterServer();
			CloseSesame();
			PassParam();
			SendResp();
			FormResp();
			repaint();

			try {animate.sleep(cgsleep);}
			catch (InterruptedException e) {};
	
			if (GoAni == true) {
				formmove = true;
		
				formx = hform.getX();	

				for ( formx = formx; formx <= endformx; formx+=3)  {			//move html form
					hform.setX(formx);
					repaint();
			
					try {animate.sleep(sleeps);}
					catch (InterruptedException e) {};
				}//end for
				GoAni = false;
				formmove = false;
			}// if GoAni == true

// moving param to cgi

			
			if (sendparam == true)  {					//begin sending to cgi
				parx = param.getX();

				for (parx = parx; parx <= cgx - 10; parx+=2)   {
					param.setX(parx);
					repaint();

					try {animate.sleep(sleeps + 10);}
					catch (InterruptedException e) {};
				}//end for

				sendparam = false;   // don't come back to this if
				reachcgi = true;	 // we have reached cgi so next event may occur
			}//end if


			if (sendresp == true) {						//begin sending to server
				
				respx = resp.getX();

				for (respx = respx; respx >= servx; respx-=3)  {
					resp.setX(respx);
					repaint();

					try {animate.sleep(sleeps);}
					catch (InterruptedException e) {};
				}//end for

				sendresp = false;
				reachserv = true;
			}//end if


			if (sendfr == true) {					//begin sending to client
				showfr = true;
				frx = fr.getX();

				for (frx = frx; frx >= endfrx; frx-=3) {
				
					fr.setX(frx); 
					repaint();

					try {animate.sleep(sleeps); }
					catch (InterruptedException e) {};
				}//end for
				sendfr = false;
				reachcli = true;
				explain.changeText();
			GoButt.setLabel("Try your own ballot ");	//change buttons 
			PButt.hide();
			RButt.hide();
			
			newgo = true;

			}//end if

			if (insertform == true) {			//begin inserting form into server

				formmove = true;				
				
				formy = hform.getY();

				for (formy = formy; formy >= openy; formy-=3) {
					
				 	hform.setY(formy);
					repaint();

					try {animate.sleep(sleeps);}
					catch (InterruptedException e) {};
				}//end for

				formx = hform.getX();

				int overserver = webserver.getX() + 25;
				
				for ( formx = formx; formx <= overserver ; formx+=3 )  {	//move html form overserver
			
					hform.setX(formx);
					repaint();
				
					try {animate.sleep(sleeps);}
					catch (InterruptedException e) {};

				}//end for


				for (formy = formy; formy <= midserver ; formy+=2) {			// push down in server
				
					hform.setY(formy);
					

					repaint();
					
					try {animate.sleep(sleeps);}
					catch (InterruptedException e) {};
					
				}//end for
				
				insertform = false;
				formIn = true;
				formmove = false;

			}// if insertform

		}//end while

	}//end run


		
	public void paint(Graphics g)  {
	
	  g.clipRect(0,0,800,500);


	  if ( (iT1.checkID(current,true)) && (iT2.checkID(current,true)) )  {
        //must clear offscreen with background here
		offgr.setColor(Color.white);
		offgr.fillRect(0,0,imgw,imgh);
		offgr.setColor(Color.black);
		offgr.drawRect(0,0,imgw-1,imgh-1);

		// draw each objects

		Font ttlf = new Font("Helvetica",Font.BOLD,15);
		

		offgr.setColor(Color.black);
		offgr.setFont(ttlf);
		offgr.drawString(mTitle,ttlx,ttly);
		
		offgr.setColor(Color.red);
		
		if (ptdx < (0+imgw - 40) )				//set moving dot position
			ptdx+=5; 
		else
			ptdx = ttlx; 

		offgr.drawOval(ptdx,ttly+5,15,1);		//moving dot

		if (sendparam == true)
			param.show(offgr);


		if (sendresp == true) 
			resp.show(offgr);

		offgr.drawImage(cligif[current],clx,cly,this);
		offgr.drawImage(cgif[current],cgx,cgy,this);
		current = (++current) % totalImages;

		if ((sendfr == true) || (showfr == true))
			fr.show(offgr);

		hform.show(offgr);
		webserver.show(offgr);


	
		offgr.drawString("PROGRAM",cgx + 12,cgy+cgif[0].getHeight(this) + 5);

		if ( (webserver.closedone() == true) && (sendparam == true) ) {
			offgr.drawImage(arrow,cgx-90,(cgy - (arrow.getHeight(this)) + 15),this);
			
		}//end if


    	g.drawImage(offimg,0,0,this);
	  }//end if
	  else postEvent(new Event(this, Event.MOUSE_ENTER, "") );



	}//end paint


	public void update(Graphics g)  {
		g = dcanvas.getGraphics();
		paint(g);

	}//end update

	
	public  boolean action( Event b, Object o)  {
						
		if (b.target instanceof Button)  {
			if ((b.target == GoButt) && (GoAni == false) )  {		// begin animation button pressed
				if (done1 == false) {
					explain.changeText();
					
					done1 = true;
				}//end if  
				
				GoAni = true;		
				
			}//end if go

		if ((b.target == GoButt) && (newgo == true)) {		//goto real voting ballot
				animate.stop();
				explain.endframe();
				showStatus("Going to ballot.html");
			    Site voteballot2 = new Site ("Online Voting- created by Fisayo Omojokun", 
					"http://osprey7.npac.syr.edu:3768/reu97-docs/ce97oom/ballot.html");
				location = voteballot2.getLocation();
				gotoSite(location);
			}

			else if ( (b.target == PButt) && (suspended == false) ) {   // Pause button pressed
				showStatus("Applet paused!");

				animate.suspend();

				suspended = true;
			}//end elseif  suspend

			else if ( (b.target == RButt) && (suspended) ) {	//Resume button pressed
				showStatus("Resuming applet");
				
				animate.resume();
				explain.putFront();
				
				suspended = false;
			}//end  elseif resume
	
		
		}//end if}

	return true;
	}//end action

	public void gotoSite(URL loc)  {
		getAppletContext().showDocument(loc);		//this must be executed in brower
	}//end gotosite

	public boolean OpenSesame() {			//handles time to open server
		
		if ((formx  >= endformx) && ((webserver.opendone()) == false) && 
			(webserver.nowOpening == false) && (openses == false) )  {
			
			explain.changeText();
			webserver.openup(openy);
			openses = true;  //locks ifstatment to occur true only once
		}//end if
		return true;
	}//end OpenSesame

	public boolean EnterServer() {		 //handles time to enter server
		
		if ( ((webserver.opendone()) == true) && (GoAni == false)  &&
			(formIn == false) ) {   // server opened and form stopped in		
			insertform = true;										   // front of server
		}//end if
		return true;
	}//end Enter Server

	public boolean CloseSesame() {		//handle time to close server
		
		if ((formIn == true) && ((webserver.closedone()) == false) && 
			(webserver.nowClosing == false) && (closeses == false) )   {		//begin closing server

			webserver.closeup(servy);
			closeses = true;    //locks ifstatment to occur true only once
		}//end if
		return true;
	}//end CloseSesame


	public boolean PassParam() {							//graphically send params to cgi prog
		if ( ( (webserver.closedone()) == true) && (paramsent == false) )  {
			showStatus("Click on CGI program icon to view an example.");
			explain.changeText();		// change read me
	
			sendparam = true;
			paramsent = true;   //locks ifstatment to occur true only once
	
			//send parameter  string
		}//end if
		return true;
	}//end passparam

	

	public boolean SendResp() {									//graphically send response to server

		if ((reachcgi == true) && (respsent == false) ) {

			explain.changeText();		// change read me
			sendresp = true;
			respsent = true;    //locks ifstatment to occur true only once
		}//end if
		return true;
	}//end sendresp

	public boolean FormResp()  {									//  send form response to client
		if ( (reachserv == true) && (frsent == false) ) {
			explain.changeText();
			sendfr = true;
			frsent = true;    //locks ifstatment to occur true only once
		}//end if
		return true;
	}//end formresp

	

	public boolean mouseUp(Event e, int clickx, int clicky)  {

		if ( (clickx >=formx) && (clickx <= (formx+formw) ) )	{
			//HTML form has been clicked on
			if ( ( clicky >= formy) && (clicky <= (formy + formh) ) ) {   //goto already filled example

				showStatus("You have clicked the HTML form. . . going to ballot.html");
			    voteballot = new Site ("Online Voting- created by Fisayo Omojokun", 
					"http://osprey7.npac.syr.edu:3768/reu97-docs/ce97oom/aballot.html");
				location = voteballot.getLocation();
				gotoSite(location);

			}//end if
		}//end if

		else if ( (clickx >= cgx) && (clickx <= (cgx + cgif[1].getWidth(this)) ) ) {  
			if ( ( clicky >= cgy) && (clicky <= cgy + cgif[1].getHeight(this) ) ) { //goto cgi perl prog
				showStatus("You have clicked the CGI program icon . . . going to program");
				cgiprog = new Site ("ballot.pl - created by Fisayo Omojokun", 
					"http://osprey7.npac.syr.edu:3768/reu97-docs/ce97oom/aballot.pl");
				location = cgiprog.getLocation();
				gotoSite(location);
			}//end if
		}//end else if

		else if ( (showfr == true) && (clickx >= frx) && (clickx <= (frx+frw)) ) {
			if ( (clicky >= fry) && (clicky <= (fry+frh)) )  {	//goto already set response
				showStatus("You have clicked the HTML response. . . going to response.html");
			    respballot = new Site ("HTML response generated by CGI program", 
					"http://osprey7.npac.syr.edu:3768/reu97-docs/ce97oom/response.html");
				location = respballot.getLocation();
				gotoSite(location);
			}//end if
		}//end else if

		return true;		//event handled
	}//end mouseUp

		
}//end mydriver