#! /usr/npac/bin/perl -w

#############################################################################
#  
#   File:        fill-out-form.pl
#
#   Input:       fill-out-form0.html
#                (variables address, phone, topping)
#
#   Output:      CGI.pm version of pizza order form
#
#   Description: Creates a pizza order from the information obtained from
#                the pizza order form.
#
#
#############################################################################
#  
#   Initialization
#
#############################################################################

$HTMLFILE = 'fill-out-form0.html';  # HTML doc with form
$HOSTPATH = 'http://www.npac.syr.edu/projects/tutorials/CGI/examples/basic-cgi';

#############################################################################
#  
#   Modules
#
#############################################################################

use CGI qw(:standard);

#############################################################################
#  
#   Main Routines
#
#############################################################################

ReadEntry() &&
PrintResult();

##############################################################################
#
#  Input
#
##############################################################################

sub ReadEntry {
  $ADDRESS = param('address');
  $PHONE = param('phone');
  $TOPPING = param('topping');
  return 1;
}

#############################################################################
#  
#   Output
#
#############################################################################

sub PrintResult {
  
  # Print MIME header:
  print header(-type=>'text/html');
  
  # Print first few lines of the HTML document:
  print start_html(
          -title=>'CGI Example:  Pizza',
          -BGCOLOR=>'#ffffff'
        ), "\n";
  
  # Print some headings:
  print h1( 'Pizza Order' ), "\n";
  print h3( "$TOPPING pizza" ), "\n";
  
  # Print some paragraphs:
  print p( "Deliver to: <B>$ADDRESS</B>" ), "\n";
  print p( "Telephone: <B>$PHONE</B>" ), "\n";
  $date = `date`; chomp($date);
  print p( "Order came in at $date" ), "\n";
  
  # Print a horizontal rule:
  print hr();
  
  # Print a link:
  print 'Return to ';
  print a({HREF=>"$HOSTPATH/$HTMLFILE"},
          'HTML form'
        ), "\n";
  
  # Print last few lines of HTML document:
  print end_html(), "\n";

}
