#! /usr/local/bin/perl -w

#############################################################################
#  
#   File:        fill-out-form.pl
#
#   Input:       fill-out-form0.html
#                (variables address, phone, topping)
#
#   Output:      HTML version of pizza order
#
#   Description: Creates a pizza order from the information obtained from
#                the pizza order form.
#
#
#############################################################################
#  
#   Initialization
#
#############################################################################

$EOL = "\015\012";
$HTMLFILE = 'fill-out-form0.html';  # HTML doc with form
$HOSTPATH = 'http://www.npac.syr.edu/projects/tutorials/CGI/examples/basic';

#############################################################################
#  
#   Library Routines
#
#############################################################################

require "ReadParse.pl" || die "error loading ReadParse.pl\n";

#############################################################################
#  
#   Main Routines
#
#############################################################################

ReadEntry() &&
PrintResult();

##############################################################################
#
#  Input
#
##############################################################################

sub ReadEntry {
  my (%in);
  # ReadParse returns an associative array of key-value pairs:
  %in = ReadParse();
  $ADDRESS = $in{'address'};
  $PHONE = $in{'phone'};
  $TOPPING = $in{'topping'};
  return 1;
}

#############################################################################
#  
#   Output
#
#############################################################################

sub println {
  print "@_$EOL";
}

sub PrintResult {
  println 'Content-type: text/html';
  println '';
  
  println '<HTML>';
  println '<HEAD>';
  println '<TITLE>CGI Example:  Pizza</TITLE>';
  println '</HEAD>';
  println '<BODY BGCOLOR="#ffffff">';
  println '<H1>Pizza Order</H1>';

  println "<H3>$TOPPING pizza</H3>";

  println "Deliver to <B>$ADDRESS</B> <P>";
  println "Telephone: <B>$PHONE</B> <P>";
  
  $date = `date`; chomp($date);
  println "Order came in at $date";
  
  println '<P><HR><P>Return to';
  println qq{<A HREF="$HOSTPATH/$HTMLFILE">HTML form</A>};
  
  println '</BODY>';
  println '</HTML>';
  return 1;
}

