#!/usr/npac/bin/perl -w
#
# File:  feedback.pl

use strict;
# Import a standard set of methods from CGI.pm (see
# page 187 of the Llama book for details):
use CGI qw(:standard);

# Default title of the generated web page:
my $title = 'Course Feedback Form';

# An alternate title may be specified in the URL:
$title = param('title') if defined(param('title'));

# It would be nice to allow the user to specify these as well,
# but we need to consider the security implications first:
my $mailto = 'trscavo@npac.syr.edu (Tom Scavo)';
my $archive = 'archives/feedback.txt';

# Print header (the MIME type 'text/html' is understood by 
# default, but is given here for clarity):
print header(-type=>'text/html');

# Print first few lines of the HTML document:
print start_html(
        -title=>"$title",
        -author=>'trscavo@npac.syr.edu',
        -BGCOLOR=>'white'
      ), "\n";            # all newlines are for visual formatting only

# Print a heading:
print h1("$title"), "\n";

# Print <FORM> tag (whose ACTION is the current script, by default):
print start_form(
        -method=>'POST',
        -action=>'http://osprey7.npac.syr.edu:3768/users-cgi/trscavo/prod/mailform',
      );
      
# Print various hidden fields used by the mailform script:
print hidden(
        -name=>'_mailTo',
        -default=>"$mailto"
      ), "\n";
print hidden(
        -name=>'_mailSubject',
        -default=>"$title"
      ), "\n";
print hidden(
        -name=>'_mailArchive',
        -default=>"$archive"
      ), "\n";
      
# Print a textarea for user comments:
print "Type your comments or suggestions below:\n";
print p( textarea(
           -name=>'Comments',
           -rows=>10, 
           -columns=>60
         )
      ), "\n";
      
# Print a textfield for the user's e-mail address (optional):
print "If you would like a personal reply,\n";
print "please type in your e-mail address:\n";
print p( textfield(
           -name=>'_mailFrom',
           -size=>50
         )
      ), "\n";
      
# Print submit and reset buttons:
print p( submit('Send'), 
         reset('Clear') 
      ), "\n";

# Print </FORM>:
print end_form(), "\n";

# Print last few lines of HTML document:
print end_html(), "\n";
