/* 
 *      Copyright (c) 1997-98 
 *      NorthEast Parallel Architectures Center, Syracuse University. 
 * All Rights Reserved. Permission to use, copy, modify, and distribute this
 * software and its documentation for educational, research and non-profit
 * purposes, without fee, and without a written agreement is hereby granted,
 * provided that the above copyright notice and this paragraph appear in all
 * copies. Permission to incorporate this software into commercial products may
 * be obtained by contacting the NorthEast Parallel Architectures Center. 
 *
 * The software program and documentation are supplied "as is",
 * without any accompanying services from NPAC. NPAC does not
 * warrant that the operation of the program will be uninterrupted or
 * error-free. The end-user understands that the program was developed for
 * research purposes and is advised not to rely exclusively on the program for
 * any reason.
 *
 */

package cis600.util;

/**
 * InvalidOperationException is an exception that is thrown 
 * when a container is asked to perform an inappropriate operation.
 *
 *@author Shrideep Pallickara
 *@version 1.0
      *
 */

public class InvalidOperationException extends org.omg.CORBA.UserException {

  public String message="UN-KNOWN";

  /**
   * Constructs a InvalidOperationException with no detail message.
   * A detail message is a String that describes this particular exception.
   */
  public InvalidOperationException()
  {
  }
  
  /**
   * Constructs a InvalidOperationException with the specified detail message.
   * A detail message is a String that describes this particular exception.
   * @param message The detail message.
   */
  public InvalidOperationException( String _message ) {
    super();
    message = _message;
  }

  public String
  toString() {
    return message;
  }
}




