/*
 * Test Java Program
 */

import java.applet.*;
import java.awt.*;

public class Test extends Applet implements Runnable {
    int maxObj = 3;     /* max object number */
    mPoint object[];    /* objecct array */
    Thread thread;
    public void init() {
      /* initial object array */
      object = new mPoint[maxObj];
      /* initial a rectangle */
      object[0] = new mRectangle(10, 10, 100, 100);
      object[0].setDelta(1, 1);
      object[0].setColor(Color.red);
      /* initial a circle */
      object[1] = new mCircle(200, 10, 100, 100);
      object[1].setDelta(-1, 1);
      object[1].setColor(Color.blue);
      /* initial a triangle */
      object[2] = new mTriangle(10, 200, 100, 100);
      object[2].setDelta(-1, 1);
      object[2].setColor(Color.green);
    }
    /* start a new thread */
    public void start() {
        if (thread == null) {
          thread = new Thread(this);
          thread.start();
        }
    }
    /* stop the thread */
    public void stop() {
        if (thread != null) {
          thread.stop();
          thread = null;
        }
    }
    /* keep moving and redraw the objects */
    public void run() {
        while (thread != null) {
          try thread.sleep(20);
          catch (InterruptedException e);
          repaint();
        }
        
    }
    /* this method will be called to respond repaint() */
    public void update(Graphics g) {
        /* check boundry and move object */
        g.setXORMode(Color.black);
        for (int i=0; i<maxObj; i++) {
          object[i].checkBoundry(bounds());
          object[i].move(g);
        }
    }
    /* this method will be called to repond a disclosure */
    public void paint(Graphics g) {
        /* we want to redraw the whole client area */
        g = getGraphics();
        /* fill background */
        g.setColor(getBackground());
        g.fillRect(1, 1, size().width-2, size().height-2);
        /* draw boundry */
        g.setColor(getForeground());
        g.drawRect(0, 0, size().width-1, size().height-1);
        /* draw objects */
        g.setXORMode(Color.black);
        for (int i=0; i<maxObj; i++)
          object[i].paint(g);
        /* user who call getGraphics should call dispose */
        g.dispose();
    }
}
