/*
 * EventTest Java Program
 */

import java.applet.*;
import java.awt.*;

public class EventTest extends Applet {
    int maxObj = 3;     /* max object number */
    mPoint object[];    /* objecct array */
    int current = -1, hit = -1;
    int xofs = 0, yofs = 0;
    public void init() {
      /* initial object array */
      setBackground(Color.black);
      setForeground(Color.white);
      object = new mPoint[maxObj];
      /* initial a rectangle */
      object[0] = new mRectangle(10, 10, 100, 100);
      object[0].setColor(Color.red);
      /* initial a circle */
      object[1] = new mCircle(200, 10, 100, 100);
      object[1].setColor(Color.red);
      /* initial a triangle */
      object[2] = new mTriangle(10, 200, 100, 100);
      object[2].setColor(Color.red);
    }
    /* this method will be called to repond a disclosure */
    public void paint(Graphics g) {
        /* we want to redraw the whole client area */
        g = getGraphics();
        /* fill background */
        g.setColor(getBackground());
        g.fillRect(1, 1, size().width-2, size().height-2);
        /* draw boundry */
        g.setColor(getForeground());
        g.drawRect(0, 0, size().width-1, size().height-1);
        /* draw objects */
        g.setXORMode(Color.black);
        for (int i=0; i<maxObj; i++)
          object[i].paint(g);
        /* user who call getGraphics should call dispose */
        g.dispose();
    }
    public void drawBoundry() {
        Graphics g = getGraphics();
        /* draw boundry */
        g.setColor(getForeground());
        g.drawRect(0, 0, size().width-1, size().height-1);
        g.dispose();
    }
    /* Mouse Move Event */
    public boolean mouseMove(Event ev, int x, int y) {
        int i;
        hit = -1;
        Graphics g = getGraphics();
        g.setXORMode(Color.black);
        for (i=0; i<maxObj; i++) {
          if ( object[i].isInside(x, y) ) {
            hit = i;
            break;
          }
        }
        for (i=0; i<maxObj; i++)
          object[i].setColor(g, (i==hit) ? Color.cyan : Color.red);
        g.dispose();
        return true;
    }
    /* Mouse Down Event */
    public boolean mouseDown(Event ev, int x, int y) {
        current = hit;
        if ( current != -1 ) {
          xofs = object[current].x-x;
          yofs = object[current].y-y;
        }
        return true;
    }
    /* Mouse Drag Event */
    public boolean mouseDrag(Event ev, int x, int y) {
        if ( current != -1 ) {
          Graphics g = getGraphics();
          g.setXORMode(Color.black);
          object[current].moveTo(g, x+xofs, y+yofs);
          g.dispose();
        }
        return true;
    }
    /* Mouse Up Event */
    public boolean mouseUp(Event ev, int x, int y) {
        current = -1;
        return true;
    }
    /* Mouse Enter Event */
    public boolean mouseEnter(Event ev, int x, int y) {
        setForeground(Color.cyan);
        drawBoundry();
        return true;
    }
    /* Mouse Exit Event */
    public boolean mouseExit(Event ev, int x, int y) {
        setForeground(Color.red);
        drawBoundry();
        return true;
    }
    /* KeyDown Event */
    public boolean keyDown(Event ev, int key) {
        if ( hit == -1 ) return false;
        int dx = 0, dy = 0;
        switch ( key ) {
          case Event.DOWN:
            dy = 1;
            break;
          case Event.UP:
            dy = -1;
            break;
          case Event.LEFT:
            dx = -1;
            break;
          case Event.RIGHT:
            dx = +1;
            break;
        }
        if ((dx != 0) || (dy != 0)) {
          Graphics g = getGraphics();
          g.setXORMode(Color.black);
          object[hit].move(g, dx, dy);
          g.dispose();
        }
        return true;
    }
}
