/*
 * EventTest Java Program
 */

import java.applet.*;
import java.awt.*;

public class EventTest extends Applet {
    int maxObj = 3;     /* max object number */
    mPoint object[];    /* objecct array */
    Image img;
    int current = -1, hit = -1;
    int xofs = 0, yofs = 0;
    public void init() {
      /* initial object array */
      setBackground(Color.black);
      setForeground(Color.white);
      object = new mPoint[maxObj];
      /* initial a rectangle */
      object[0] = new mRectangle(10, 10, 100, 100);
      object[0].setColor(Color.red);
      /* initial a circle */
      object[1] = new mCircle(200, 10, 100, 100);
      object[1].setColor(Color.red);
      /* initial a triangle */
      object[2] = new mTriangle(10, 200, 100, 100);
      object[2].setColor(Color.red);
      img = createImage(size().width, size().height);
    }
    /* this method will be called to repond a repaint */
    public void paint(Graphics g) { update(g);}
    /* this method will be called to repond a disclosure */
    public void update(Graphics g) {
        /* Get Off Screen Graphics Context */
        Graphics og = img.getGraphics();
        /* fill background */
        og.setColor(getBackground());
        og.fillRect(1, 1, size().width-2, size().height-2);
        /* draw boundry */
        og.setColor(getForeground());
        og.drawRect(0, 0, size().width-1, size().height-1);
        /* draw objects */
        for (int i=0; i<maxObj; i++)
          object[i].paint(og);
        /* user who call getGraphics should call dispose */
        og.dispose();
        g.drawImage(img, 0, 0, this);
    }
    /* Mouse Move Event */
    public boolean mouseMove(Event ev, int x, int y) {
        int i;
        hit = -1;
        for (i=0; i<maxObj; i++) {
          if ( object[i].isInside(x, y) ) {
            hit = i;
            break;
          }
        }
        for (i=0; i<maxObj; i++)
          object[i].setColor((i==hit) ? Color.cyan : Color.red);
        repaint();
        return true;
    }
    /* Mouse Down Event */
    public boolean mouseDown(Event ev, int x, int y) {
        current = hit;
        if ( current != -1 ) {
          xofs = object[current].x-x;
          yofs = object[current].y-y;
        }
        return true;
    }
    /* Mouse Drag Event */
    public boolean mouseDrag(Event ev, int x, int y) {
        if ( current != -1 ) {
          object[current].moveTo(x+xofs, y+yofs);
          repaint();
        }
        return true;
    }
    /* Mouse Up Event */
    public boolean mouseUp(Event ev, int x, int y) {
        current = -1;
        return true;
    }
    /* Mouse Enter Event */
    public boolean mouseEnter(Event ev, int x, int y) {
        setForeground(Color.cyan);
        repaint();
        return true;
    }
    /* Mouse Exit Event */
    public boolean mouseExit(Event ev, int x, int y) {
        setForeground(Color.red);
        repaint();
        return true;
    }
    /* KeyDown Event */
    public boolean keyDown(Event ev, int key) {
        if ( hit == -1 ) return false;
        int dx = 0, dy = 0;
        switch ( key ) {
          case Event.DOWN:
            dy = 1;
            break;
          case Event.UP:
            dy = -1;
            break;
          case Event.LEFT:
            dx = -1;
            break;
          case Event.RIGHT:
            dx = +1;
            break;
        }
        if ((dx != 0) || (dy != 0)) {
          object[hit].move(dx, dy);
          repaint();
        }
        return true;
    }
}
