/*
 * Scroll Java Program
 */

import java.applet.*;
import java.awt.*;

public class Scroll extends Applet implements Runnable {
    int w, h, xoffset = 0;
    static int yBase;
    static int strw;
    static Color color = Color.gray;
    Thread thread;
    Image offImg, bakImg;
    String title = "Star War";
    Graphics offscr;
    public Scroll() { setBackground(Color.black);}
    public void init() {
        int i, x, y, d, count;

        /* get Width and Height of Applet */
        w = size().width;
        h = size().height;

        /* Create font and caculate Font Base Line Position */
        Font fn = new Font("Courier", Font.ITALIC | Font.BOLD, h-8);
        FontMetrics fm = getFontMetrics(fn);
        strw = fm.stringWidth(title)+w;
        yBase = 4+fn.getSize()-fm.getDescent();

        /* Create Image according applet size */
        offImg = createImage(w,h);
        bakImg = createImage(w,h);

        /* Draw Stars on bakImg */
        offscr = bakImg.getGraphics();
        offscr.setColor(Color.black);
        offscr.fillRect(0, 0, w, h);

        /* Get Stars Density */
        count = (int)Math.sqrt(w*h);

        for (i=0; i<count; i++) {
          /* Get a Random Color */
          d = (int)(Math.random()*2+1);
          offscr.setColor(new Color((int)(Math.random()*255),
            (int)(Math.random()*255), (int)(Math.random()*255)));

          /* Get a Random (x, y) pair */
          x = (int)(Math.random()*w);
          y = (int)(Math.random()*h);

          /* Draw a pixel on image */
          offscr.fillOval(x, y, d, d);
        }

        offscr.dispose();

        /* Create Off Screen Graphic Context */
        offscr = offImg.getGraphics();
        offscr.setColor(color);
        offscr.setFont(fn);
    }
    /* start a new thread */
    public void start() {
        if (thread == null) {
          thread = new Thread(this);
          thread.start();
        }
    }
    /* stop the thread */
    public void stop() {
        if (thread != null) {
          thread.stop();
          thread = null;
        }
    }
    public void destroy() {
        /* Destroy Off Screen Graphics Context Here */
        offscr.dispose();
    }
    /* keep moving and redraw the objects */
    public void run() {
        while (thread != null) {
          try thread.sleep(50);
          catch (InterruptedException e);
          repaint();
          xoffset = (xoffset+1)%strw;
        }
    }
    /* this method will be called to repond a disclosure */
    public void paint(Graphics g) {
        update(g);
    }
    /* this method will be called to respond repaint() */
    public void update(Graphics g) {
        if ( g == null ) return;
        /* Draw on Off Screen Graphic Context */
        offscr.drawImage(bakImg, 0, 0, this);
        offscr.setColor(color);
        offscr.drawString(title, -xoffset+w, yBase);
        /* Draw Image on Screen Avoid Blinking */
        g.drawImage(offImg, 0, 0, this);
    }
}
