/*
 * Title Java Program
 */

import java.applet.*;
import java.awt.*;

public class StringTest extends Applet implements Runnable {
    static int yBase;
    int state = 0;
    Thread thread;
    String title = "String Example";
    String current;
    public StringTest() { setBackground(Color.white);}
    public void init() {
        int w = size().width;
        int h = size().height;
        Font fn = new Font("Helvetica",
          Font.ITALIC | Font.BOLD, h-8);
        FontMetrics fm = getFontMetrics(fn);
        yBase = 4+fn.getSize()-fm.getDescent();
        setFont(fn);
        current = title;
    }

    /* start a new thread */
    public void start() {
        if (thread == null) {
          thread = new Thread(this);
          thread.start();
        }
    }

    /* stop the thread */
    public void stop() {
        if (thread != null) {
          thread.stop();
          thread = null;
        }
    }

    /* reverse the string */
    String reverse(String source) {
        int i, len = source.length();
        StringBuffer dest = new StringBuffer(len);
        for (i=len-1; i>=0; i--)
          dest.append(source.charAt(i));
        return dest.toString();
    }

    /* keep redraw the string every two second */
    public void run() {
        while (thread != null) {
          try thread.sleep(2000);
          catch (InterruptedException e);
          switch ( state = (state+1)%4 ) {
            case 0 : current = title; break;
            case 1 : current = title.toLowerCase(); break;
            case 2 : current = title.toUpperCase(); break;
            case 3 : current = reverse(title); break;
          }
          repaint();
        }
    }

    /* this method will be called to repond a disclosure */
    public void paint(Graphics g) {
        g.drawString(current, 10, yBase);
    }

}
