
import java.applet.*;
import java.awt.*;
/**
 * 
 */
public class Test extends Applet implements java.awt.event.ActionListener {
  private Button ivjnotifyAllButton = null;
  private Button ivjnotifyButton = null;
  private TextArea ivjmessageArea = null;
  private WaitingThread[] waitingThreads;
  private int numberOfThreads = 5;
  private static double notifyTime; 
  private static Test instanceObject;
  /**
   * Method to handle events for the ActionListener interface.
   * @param e java.awt.event.ActionEvent
   */

  public void actionPerformed(java.awt.event.ActionEvent e) {
    if ((e.getSource() == getnotifyButton()) ) {
      connEtoM1(e);
    }
    if ((e.getSource() == getnotifyAllButton()) ) {
      connEtoM2(e);
    }
  }
  /**
   * connEtoM1:  (notifyButton.action.actionPerformed(java.awt.event.ActionEvent) --> Test.notify()V)
   * @param arg1 java.awt.event.ActionEvent
   */

  private void connEtoM1(java.awt.event.ActionEvent arg1) {
    try {
      notifyTime = System.currentTimeMillis();
      synchronized(this) {
	notify();
      }
    } catch (java.lang.Throwable ivjExc) {
      handleException(ivjExc);
    }
  }
  /**
   * connEtoM2:  (notifyAllButton.action.actionPerformed(java.awt.event.ActionEvent) --> Test.notifyAll()V)
   * @param arg1 java.awt.event.ActionEvent
   */

  private void connEtoM2(java.awt.event.ActionEvent arg1) {
    try {
      notifyTime = System.currentTimeMillis();
      synchronized(this) {
	notifyAll();
      }
    } catch (java.lang.Throwable ivjExc) {
      handleException(ivjExc);
    }
  }
  /**
   * Gets the applet information.
   * @return java.lang.String
   */
  public String getAppletInfo() {
    return "Test created using VisualAge for Java.";
  }
  /**
   * Return the messageArea property value.
   * @return java.awt.TextArea
   */
  private TextArea getmessageArea() {
    if (ivjmessageArea == null) {
      try {
	ivjmessageArea = new java.awt.TextArea();
	ivjmessageArea.setName("messageArea");
	ivjmessageArea.setFont(new java.awt.Font("monospaced", 1, 12));
	ivjmessageArea.setBounds(31, 25, 231, 162);
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjmessageArea;
  }
  /**
   * Return the notifyAllButton property value.
   * @return java.awt.Button
   */
  private Button getnotifyAllButton() {
    if (ivjnotifyAllButton == null) {
      try {
	ivjnotifyAllButton = new java.awt.Button();
	ivjnotifyAllButton.setName("notifyAllButton");
	ivjnotifyAllButton.setBounds(380, 52, 56, 23);
	ivjnotifyAllButton.setLabel("notifyAll");
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjnotifyAllButton;
  }
  /**
   * Return the notifyButton property value.
   * @return java.awt.Button
   */

  private Button getnotifyButton() {
    if (ivjnotifyButton == null) {
      try {
	ivjnotifyButton = new java.awt.Button();
	ivjnotifyButton.setName("notifyButton");
	ivjnotifyButton.setBounds(299, 54, 56, 23);
	ivjnotifyButton.setLabel("notify");
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjnotifyButton;
  }
  /**
   * Called whenever the part throws an exception.
   * @param exception java.lang.Throwable
   */
  private void handleException(Throwable exception) {
    exception.printStackTrace(System.out);
  }
  /**
   * Handle the Applet init method.
   */
  public void init() {
    super.init();
    try {
      setName("Test");
      setLayout(null);
      setSize(458, 251);
      add(getmessageArea(), getmessageArea().getName());
      add(getnotifyButton(), getnotifyButton().getName());
      add(getnotifyAllButton(), getnotifyAllButton().getName());
      initializeWaitingThreads();
      initConnections();
      instanceObject = this;
    } catch (java.lang.Throwable ivjExc) {
      handleException(ivjExc);
    }
  }
  /**
   * Initializes connections
   */
  private void initConnections() {
    getnotifyButton().addActionListener(this);
    getnotifyAllButton().addActionListener(this);
  }


  private void initializeWaitingThreads() {
    waitingThreads = new WaitingThread[numberOfThreads];
    for (int i=0; i<numberOfThreads; i++) {
      waitingThreads[i] = new WaitingThread(this);
      waitingThreads[i].start();
    }
  }

  public static void appendText(String info) {
    if (instanceObject != null) 
      instanceObject.getmessageArea().append(info + "\n");
  }
  
  public static double getNotifyTime() {
    return notifyTime;
  }
  /**
   * main entrypoint - starts the part when it is run as an application
   * @param args java.lang.String[]
   */
  public static void main(java.lang.String[] args) {
    try {
      Frame frame;
      try {
	Class aFrameClass = Class.forName("com.ibm.uvm.abt.edit.TestFrame");
	frame = (Frame)aFrameClass.newInstance();
      } catch (java.lang.Throwable ivjExc) {
	frame = new Frame();
      }
      Test aTest;
      Class iiCls = Class.forName("Test");
      ClassLoader iiClsLoader = iiCls.getClassLoader();
      aTest = (Test)java.beans.Beans.instantiate(iiClsLoader,"Test");
      frame.add("Center", aTest);
      frame.setSize(aTest.getSize());
      frame.setVisible(true);
    } catch (Throwable exception) {
      System.err.println("Exception occurred in main() of java.applet.Applet");
      exception.printStackTrace(System.out);
    }
  }
}


/**
 * A thread that prints a message each time it is reactivated
 * after waiting on a monitor.
 */
class WaitingThread extends Thread {
  Object instanceToBeLocked;
  
  /**
   * Creates a wait thread which will use the specified
   * monitor for waiting.
   */
  public WaitingThread(Object obj) {
   instanceToBeLocked = obj;
  }
  
  public void run() {
    while (true) {
      synchronized (instanceToBeLocked) {
	Test.appendText(this + 	" starting to wait.");
	try {
	  instanceToBeLocked.wait();
	} catch (InterruptedException e) {
	  Test.appendText("Error in Thread " + this +
			  " during wait");
	}
	Test.appendText(this + " awoke from wait.");
      }
      double mSeconds = (System.currentTimeMillis() - 
			 Test.getNotifyTime());
      Test.appendText("Elapsed time for " + this + " to acquire Lock = "  + 
		      mSeconds + " milliSeconds");
    }
  }
}
