import java.awt.*;

public class WaitNotifyExample extends java.applet {
  static final String NOTIFY = "notify();";
  static final String NOTIFY_ALL = "notifyAll();";
  static WaitNotifyExample currentInstance;
  TextArea messageLog = new TextArea(45, 45);
  Button notifyButton = new Button(NOTIFY);
  Button notifyAllButton = new Button(NOTIFY_ALL);
  WaitThread w1Thread;
  WaitThread w2Thread;
  WaitThread w3Thread;
  WaitThread w4Thread;
  WaitThread w5Thread;
  WaitThread w6Thread;
  WaitThread w7Thread;
  WaitThread w8Thread;
  WaitThread w9Thread;
  WaitThread w10Thread;
  public static long notifyStartTime;
  
  /** Builds the applet's interface. */
  public void init() {
    Panel p = new Panel();
    p.setLayout(new GridLayout(1, 0));
    p.add(notifyButton);
    p.add(notifyAllButton);
    add(p);
    add(messageLog);
  }
  
  /**
   * Called when the applet is started or when the browser
   * returns to the applet's page.
   */
  
  public void start() {
    currentInstance = this;
    
    /* Create and start nine threads that will all wait on the
     * same monitor.
     */
    if (w1Thread == null) {
      w1Thread = new WaitThread(this);
    }
    w1Thread.start();
    if (w2Thread == null) {
      w2Thread = new WaitThread(this);
    }
    w2Thread.start();
    if (w3Thread == null) {
      w3Thread = new WaitThread(this);
    }
    w3Thread.start();
    if (w4Thread == null) {
      w4Thread = new WaitThread(this);
    }
    w4Thread.start();
    if (w5Thread == null) {
      w5Thread = new WaitThread(this);
    }
    w5Thread.start();
    if (w6Thread == null) {
      w6Thread = new WaitThread(this);
    }
    w6Thread.start();
    if (w7Thread == null) {
      w7Thread = new WaitThread(this);
    }
    w7Thread.start();
    if (w8Thread == null) {
      w8Thread = new WaitThread(this);
    }
    w8Thread.start();
    if (w9Thread == null) {
      w9Thread = new WaitThread(this);
    }
    w9Thread.start();
    
    /* This next thread will not get notified, because
     * it waits on a different monitor than the others.
     */
    if (w10Thread == null) {
      w10Thread = new WaitThread(new Object());
    }
    w10Thread.start();
  }
  
  /**
   * Called when the applet is terminated or when the browser
   * leaves the applet's page.
   */
  public void stop() {
    w1Thread.stop();
    w1Thread = null;
    w2Thread.stop();
    w2Thread = null;
    w3Thread.stop();
    w3Thread = null;
    w4Thread.stop();
    w4Thread = null;
    w5Thread.stop();
    w5Thread = null;
    w6Thread.stop();
    w6Thread = null;
    w7Thread.stop();
    w7Thread = null;
    w8Thread.stop();
    w8Thread = null;
    w9Thread.stop();
    w9Thread = null;
    w10Thread.stop();
    w10Thread = null;
  }
  
  /** Handles button presses in the applet. */
  public boolean action(Event evt, Object what) {
    if (evt.target instanceof Button) {
      if (NOTIFY.equals(what)) {
	/* Do a notify on the applet's monitor. */
	synchronized (this) {
	  notifyStartTime = System.currentTimeMillis();
	  notify();
	  addMessage("Thread \"" + Thread.currentThread().getName() + "\" sent a notify.");
	}
      } else
	if (NOTIFY_ALL.equals(what)) {
	  /* Do a notifyAll on the applet's monitor. */
	  synchronized (this) {
	    notifyStartTime = System.currentTimeMillis();
	    notifyAll();
	    addMessage("Thread \"" + Thread.currentThread().getName() + "\" sent a notifyAll.");
	  }
	} else {
	}
      return true;
    }
    return super.action(evt, what);
  }
  
  /** Adds a message to the applet's log. */
  public static void addMessage(String s) {
    if (currentInstance != null) {
      currentInstance.messageLog.appendText(s + "\n");
    }
  }
}


/**
 * A thread that prints a message each time it is reactivated
 * after waiting on a monitor.
 */
class WaitThread extends Thread {
  Object monitorObject;
  
  /**
   * Creates a wait thread which will use the specified
   * monitor for waiting.
   */
  public WaitThread(Object obj) {
    monitorObject = obj;
  }
  public void run() {
    while (true) {
      synchronized (monitorObject) {
	WaitNotifyExample.addMessage("Thread \"" + getName() + "\" starting to wait.");
	try {
	  monitorObject.wait();
	} catch (InterruptedException e) {
	}
	WaitNotifyExample.addMessage("Thread \"" + getName() + "\" awoke from wait.");
      }
      double mSeconds = (System.currentTimeMillis() - WaitNotifyExample.notifyStartTime);
      System.out.println("Elapsed time for " + getName() + " = " + mSeconds + " milliSeconds\n");
    }
  }
}
