# This makefile delivers two beans (OurButton and ExplicitButton)
# in a single JAR file.

CLASSFILES= \
        sunw/demo/ImageEditor/ImageEditor.class \
        sunw/demo/ImageEditor/ImageEditorBeanInfo.class \
	sunw/demo/ImageEditor/FilterNameEditor.class 

DATAFILES= \
	sunw/demo/ImageEditor/faces.gif \
	sunw/demo/ImageEditor/ImageScaleIconColor16.gif \
	sunw/demo/ImageEditor/ImageScaleIconColor32.gif \
	sunw/demo/ImageEditor/ImageScaleIconMono16.gif  \
	sunw/demo/ImageEditor/ImageScaleIconMono32.gif
JARFILE= ../jars/ImageEditor.jar

all: $(JARFILE)

# Create a JAR file with a suitable manifest.

$(JARFILE): $(CLASSFILES) $(DATAFILES)
	echo "Name: sunw/demo/ImageEditor/ImageEditor.class" >> manifest.tmp
	echo "Java-Bean: True" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/ImageEditor/ImageEditorBeanInfo.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp

	echo "Name: sunw/demo/ImageEditor/FilterNameEditor.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	jar cfm $(JARFILE) manifest.tmp sunw/demo/ImageEditor/*.class $(DATAFILES)
	@/bin/rm manifest.tmp

# Rule for compiling a normal .java file
%.class: %.java
	export CLASSPATH; CLASSPATH=.
	javac $<

clean:
	/bin/rm -f sunw/demo/ImageEditor/*.class
	/bin/rm -f $(JARFILE)
