package demos.textEditor;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.*;



public class CollabDialog extends Dialog implements ActionListener {
  Button    setNameButton;
  Button partyNameButton;
  protected Button yes;
  protected Button no;
  TextField nameField;
  TextField partyField;
  Label _statusInfo;
  String _defaultStatus = new String("Set JDCE Preferences");
  TextEditor parent;
  
  public CollabDialog (Frame frame, String _string) {
    super(frame, _string, true);
    parent = (demos.textEditor.TextEditor)frame;
    Panel p;
    Font               lbl;
    GridBagLayout      g;
    GridBagConstraints c;

    lbl = new Font("Helvetica", Font.BOLD, 14);
    g   = new GridBagLayout();
    c   = new GridBagConstraints();
    
    c.fill      = GridBagConstraints.NONE;
    c.weightx   = 1.0;
    c.gridwidth = GridBagConstraints.REMAINDER;
    
    setLayout(g);

    p = new Panel();
    g.setConstraints(p, c);
    add(p);
    p.add(_statusInfo = new Label("", FlowLayout.CENTER));
    _statusInfo.setText(_defaultStatus);
    
    p = new Panel();
    g.setConstraints(p, c);
    add(p);
    p.add(partyNameButton = new Button("Party"));
    partyNameButton.addActionListener(this);
    p.add(partyField     = new TextField(20)).setFont(lbl);

    p = new Panel();
    g.setConstraints(p, c);
    add(p);
    p.add(setNameButton = new Button("Set Name"));
    setNameButton.addActionListener(this);
    p.add(nameField     = new TextField(20)).setFont(lbl);

    p = new Panel();
    g.setConstraints(p, c);
    add(p);
    p.add(yes = new Button("OK"));
    yes.addActionListener(this);
    p.add(no = new Button("Cancel"));
    no.addActionListener(this);

    if (parent.getPartyName()!=null) partyField.setText(parent.getPartyName());
    if (parent.getClientName()!=null) nameField.setText(parent.getClientName());


    setTitle("JDCE Dialog");
    setResizable(true);
    pack();
  }

  public void actionPerformed(ActionEvent actionEvent) {
    String string = actionEvent.getActionCommand();
        
    if (partyNameButton !=null && string.equals(partyNameButton.getLabel())) 
      parent.setPartyName(partyField.getText());
    
    if (setNameButton !=null && string.equals(setNameButton.getLabel())) 
      parent.setClientName(nameField.getText());			       
    if (yes != null && string.equals(yes.getLabel())) {
      setVisible(false);
      dispose();
    }
    if (no != null && string.equals(no.getLabel())) {
      setVisible(false);
      dispose();
    }
  }

}
