package edu.syr.npac.webflow.impl.manager;

import java.util.*;
import java.beans.*;
import java.lang.reflect.*;
import org.omg.CosNaming.*;



public class moduleManagerImpl
extends edu.syr.npac.webflow.manager._moduleManagerImplBase {
  nameSpaceWalker walker = new nameSpaceWalker();

  /** Construct a persistently named object. */
  public moduleManagerImpl(java.lang.String name) {
    super(name);
  }
  
  /** Construct a transient object. */
  public moduleManagerImpl() {
    super();
  }

  public String[] listModules() {
    return walker.listNameContextsAndObjects("NPAC/1");
  }
  
  public String[] listMethods(edu.syr.npac.webflow.module.Module  _module) {
    try {
      MethodDescriptor mds[] = 
	Introspector.getBeanInfo(_module.getClass()).getMethodDescriptors();
      String methodsInfo[] = new String[mds.length];
      for (int i = 0; i < mds.length; i++) {
	methodsInfo[i]=mds[i].getName();
      }
      return methodsInfo;
    } catch (Exception ex) {
      System.out.println("Error printing methods info for :" + _module);
      return null;
    }
  }
  
  public String[] listZeroArgumentMethods(java.lang.Object _module) {
    try {
      Vector zeroArgMethods = new Vector();
      MethodDescriptor mds[] = 
	Introspector.getBeanInfo(_module.getClass()).getMethodDescriptors();
      
      for (int i = 0; i < mds.length; i++) {
	MethodDescriptor md = mds[i];
	Class margs[] = md.getMethod().getParameterTypes();
	
	if (margs.length == 0 && 
	    md.getMethod().getReturnType() == Void.TYPE) {
	  zeroArgMethods.addElement(md);
	  continue;
	}
      }
      String methodsInfo[] = new String[zeroArgMethods.size()];
      for (int i=0; i < zeroArgMethods.size(); i++)
	methodsInfo[i] = 
	  ((MethodDescriptor)zeroArgMethods.elementAt(i)).getName();
      return methodsInfo;
    } catch (Exception ex) {
      return null;
    }
  }
  
  public org.omg.CORBA.Object getModuleHandle(java.lang.String  _moduleName) {
    //String args[] = { -DORBservices=CosNaming, -DSVCnameroot=NPAC };
    try {
      /* Initialize the ORB. */
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();

      /* Get a reference to the Naming Service */
      org.omg.CORBA.Object nameServiceObj = 
	orb.resolve_initial_references("NameService");
      if (nameServiceObj == null) {
	System.out.println("Name Service Object = null");
	return null;
      }
      
      org.omg.CosNaming.NamingContext rootContext =
	org.omg.CosNaming.NamingContextHelper.bind(orb, "NPAC/1");
      if (rootContext == null) {
	System.out.println("rootContext = null");
	return null;
      }

      NameComponent []name =  toName(_moduleName);
      org.omg.CORBA.Object object=rootContext.resolve(name);
      return object;

    } catch(org.omg.CORBA.UserException e) {
      System.out.println("Exception: " + e);
      return null;
    }
  }

  public edu.syr.npac.webflow.module.Module createTransientModule(java.lang.String  _moduleName) {
    if (_moduleName.equals("ConvexFilter")) {
      System.out.println("Success here .....");
      return new edu.syr.npac.webflow.impl.module.imaging.ConvexFilter();
    }
    if (_moduleName.equals("NegativeFilter"))
      return new edu.syr.npac.webflow.impl.module.imaging.NegativeFilter();
    
    if (_moduleName.equals("BathGlassFilter"))
      return new edu.syr.npac.webflow.impl.module.imaging.BathGlassFilter();
    
    if (_moduleName.equals("InputModule"))
      return new edu.syr.npac.webflow.impl.module.imaging.InputModule();
    
    return null;

  }

  
  private static NameComponent[] toName(String name) 
       throws org.omg.CORBA.UserException 
  {
    LNameFactory factory = 
      com.visigenic.vbroker.services.CosNaming.LFactory.instance();
    LName lname=factory.create_lname();
    StringTokenizer slasher = new StringTokenizer(name, "/");
    int index=1;
    while(slasher.hasMoreTokens()) {
      LNameComponent component=factory.create_lname_component();
      String nameComponent=slasher.nextToken();
      StringTokenizer dotter=
	new StringTokenizer(nameComponent, ".");
      component.set_id(dotter.hasMoreTokens() ? dotter.nextToken() : "");
      component.set_kind(dotter.hasMoreTokens() ? dotter.nextToken() : "");
      lname.insert_component(index++, component);
    }
    return lname.to_idl_form();
  }
}
