package edu.syr.npac.webflow.impl.module.imaging;

public class BathGlassFilter
    extends edu.syr.npac.webflow.module.imaging._ImageModuleImplBase {
    
  private int[] pixel;
  private int imgw;
  private int imgh;
      
      /** Construct a persistently named object. */
  public BathGlassFilter(java.lang.String name) {
    super(name);
  }
      
      /** Construct a transient object. */
  public BathGlassFilter() {
    super();
  }
      
      
  public void setWidth(int nimgw) {
    imgw = nimgw;
  }
      
  public int getWidth(){ 
    return imgw;
  }
      
  public void setHeight(int nimgh) {
    imgh=nimgh;
  }
      
  public int getHeight() {
    return imgh;
  }
      
  public void setPixels(int[] pixels) {
    pixel = new int[pixels.length];
    System.arraycopy(pixels, 0, pixel, 0,pixels.length);
  }
      
  public int[] getPixels(){
    return pixel;
  }
      
  private void filter(int[] npixel, int nimgw, int nimgh) {
    System.out.println("BathGlass Filtering begins on the server-side....");
    int _pixel[] = new int[nimgw * nimgh];
    int wpixel[] = new int[nimgw];
    for (int j=0; j < nimgh ; j++) {
      
      for (int i=0; i < nimgw ; i++) {
	int a = 10 - i%10 + i;
	a += nimgw*j;
	if (a < nimgw * nimgh) wpixel[i] = npixel[a];
	else wpixel[i] = npixel[nimgw*nimgh -1];
      }
      System.arraycopy(wpixel,0, _pixel, j*nimgw, nimgw);
    }
    System.arraycopy(_pixel,0, pixel, 0, _pixel.length);
    System.out.println("Done ....");
  }
      
      /**
       * run the module code
       */ 
  public void run(){
    filter(pixel, imgw, imgh);
  }
      
      /**
       * deallocate all resources allocated by the module. Destroy the module

       */
  public void destroy(){
    
  }
}
