package edu.syr.npac.webflow.impl.module.imaging;

import java.awt.*;
import java.awt.image.*;
import java.net.URL;
import org.omg.CosNaming.*;
import java.util.*;

public class InputModule
extends edu.syr.npac.webflow.module.imaging._ImageInputModuleImplBase {
  
  private int[] pixel;
  private int imgw;
  private int imgh;
  private String imageLoc;

  private Image _img;
  /** Construct a persistently named object. */
  public InputModule(java.lang.String name) {
    super(name);
  }
  
  /** Construct a transient object. */
  public InputModule() {
    super();
  }

  public int getWidth(){ 
    return imgw;
  }

  public int getHeight() {
    return imgh;
  }
  
  public int[] getPixels(){
    return pixel;
  }
  
  public void setImageLocation(String _imageLoc) {
    imageLoc = _imageLoc;
  }

  /**
   * run the module code
   */ 
  public void run(){
    if (loadImage()) grabPixels();
    else System.out.println("Error in Loading Pixels... Check URL");    
  }
  
  
  private boolean loadImage() {
    URL _urlImage;
    
    try {
      _urlImage = new URL(imageLoc);
      _img = Toolkit.getDefaultToolkit().getImage(_urlImage);
    } catch (Exception e) {
      try {
	_img = Toolkit.getDefaultToolkit().getImage(imageLoc);
      }  catch (Exception ex) {
	_img=null;
	ex.printStackTrace();
      }
    }
    Button c = new Button("track");
    if (_img==null) return false;
    // Use a MediaTracker to wait for the Image to be fully loaded.
    MediaTracker mt = new MediaTracker(c);
    mt.addImage( _img, 0 );
    System.out.println("Media Tracker waiting to load Image .....");
    try {
      mt.waitForID( 0 );
    } catch(Exception e) {
      return false;
    }
    return true;
  }
  
  
  private void grabPixels() { 
    imgw = _img.getWidth(null);
    imgh = _img.getHeight(null);
    pixel = new int[imgw*imgh]; 
    
    PixelGrabber pg = 
      new PixelGrabber(_img, 0, 0, imgw, imgh, pixel, 0, imgw); 
    try { 
      pg.grabPixels(); 
    } catch (InterruptedException e) {
      e.printStackTrace();
    } 
    
  }
  
  /**
   * deallocate all resources allocated by the module. Destroy the module
   */
  public void destroy(){
    
  }

}

