package edu.syr.npac.webflow.impl.module.imaging;
import java.awt.image.*;
import java.awt.*;

public class NegativeFilter
    extends edu.syr.npac.webflow.module.imaging._ImageModuleImplBase {
    
    private int[] pixel;
    private int imgw;
    private int imgh;
    
    /** Construct a persistently named object. */
    public NegativeFilter(java.lang.String name) {
	super(name);
    }
    
    /** Construct a transient object. */
    public NegativeFilter() {
	super();
    }
    
    
    public void setWidth(int nimgw) {
	imgw = nimgw;
    }

    public int getWidth(){ 
	return imgw;
    }
    
    public void setHeight(int nimgh) {
	imgh=nimgh;
    }

    public int getHeight() {
	return imgh;
    }
    
    public void setPixels(int[] pixels) {
	pixel = new int[pixels.length];
	System.arraycopy(pixels, 0, pixel, 0, pixels.length);
	System.out.println("Set the Pixels here ");
    }
    
    public int[] getPixels(){
	return pixel;
    }
    
    private void filter(int[] npixel, int nimgw, int nimgh) {
      System.out.println("Negative Filtering begins on the server-side....");
      int r, g, b, p=1;
      Color col;
      
      for (int i=0; i<npixel.length; i++) {
	col = toRGB(npixel[i]);
	r  = col.getRed();
	g  = col.getGreen();
	b  = col.getBlue();
	
	npixel[i] = toPixel(255-r,255-g,255-b);
      } 
      
      System.arraycopy(npixel,0, pixel, 0, npixel.length);
      System.out.println("Done .....");
    }

  private int toPixel(double r, double g, double b) {
    return toPixel((int)r, (int)g, (int)b); }

  private int toPixel(int r, int g, int b) {
    return (255 << 24) | (r << 16) | (g << 8) | (b << 0); }

      
  private Color toRGB(int p) {
    int r = (p >> 16) & 0xff;
    int g = (p >>  8) & 0xff;
    int b = (p >>  0) & 0xff;
    return new Color(r,g,b);
  }
      
      
      /**
       * run the module code
       */ 
  public void run(){
    filter(pixel, imgw, imgh);
  }
      
      /**
       * deallocate all resources allocated by the module. Destroy the module
       */
  public void destroy(){
    
  }
}

