/**
* This is part of the source code needed for building a Collabratised
* VRML World using JSDA.
* The files needed are 
* Server-Side :: 
* VRServer.java - This is the Virtual World Server
* MuProtocol.java - This contains various defined constants used throughout
* 
* Client-side ::
* VRClient.java - 
* VRUser.java - The Java Script
* VRConsumer.java
* MuProtocol.java - This contains various defined constants used throughout
* 
* @author : Shrideep Pallickara
* @advisor: Dr. Wojtek Furmanski
* @date   : 26/Mar - 1997.
*/
import SharedData.*;

class
VRConsumer implements ChannelConsumer, MuProtocol {

    /** The name of this channel consumer. */
    protected String name;
    VRUser vrUser;
    public
    VRConsumer(String name, VRUser vrUser) {
	if (VRConsumer_Debug) {
	    System.out.println("VRConsumer: constructor.");
	}

	this.name = name;
        this.vrUser = vrUser;
    }


    public synchronized void
    dataReceived(Data data) {
        String  message;
        int     position   = 0;
	int     priority   = data.getPriority();
	String  senderName = data.getSenderName();
        Channel channel    = data.getChannel();
        byte[]  theData    = data.getData();

        if (VRConsumer_Debug) {
            System.out.println("VRConsumer: dataReceived " +
                               " Priority "    + priority +
                               " Channel "     + channel +
                               " Sender name " + senderName +
                               " Data "        + theData);
        }

/* Construct message and output it to the end of the message area. */

        message = new String(theData, 0);
        vrUser.commandLine = message;
        vrUser.performUpdate();

    }
}
