DROP INDEX name_index;
DROP INDEX phone_no_index;

DROP TABLE phone_list_table; 
DROP TABLE person_info_table;

CREATE TABLE person_info_table
       (person_id	NUMBER(6) CONSTRAINT pk_person_info PRIMARY KEY,
	last_name	VARCHAR2(15),
	first_name	VARCHAR2(15),
	title   	VARCHAR2(8) CONSTRAINT lower_title
			            CHECK (title = LOWER(title)),
	user_name	VARCHAR2(8),
	address		VARCHAR2(12),
	url		VARCHAR2(20) DEFAULT NULL);

CREATE TABLE phone_list_table
       (person_id	NUMBER(6) CONSTRAINT fk_phone_list
				  REFERENCES person_info_table(person_id),
	phone_no	NUMBER(10),
	phone_type	VARCHAR2(10));


CREATE INDEX name_index ON person_info_table(last_name, first_name);
CREATE INDEX phone_no_index ON phone_list_table(phone_no);
