/*
 *  File:  DrawableStringTest.java
 *
 *  Given a string, center the string both vertically and
 *  horizontally in the applet window.
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.*;

public class DrawableStringTest extends Applet {

   private String s, fontName;
   private DrawableString drawableString;
   
   public void init() {
      
      // Get the "stringToDraw" parameter from the HTML document:
      s = getParameter( "stringToDraw" );
      if ( s == null ) s = "Merry Christmas!";
      
      // Get the "font" parameter from the HTML document:
      fontName = getParameter( "font" );
      if ( fontName == null ) fontName = "SansSerif";
      
      // Instantiate a DrawableString object:
      drawableString = new DrawableString( s );
      drawableString.setColor( Color.red );
      drawableString.setFontName( fontName );
      
      // Set the background color of the applet:
      this.setBackground( Color.cyan );
      
   }
   
   public void paint( Graphics g ) {
      drawableString.centerDraw( this );
  }
   
}
