/*
 *  File:  OctagonTest.java
 *
 *  Rotate a regular octagon
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;

public class OctagonTest extends Applet {

   // create a reference to an octagon:
   private Octagon octagon;
   
   // center of regular octagon:
   private int x, y;
   
   // radius of regular octagon:
   private int r;

   // number of rotations:
   private int n = 7;
   
   // rotation angle:
   private double theta = 2 * Math.PI / n;

   public void init() {
     x = y = Math.min( getSize().width, getSize().height )/2;
     r = x - 15;
   }

   public void paint( Graphics g ) {

      // instantiate a regular octagon:
      octagon = new Octagon( x, y, r );
    
      // rotate and draw:
      for ( int i = 0; i < n; i++ ) {
         octagon.centerRotate( theta ).draw( g );
      }

   }
   
}
