/*
 *  File:  QuadrilateralTest.java
 *
 *  Telescoping trapezoids (or a striped truncated cone)
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Color;

public class QuadrilateralTest extends Applet {

   // create a reference to a quadrilateral:
   private Quadrilateral trapezoid;

   private int delta = 15;  // increment
   
   public void paint( Graphics g ) {

      // initialize color:
      Color c = Color.white;

      // initialize base of the trapezoid:
      Point p1 = new Point(  20, 180 );
      Point p2 = new Point( 360, 180 );

      // initialize roof to base:
      Point q1 = new Point( p1 );
      Point q2 = new Point( p2 );

      // raise the roof, set the color, and fill:
      do {

         // compute the roof of the trapezoid:
         q1.x += delta; q2.x -= delta;
         q1.y -= delta; q2.y -= delta;

         // instantiate a trapezoid:
         trapezoid = new Quadrilateral( p1, p2, q2, q1 );

         // change color:
         if ( c.equals( Color.white ) ) {
            trapezoid.setColor( c = Color.black );
         } else {
            trapezoid.setColor( c = Color.white );
         }

         // fill the trapezoid:
         trapezoid.fill( g );

         // the base of the next trapezoid is the roof of this trapezoid:
         p1 = new Point( q1 ); p2 = new Point( q2 );

      } while ( q2.x - q1.x >= 2*delta );

   }
   
}
