/*
 *  File:  ColorBoxes3.java
 *
 *  Display built-in colors with labels, arrays, and loops
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;

public class ColorBoxes3 extends Applet {

   // initialize color arrays:
   Color firstRowColor[] = { Color.black, Color.blue, Color.cyan, Color.darkGray };
   Color secondRowColor[] = { Color.gray, Color.green, Color.lightGray, Color.magenta };
   Color thirdRowColor[] = { Color.orange, Color.pink, Color.red, Color.white };
   Color fourthRowColor[] = { Color.yellow };
   
   public void paint( Graphics g ) {
      
      FontMetrics fm = g.getFontMetrics();
      int descender = fm.getDescent();
      
      // Draw the first row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( firstRowColor[j] );
          g.fillRect( 10 + 70*j, 10, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( firstRowColor[j] ), 10 + 70*j, 10 - descender );
      }
      
      // Draw the second row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( secondRowColor[j] );
          g.fillRect( 10 + 70*j, 80, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( secondRowColor[j] ), 10 + 70*j, 80 - descender );
      }
      
      // Draw the third row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( thirdRowColor[j] );
          g.fillRect( 10 + 70*j, 150, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( thirdRowColor[j] ), 10 + 70*j, 150 - descender );
      }
      
      // Draw the fourth row of color boxes:
      for ( int j = 0; j < 1; j++ ) {
          g.setColor( fourthRowColor[j] );
          g.fillRect( 10 + 70*j, 220, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( fourthRowColor[j] ), 10 + 70*j, 220 - descender );
      }
      
   }

   public String toString( Color c ) {
      
      if ( c.equals( Color.black ) ) {
         return "black";
      } else if ( c.equals( Color.blue ) ) {
         return "blue";
      } else if ( c.equals( Color.cyan ) ) {
         return "cyan";
      } else if ( c.equals( Color.darkGray ) ) {
         return "darkGray";
      } else if ( c.equals( Color.gray ) ) {
         return "gray";
      } else if ( c.equals( Color.green ) ) {
         return "green";
      } else if ( c.equals( Color.lightGray ) ) {
         return "lightGray";
      } else if ( c.equals( Color.magenta ) ) {
         return "magenta";
      } else if ( c.equals( Color.orange ) ) {
         return "orange";
      } else if ( c.equals( Color.pink ) ) {
         return "pink";
      } else if ( c.equals( Color.red ) ) {
         return "red";
      } else if ( c.equals( Color.white ) ) {
         return "white";
      } else if ( c.equals( Color.yellow ) ) {
         return "yellow";
      } else {
         return "unknown";
      }
      
   }
   
}
   
