/*
 *  File:  ColorBoxes4.java
 *
 *  Display built-in colors with labels, a 2D array, and a nested loop
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;

public class ColorBoxes4 extends Applet {

   // Initialize two-dimensional color array:
   private Color color[][] = {
      { Color.black, Color.blue, Color.cyan, Color.darkGray },
      { Color.gray, Color.green, Color.lightGray, Color.magenta },
      { Color.orange, Color.pink, Color.red, Color.white },
      { Color.yellow }
   };
   
   // Initialize two-dimensional array of color strings:
   private String colorString[][] = {
      { "black", "blue", "cyan", "darkGray" },
      { "gray", "green", "lightGray", "magenta" },
      { "orange", "pink", "red", "white" },
      { "yellow" }
   };
   
   public void paint( Graphics g ) {
      
      FontMetrics fm = g.getFontMetrics();
      int descender = fm.getDescent();
      
      // Draw rows of color boxes:
      for ( int i = 0; i < color.length; i++ ) {
         for ( int j = 0; j < color[i].length; j++ ) {
           g.setColor( color[i][j] );
           g.fillRect( 10 + 70*j, 10 + 70*i, 50, 50 );
           g.setColor( Color.black );
           g.drawString( colorString[i][j], 10 + 70*j, 10 + 70*i - descender );
         }
      }
      
   }

}
   
