/*
 *  File:  ColorBoxes5.java
 *
 *  Display built-in colors with labels, a 2D array, a nested loop,
 *  and some constants
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;

public class ColorBoxes5 extends Applet {

   // size of each color swatch:
   private final int swatchSize = 70;
   // whitespace around each color swatch:
   private final int border = 15;
   // total size, including whitespace:
   private final int unitSize = swatchSize + 2*border;
   // number of color swatches per row:
   private final int cols = 4;

   // Initialize two-dimensional color array:
   private Color color[][] = {
      { Color.black, Color.blue, Color.cyan, Color.darkGray },
      { Color.gray, Color.green, Color.lightGray, Color.magenta },
      { Color.orange, Color.pink, Color.red, Color.white },
      { Color.yellow }
   };
   
   // Initialize two-dimensional array of color strings:
   private String colorString[][] = {
      { "black", "blue", "cyan", "darkGray" },
      { "gray", "green", "lightGray", "magenta" },
      { "orange", "pink", "red", "white" },
      { "yellow" }
   };
   
   public void paint( Graphics g ) {
      
      int x, y;  // local variables:
      
      // vertical adjustment for color labels:
      int descender = g.getFontMetrics().getDescent();
      
      // Draw rows of color boxes:
      for ( int i = 0; i < color.length; i++ ) {
         y = border + unitSize*i;
         for ( int j = 0; j < color[i].length; j++ ) {
            x = border + unitSize*j;
            g.setColor( color[i][j] );
            g.fillRect( x, y, swatchSize, swatchSize );
            g.setColor( Color.black );
            g.drawString( colorString[i][j], x, y - descender );
         }
      }
      
   }

}
   
