/*
 *  File:  ColorString.java
 *
 *  A ColorString class
 *
 *  Usage:  ColorString.getColor( ColorString.color )
 *          where 'color' is one of the thirteen pre-define colors
 *
 *  Example:  Color c = ColorString.getColor( ColorString.red )
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.Color;
import java.util.Hashtable;

public class ColorString {

   // initialize ColorString constants:
   public static final String black = "black";
   public static final String blue = "blue";
   public static final String cyan = "cyan";
   public static final String darkGray = "darkGray";
   public static final String gray = "gray";
   public static final String green = "green";
   public static final String lightGray = "lightGray";
   public static final String magenta = "magenta";
   public static final String orange = "orange";
   public static final String pink = "pink";
   public static final String red = "red";
   public static final String white = "white";
   public static final String yellow = "yellow";
   
   protected static Hashtable colors;
   
   private static void initColors() {
      colors = new Hashtable();
      colors.put( ColorString.black, Color.black );
      colors.put( ColorString.blue, Color.blue );
      colors.put( ColorString.cyan, Color.cyan );
      colors.put( ColorString.darkGray, Color.darkGray );
      colors.put( ColorString.gray, Color.gray );
      colors.put( ColorString.green, Color.green );
      colors.put( ColorString.lightGray, Color.lightGray );
      colors.put( ColorString.magenta, Color.magenta );
      colors.put( ColorString.orange, Color.orange );
      colors.put( ColorString.pink, Color.pink );
      colors.put( ColorString.red, Color.red );
      colors.put( ColorString.white, Color.white );
      colors.put( ColorString.yellow, Color.yellow );
   }
   
   public static final Color getColor( ColorString colorstring ) {
   
      if ( colors == null ) initColors();
      return ( Color ) colors.get( colorstring );
      
   }
   
}
   
