/*
 *  File:  MyColorBoxes2.java
 *
 *  Display built-in colors with labels
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;

public class MyColorBoxes2 extends Applet {

   // Define three colors:
   private Color brown     = new Color( 0xA5, 0x2A, 0x2A );
   private Color turquoise = new Color( 0x40, 0xE0, 0xD0 );
   private Color violet    = new Color( 0xEE, 0x82, 0xEE );
   
   public void paint( Graphics g ) {
      
      // vertical adjustment for color labels:
      int descender = g.getFontMetrics().getDescent();
      
      // Draw the first row of color boxes:
      g.setColor( Color.black );
      g.fillRect( 10, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "black", 10, 10 - descender );
      g.setColor( Color.blue );
      g.fillRect( 80, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "blue", 80, 10 - descender );
      g.setColor( Color.cyan );
      g.fillRect( 150, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "cyan", 150, 10 - descender );
      g.setColor( Color.darkGray );
      g.fillRect( 220, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "darkGray", 220, 10 - descender );
      
      // Draw the second row of color boxes:
      g.setColor( Color.gray );
      g.fillRect( 10, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "gray", 10, 80 - descender );
      g.setColor( Color.green );
      g.fillRect( 80, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "green", 80, 80 - descender );
      g.setColor( Color.lightGray );
      g.fillRect( 150, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "lightGray", 150, 80 - descender );
      g.setColor( Color.magenta );
      g.fillRect( 220, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "magenta", 220, 80 - descender );
      
      // Draw the third row of color boxes:
      g.setColor( Color.orange );
      g.fillRect( 10, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "orange", 10, 150 - descender );
      g.setColor( Color.pink );
      g.fillRect( 80, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "pink", 80, 150 - descender );
      g.setColor( Color.red );
      g.fillRect( 150, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "red", 150, 150 - descender );
      g.setColor( Color.white );
      g.fillRect( 220, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "white", 220, 150 - descender );
      
      // Draw the fourth row of color boxes:
      g.setColor( Color.yellow );
      g.fillRect( 10, 220, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "yellow", 10, 220 - descender );
      g.setColor( brown );
      g.fillRect( 80, 220, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "brown", 80, 220 - descender );
      g.setColor( turquoise );
      g.fillRect( 150, 220, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "turquoise", 150, 220 - descender );
      g.setColor( violet );
      g.fillRect( 220, 220, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "violet", 220, 220 - descender );
      
   }
   
}
