/*
 *  File:  MyColorBoxes3.java
 *
 *  Display built-in colors with labels, arrays, and loops
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;

public class MyColorBoxes3 extends Applet {

   // Define some colors:
   private Color brown      = new Color( 0xA5, 0x2A, 0x2A );
   private Color turquoise  = new Color( 0x40, 0xE0, 0xD0 );
   private Color violet     = new Color( 0xEE, 0x82, 0xEE );
   private Color gold       = new Color( 0xFF, 0xD7, 0x00 );
   private Color darkBrown  = new Color( 0x5C, 0x40, 0x33 );
   private Color navy       = new Color( 0x00, 0x00, 0x80 );
   private Color darkPurple = new Color( 0x87, 0x1F, 0x78 );
   
   // Initialize color arrays:
   Color firstRowColor[] = { Color.black, Color.blue, Color.cyan, Color.darkGray };
   Color secondRowColor[] = { Color.gray, Color.green, Color.lightGray, Color.magenta };
   Color thirdRowColor[] = { Color.orange, Color.pink, Color.red, Color.white };
   Color fourthRowColor[] = { Color.yellow, brown, turquoise, violet };
   Color fifthRowColor[] = { gold, darkBrown, navy, darkPurple };
   
   public void paint( Graphics g ) {
      
      // vertical adjustment for color labels:
      int descender = g.getFontMetrics().getDescent();
      
      // Draw the first row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( firstRowColor[j] );
          g.fillRect( 10 + 70*j, 10, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( firstRowColor[j] ), 10 + 70*j, 10 - descender );
      }
      
      // Draw the second row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( secondRowColor[j] );
          g.fillRect( 10 + 70*j, 80, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( secondRowColor[j] ), 10 + 70*j, 80 - descender );
      }
      
      // Draw the third row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( thirdRowColor[j] );
          g.fillRect( 10 + 70*j, 150, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( thirdRowColor[j] ), 10 + 70*j, 150 - descender );
      }
      
      // Draw the fourth row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( fourthRowColor[j] );
          g.fillRect( 10 + 70*j, 220, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( fourthRowColor[j] ), 10 + 70*j, 220 - descender );
      }
      
      // Draw the fifth row of color boxes:
      for ( int j = 0; j < 4; j++ ) {
          g.setColor( fifthRowColor[j] );
          g.fillRect( 10 + 70*j, 290, 50, 50 );
          g.setColor( Color.black );
          g.drawString( toString( fifthRowColor[j] ), 10 + 70*j, 290 - descender );
      }
      
   }

   public String toString( Color c ) {
      
      if ( c.equals( Color.black ) ) {
         return "black";
      } else if ( c.equals( Color.blue ) ) {
         return "blue";
      } else if ( c.equals( Color.cyan ) ) {
         return "cyan";
      } else if ( c.equals( Color.darkGray ) ) {
         return "darkGray";
      } else if ( c.equals( Color.gray ) ) {
         return "gray";
      } else if ( c.equals( Color.green ) ) {
         return "green";
      } else if ( c.equals( Color.lightGray ) ) {
         return "lightGray";
      } else if ( c.equals( Color.magenta ) ) {
         return "magenta";
      } else if ( c.equals( Color.orange ) ) {
         return "orange";
      } else if ( c.equals( Color.pink ) ) {
         return "pink";
      } else if ( c.equals( Color.red ) ) {
         return "red";
      } else if ( c.equals( Color.white ) ) {
         return "white";
      } else if ( c.equals( Color.yellow ) ) {
         return "yellow";
      } else if ( c.equals( brown ) ) {
         return "brown";
      } else if ( c.equals( turquoise ) ) {
         return "turquoise";
      } else if ( c.equals( violet ) ) {
         return "violet";
      } else if ( c.equals( gold ) ) {
         return "gold";
      } else if ( c.equals( darkBrown ) ) {
         return "darkBrown";
      } else if ( c.equals( navy ) ) {
         return "navy";
      } else if ( c.equals( darkPurple ) ) {
         return "darkPurple";
      } else {
         return "unknown";
      }
      
   }
   
}
   
