/*
 *  File:  MyColorBoxes4.java
 *
 *  Display built-in colors with labels, a 2D array, and a nested loop
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;

public class MyColorBoxes4 extends Applet {

   // Define some colors:
   private Color brown      = new Color( 0xA5, 0x2A, 0x2A );
   private Color turquoise  = new Color( 0x40, 0xE0, 0xD0 );
   private Color violet     = new Color( 0xEE, 0x82, 0xEE );
   private Color gold       = new Color( 0xFF, 0xD7, 0x00 );
   private Color darkBrown  = new Color( 0x5C, 0x40, 0x33 );
   private Color navy       = new Color( 0x00, 0x00, 0x80 );
   private Color darkPurple = new Color( 0x87, 0x1F, 0x78 );
   
   // Initialize two-dimensional color array:
   private Color color[][] = {
      { Color.black, Color.blue, Color.cyan, Color.darkGray },
      { Color.gray, Color.green, Color.lightGray, Color.magenta },
      { Color.orange, Color.pink, Color.red, Color.white },
      { Color.yellow, brown, turquoise, violet },
      { gold, darkBrown, navy, darkPurple }
   };
   
   // Initialize two-dimensional array of color strings:
   private String colorString[][] = {
      { "black", "blue", "cyan", "darkGray" },
      { "gray", "green", "lightGray", "magenta" },
      { "orange", "pink", "red", "white" },
      { "yellow", "brown", "turquoise", "violet" },
      { "gold", "darkBrown", "navy", "darkPurple" }
   };
   
   public void paint( Graphics g ) {
      
      // vertical adjustment for color labels:
      int descender = g.getFontMetrics().getDescent();
      
      // Draw rows of color boxes:
      for ( int i = 0; i < color.length; i++ ) {
         for ( int j = 0; j < color[i].length; j++ ) {
           g.setColor( color[i][j] );
           g.fillRect( 10 + 70*j, 10 + 70*i, 50, 50 );
           g.setColor( Color.black );
           g.drawString( colorString[i][j], 10 + 70*j, 10 + 70*i - descender );
         }
      }
      
   }

}
   
