/*
 *  File:  FontMetricsTest.java
 *
 *  Given a string, center the string horizontally in the 
 *  applet window.
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;

public class FontMetricsTest extends Applet {

   private String s;
   
   public void init() {
      
      // The string to be drawn:
      s = "Today is your lucky day!";
      
      // Instantiate a font object:
      Font f = new Font( "Serif", Font.PLAIN, 18 );
      
      // Set the font:
      this.getGraphics().setFont( f );
      
      // Set the background color of the applet:
      this.setBackground( java.awt.Color.cyan );
      
   }
   
   public void paint( Graphics g ) {
      
      // Determine the width of the applet:
      int appletWidth = this.getSize().width;
      
      // Determine the width of the string:
      int stringWidth = g.getFontMetrics().stringWidth( s );
      
      // Calculate the x-coordinate of the string:
      int x = (appletWidth - stringWidth)/2;
      
      // Specify the y-coordinate of the string:
      int y = 50;
      
      // Draw the string at point (x,y):
      g.drawString( s, x, y );
      
   }
   
}
