/*
 *  File:  FontMetricsTest2.java
 *
 *  Given a string, center the string both vertically and
 *  horizontally in the applet window.
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;

public class FontMetricsTest2 extends Applet {

   private String s;
   
   public void init() {
      
      // Get the "stringToDraw" parameter from the HTML document:
      s = getParameter( "stringToDraw" );
      if ( s == null ) s = "Merry Christmas!";
      
      // Instantiate a font object:
      Font f = new Font( "Serif", Font.ITALIC, 24 );
      
      // Set the font:
      this.getGraphics().setFont( f );
      
      // Set the background color of the applet:
      this.setBackground( java.awt.Color.cyan );
      
   }
   
   public void paint( Graphics g ) {
      
      // Get the FontMetrics object associated with this applet:
      FontMetrics fm = g.getFontMetrics();
      
      // Determine the width of the applet:
      int appletWidth = this.getSize().width;
      
      // Determine the width of the string:
      int stringWidth = fm.stringWidth( s );
      
      // Calculate the x-coordinate of the string:
      int x = (appletWidth - stringWidth)/2;
      
      // Determine the height of the applet:
      int appletHeight = this.getSize().height;
      
      // Calculate the height of *any* string:
      int ascent = fm.getAscent();
      int descent = fm.getDescent();
      int stringHeight = ascent + descent;
      
      // Calculate the y-coordinate of the string:
      int y = (appletHeight - stringHeight)/2 + ascent;
      
      // Draw the string at point (x,y):
      g.drawString( s, x, y );
      
   }
   
}
