/*
 *  File:  CheckboxGroupDemo.java
 *
 *  Create some radio buttons
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.Color;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Panel;

public class CheckboxGroupDemo extends java.applet.Applet {

  private int n = 6;  // number of radio buttons
  private Checkbox[] radioButton = new Checkbox[n];
  private CheckboxGroup radioButtons = new CheckboxGroup();
  
  public void init() {
    setBackground( Color.white );
    Color lightBlue = new Color( 0xB0, 0xE0, 0xE6 );
    Color  navyBlue = new Color( 0x19, 0x19, 0x70 );

    String[] colorLabel = new String[n];
    colorLabel[0] = "Red";    colorLabel[1] = "Blue";
    colorLabel[2] = "Yellow"; colorLabel[3] = "Green";
    colorLabel[4] = "Orange"; colorLabel[5] = "Purple";
    
    // Instantiate radio buttons and add them to a panel:
    Panel radioButtonPanel = new Panel();
    radioButtonPanel.setBackground( lightBlue );
    for ( int i = 0; i < n; i++ ) {
      radioButton[i] = new Checkbox( colorLabel[i], radioButtons, false );
      radioButton[i].setForeground( navyBlue );
      radioButton[i].setBackground( lightBlue );
      radioButtonPanel.add( radioButton[i] );
    }
    radioButtons.setSelectedCheckbox( radioButton[0] );
    
    add( radioButtonPanel );
  }

}
