/*
 *  File:  ListDemo.java
 *
 *  Create a scrolling list of fonts
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.List;
import java.awt.Color;
import java.awt.Toolkit;

public class ListDemo extends java.applet.Applet {

  // Allow five visible items in the list and 
  // allow for multiple selections:
  private List fontList = new List( 5, true );
  
  public void init() {
    setBackground( Color.white );

    // Color the scrolling list:
    Color lightBlue = new Color( 0xB0, 0xE0, 0xE6 );
    Color  navyBlue = new Color( 0x19, 0x19, 0x70 );
    fontList.setBackground( lightBlue );
    fontList.setForeground(  navyBlue );
    
    // Get list of system fonts:
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    String fonts[] = toolkit.getFontList();
      
    // Add fonts to the scrolling list:
    for ( int i = 0; i < fonts.length; i++ ) {
      fontList.addItem( fonts[i] );
    }
    
    add( fontList );
  }
  
}
