/*
 *  File:  ScrollbarDemo.java
 *
 *  Create a scrollbar (i.e., a slide control)
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.Label;
import java.awt.Scrollbar;
import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.Font;

public class ScrollbarDemo extends java.applet.Applet {
  
  private Label labelLeft, labelRight;
  private Scrollbar scrollbar;

  public void init() {
    setBackground( Color.white );
    Color lightBlue = new Color( 0xB0, 0xE0, 0xE6 );
    
    int min = 0;    // minimum value of scrollbar
    labelLeft = new Label( String.valueOf( min ) );
    labelLeft.setAlignment( Label.LEFT );
    labelLeft.setFont( new Font( "Serif", Font.PLAIN, 12 ) );
    
    int max = 100;  // maximum value of scrollbar
    labelRight = new Label( String.valueOf( max ) );
    labelRight.setAlignment( Label.RIGHT );
    labelRight.setFont( new Font( "Serif", Font.PLAIN, 12 ) );
    
    int pos = 50;   // initial position of scrollbox    
    int orientation = Scrollbar.HORIZONTAL;
    int size = 5;   // relative size of the scrollbox
    scrollbar = new Scrollbar( orientation, pos, size, min, max );
    scrollbar.setBlockIncrement(10);
    scrollbar.setBackground( lightBlue );
    
    // Add components to the applet:
    setLayout( new BorderLayout() );
    add( labelLeft, BorderLayout.WEST ); 
    add( labelRight, BorderLayout.EAST ); 
    add( scrollbar, BorderLayout.SOUTH );
    
  }

}
