/*
 *  File:  OctagonTest.java
 *
 *  Draw a regular octagon
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Polygon;
import java.awt.Point;

public class OctagonTest extends Applet {

   // create a reference to an octagon:
   private Octagon octagon;
   
   // create references to eight points:
   private Point p1, p2, p3, p4, p5, p6, p7, p8;
   
   public void init() {
   
      // instantiate eight points (the vertices of a regular octagon):
      p1 = new Point(  69,  25 );
      p2 = new Point( 131,  25 );
      p3 = new Point( 175,  69 );
      p4 = new Point( 175, 131 );
      p5 = new Point( 131, 175 );
      p6 = new Point(  69, 175 );
      p7 = new Point(  25, 131 );
      p8 = new Point(  25,  69 );
      
      // instantiate an octagon like this...
      octagon = new Octagon( p1, p2, p3, p4, p5, p6, p7, p8 );
      
      // ...or like this:
      octagon = new Octagon();
      octagon.addPoint( p1 );
      octagon.addPoint( p2 );
      octagon.addPoint( p3 );
      octagon.addPoint( p4 );
      octagon.addPoint( p5 );
      octagon.addPoint( p6 );
      octagon.addPoint( p7 );
      octagon.addPoint( p8 );
      // (see below for the definition of addPoint( Point ) )

   }
   
   public void paint( Graphics g ) {

      // fill the octagon:
      g.setColor( Color.red );
      octagon.fill( g );

   }
   
}

// An octagon is a polygon with eight sides:
class Octagon extends Polygon {

   // Octagon constructor #1:
   public Octagon() {
      // invoke the constructor of the superclass Polygon:
      super();
   }

   // Octagon constructor #2:
   public Octagon( int x1, int y1, 
                   int x2, int y2, 
                   int x3, int y3, 
                   int x4, int y4,
                   int x5, int y5, 
                   int x6, int y6, 
                   int x7, int y7, 
                   int x8, int y8  ) {
 
      // invoke the constructor of the superclass Polygon:
      super();
      
      // the 'this' reference is optional:
      this.addPoint( x1, y1 );
      this.addPoint( x2, y2 );
      this.addPoint( x3, y3 );
      this.addPoint( x4, y4 );
      this.addPoint( x5, y5 );
      this.addPoint( x6, y6 );
      this.addPoint( x7, y7 );
      this.addPoint( x8, y8 );
 
   }

   // Octagon constructor #3:
   public Octagon( Point p1, 
                   Point p2, 
                   Point p3, 
                   Point p4,
                   Point p5, 
                   Point p6, 
                   Point p7, 
                   Point p8  ) {
 
      // invoke Octagon constructor #2:
      this( p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y,
            p5.x, p5.y, p6.x, p6.y, p7.x, p7.y, p8.x, p8.y  );
 
   }

   // Instance methods:
   public void draw( Graphics g ) {
      g.drawPolygon( this );
   }
   public void fill( Graphics g ) {
      g.fillPolygon( this );
   }
   
   // Overload Polygon.addPoint( int, int ):
   public void addPoint( Point p ) {
      super.addPoint( p.x, p.y );
   }
   
}
