/*
 *  File:  OctagonTest2.java
 *
 *  Draw a quadrilateral inside a regular octagon (an exercise)
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Point;

public class OctagonTest2 extends Applet {

   // create a reference to an octagon:
   private Octagon octagon;
   
   // create a reference to a quadrilateral:
   private Quadrilateral quad;

   // create references to eight points:
   private Point p1, p2, p3, p4, p5, p6, p7, p8;
   
   public void init() {
   
      // instantiate eight points (the vertices of a regular octagon):
      p1 = new Point(  69,  25 );
      p2 = new Point( 131,  25 );
      p3 = new Point( 175,  69 );
      p4 = new Point( 175, 131 );
      p5 = new Point( 131, 175 );
      p6 = new Point(  69, 175 );
      p7 = new Point(  25, 131 );
      p8 = new Point(  25,  69 );
      
      // instantiate a regular octagon:
      octagon = new Octagon( p1, p2, p3, p4, p5, p6, p7, p8 );
      
      // instantiate a quadrilateral inside the octagon:
      quad = new Quadrilateral( p1.x, p1.y, p3.x, p3.y, 
                                p5.x, p5.y, p7.x, p7.y );
      
   }
   
   public void paint( Graphics g ) {

      // fill the octagon:
      g.setColor( Color.red );
      octagon.fill( g );

      // draw the quadrilateral:
      g.setColor( Color.yellow );
      quad.draw( g );

   }
   
}
