/*
 *  File:  OvalTest3.java
 *
 *  Draw a dart board
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class OvalTest3 extends Applet {

   private int x = 75;  // center of dart board:  x-coordinate
   private int y = 75;  // center of dart board:  y-coordinate
   private int r = 70;  // radius of dart board
   private int w =  4;  // width of bands
   
   public void paint( Graphics g ) {
   
      // draw the outer band:
      g.drawOval( x - r, y - r, 2*r, 2*r );
      g.drawOval( x - r + w, y - r + w, 2*(r - w), 2*(r - w) );
      
      // draw the middle band:
      g.drawOval( x - r/2 - w, y - r/2 - w, r + 2*w, r + 2*w );
      g.drawOval( x - r/2, y - r/2, r, r );
      
      // draw the spokes:
      for ( int n = 0; n < 16; n++ ) {
         double theta = 2 * Math.PI * n/16;
         int xn = ( int ) Math.round( r * Math.cos( theta ) );
         int yn = ( int ) Math.round( r * Math.sin( theta ) );
         g.drawLine( x, y, xn + x, yn + y );
      }
      
      // draw the bullseye:
      g.setColor( getBackground() );
      g.fillOval( x - 2*w, y - 2*w, 4*w, 4*w );
      g.setColor( getForeground() );
      g.drawOval( x - 2*w, y - 2*w, 4*w, 4*w );
      g.drawOval( x - w, y - w, 2*w, 2*w );
      
   }
   
}
