/* MovableObject.java */

import java.awt.*;

// This class is "abstract" since it defines abstract methods:
public abstract class MovableObject extends Point {

  // The Point class defines public variables  x  and  y .
  
  // Instance variables:
  protected int dx, dy;    // displacement of object
  protected Color color;   // color of object
  
  // Constructor:
  public MovableObject( int new_x, int new_y ) {
    // Invoke the constructor of the superclass:
    super( new_x, new_y );
    dx = 1; dy = 1;
    color = Color.black;
  }
  
  // In addition to the following accessors and mutators,
  // the Point class also defines methods getLocation(),
  // setLocation( int, int ), and setLocation( Point ):
  public int getX() { return x; }
  public int getY() { return y; }
  public void setDelta( int new_dx, int new_dy ) {
    dx = new_dx; dy = new_dy;
  }
  public Color getColor() { return color; }
  public void setColor( Color new_color ) {
    color = new_color;
  }
  
  // The Point class defines a method translate( int, int ).
  // Here we define an alternative form of that method:
  public void translate() {
    x += dx; y += dy;
  }
  
  // Class methods to be implemented by subclasses:
  public abstract void paint( Graphics g );
  public abstract void checkBoundary( Rectangle rect );
  public abstract boolean contains( int some_x, int some_y );

} // end of MovableObject class

