/* MovableRectangle.java */

import java.awt.*;

public class MovableRectangle extends MovableObject {
  
  // Instance variables:
  protected int w, h;      // width and height

  // Constructor:
  public MovableRectangle( int new_x, int new_y, int new_w, int new_h ) {
    // Invoke the constructor of the superclass MovableObject:
    super( new_x, new_y );
    w = new_w; h = new_h;
  }

  // Implement MovableObject.paint( Graphics ):
  public void paint( Graphics g ) {
    g.setColor( color );
    g.fillRect( x, y, w, h );
  }
  
  // Implement MovableObject.checkBoundary( Rectangle ):
  public void checkBoundary( Rectangle r ) {
    // Calculate new location:
    int nx = x + dx, ny = y + dy;
    // Check if new location out of bounds:
    if ( (nx < r.x) || (nx + w > r.x + r.width) ) dx = -dx;
    if ( (ny < r.y) || (ny + h > r.y + r.height) ) dy = -dy;
  }

  // Implement MovableObject.contains( int, int ):
  public boolean contains( int some_x, int some_y ) {
    Rectangle r = new Rectangle( x, y, w, h );
    return r.contains( some_x, some_y );
  }

} // end of MovableRectangle class

