/* MovableString.java */

import java.awt.*;

public class MovableString extends MovableObject {

  // Instance variables:
  private int w, h;
  protected String s;
  protected Font f;
  
  // Constructor:
  public MovableString( int new_x, int new_y, String new_s ) {
    // Invoke MovableObject's constructor:
    super( new_x, new_y );
    s = new_s;
    // A default font:
    setFont( new Font( "SansSerif", Font.PLAIN, 36 ) );
  }
  
  // Accessors and mutators:
  public void setString( String new_s ) {
    s = new_s;
  }
  public void setFont( Font new_f ) {
    f = new_f;
  }
  
  // Implement MovableObject.paint( Graphics ):
  public void paint( Graphics g ) {
    g.setColor( color );
    g.setFont(f);
    FontMetrics fm = g.getFontMetrics();
    w = fm.stringWidth(s);  // width of string in current font
    h = fm.getHeight() - fm.getDescent();
    g.drawString( s, x, y + h );
  }
  
  // Implement MovableObject.contains( int, int ):
  public boolean contains( int some_x, int some_y ) {
    Rectangle r = new Rectangle( x, y, w, h );
    return r.contains( some_x, some_y );
  }

  // Implement MovableObject.checkBoundary( Rectangle ):
  public void checkBoundary( Rectangle r ) {
    int nx = x + dx, ny = y + dy;
    if ( (nx < r.x) || (nx + w > r.x + r.width) ) dx = -dx;
    if ( (ny < r.y) || (ny + h > r.y + r.height) ) dy = -dy;
  }
  
}
