/* MovableTriangle.java */

import java.awt.*;

public class MovableTriangle extends MovableRectangle {

  public MovableTriangle( int new_x, int new_y, int new_w, int new_h ) {
    // Call MovableRectangle's constructor:
    super( new_x, new_y, new_w, new_h );
  }
  
  // Override MovableRectangle.paint( Graphics ):
  public void paint( Graphics g ) {
    // Compute the vertices of the triangle:
    int xpoints[] = { x, x + w, x + w/2 };
    int ypoints[] = { y + h, y + h, y };
    // Draw the triangle:
    g.setColor( color );
    g.fillPolygon( xpoints, ypoints, 3 );
  }
  
  // Override MovableRectangle.contains( int, int ):
  public boolean contains( int some_x, int some_y ) {
    // Compute the vertices of the triangle:
    int xpoints[] = { x, x + w, x + w/2 };
    int ypoints[] = { y + h, y + h, y };
    // Construct a polygon:
    Polygon p = new Polygon( xpoints, ypoints, 3 );
    return p.contains( some_x, some_y );
  }

}
