/* MovingRectangles.java */

import java.awt.*;
import java.applet.*;

public class MovingRectangles extends Applet implements Runnable {

  // Instance variables:
  private Thread thread;
  private MovableObject object[] = new MovableObject[2];
  private int x[] = { 10, 200 };  // initial x coordinates
  private int y[] = { 10,  10 };  // initial y coordinates

  // Override java.applet.Applet.init:
  public void init () {
    setBackground( Color.black );

    object[0] = new MovableRectangle( x[0], y[0], 100, 100 );
    object[0].setDelta( 1, 1 );
    object[0].setColor( Color.red );
    
    object[1] = new MovableRectangle( x[1], y[1], 100, 100 );
    object[1].setDelta( -1, 1 );
    object[1].setColor( Color.blue );
  }

  // Override java.applet.Applet.start:
  public void start() {
    if ( thread == null ) {
      // Reinitialize (x,y) coordinates:
      object[0].setLocation( x[0], y[0] );
      object[1].setLocation( x[1], y[1] );
      // Start a new thread:
      thread = new Thread( this );
      thread.start();
    }
  }

  // Override java.applet.Applet.stop:
  public void stop() {
    if ( thread != null ) {
      thread.stop();
      thread = null ;
    }
  }

  // Implement java.lang.Runnable.run:
  public void run() {
    while ( thread != null ) {
      repaint();
      try {
        Thread.sleep(20);
      } catch ( InterruptedException e ) {
        // Do nothing   
      };
    }
  }

  // Override java.awt.Component.update:
  public void update( Graphics g ) {
    // Get the size of this applet and color it black:
    g.setColor( Color.black );
    g.fillRect( 0, 0, getSize().width, getSize().height );
    // Move each object:
    for ( int i = 0; i < object.length; i++ ) {
      object[i].translate();
    }
    paint(g);
  }

  // Override java.awt.Component.paint:
  public void paint( Graphics g ) {
    // Paint each object:
    for ( int i = 0; i < object.length; i++ ) {
      object[i].paint(g);
    }
  }

}

