/*
 *  File:  DrawableLine.java
 *
 *  A line class
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.*;

public class DrawableLine extends DrawableObject {

  public DrawableLine( int new_x1, int new_y1, int new_x2, int new_y2 ) {
    super( new_x1, new_y1, new_x2, new_y2 );
  }

  public void paint( Graphics g ) {
    g.drawLine( x1, y1, x2, y2 );
  }
  
  // Return true if a point (x,y) lies on the line segment:
  public boolean contains( int x, int y ) {
    return ( x >= Math.min( x1, x2 ) && x <= Math.max( x1, x2 ) &&
             y >= Math.min( y1, y2 ) && y <= Math.max( y1, y2 ) &&
             (y - y2) * (x2 - x1) == (y2 - y1) * (x - x2) );
  }

}

