/*
 *  File:  DrawableObject.java
 *
 *  The superclass of all drawable objects
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.*;

public abstract class DrawableObject {

  protected int x1, y1, x2, y2;
  protected boolean fill;
  protected Color color;

  public DrawableObject( int new_x1, int new_y1, int new_x2, int new_y2 ) {
    x1 = new_x1; y1 = new_y1;
    x2 = new_x2; y2 = new_y2;
    fill = false;
    color = Color.black;
  }

  public int getX() { return x1; }
  public int getY() { return y1; }
  
  public void setEndpoint( int new_x2, int new_y2 ) {
    x2 = new_x2; y2 = new_y2;
  }
  
  public void setFill( boolean new_fill ) {
    fill = new_fill;
  }

  public Color getColor() { return color; }

  public abstract void paint( Graphics g );

  public abstract boolean contains( int x, int y );

}
