/*
 *  File:  DrawableOval.java
 *
 *  An oval class
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.*;

public class DrawableOval extends DrawableRectangle {

  public DrawableOval( int new_x1, int new_y1, int new_x2, int new_y2 ) {
    super( new_x1, new_y1, new_x2, new_y2 );
  }

  public void paint( Graphics g ) {
    int x = Math.min( x1, x2 );
    int y = Math.min( y1, y2 );
    int w = Math.abs( x2 - x1 );
    int h = Math.abs( y2 - y1 );
    g.setColor( color );
    if ( fill ) {
      g.fillOval( x, y, w, h );
    } else {
      g.drawOval( x, y, w, h );
    }
  }
  
}
