/*
 *  File:  DrawableRectangle.java
 *
 *  A rectangle class
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.*;

public class DrawableRectangle extends DrawableObject {

  public DrawableRectangle( int new_x1, int new_y1, int new_x2, int new_y2 ) {
    super( new_x1, new_y1, new_x2, new_y2 );
  }

  public void paint( Graphics g ) {
    int x = Math.min( x1, x2 );
    int y = Math.min( y1, y2 );
    int w = Math.abs( x2 - x1 );
    int h = Math.abs( y2 - y1 );
    g.setColor( color );
    if ( fill ) {
      g.fillRect( x, y, w, h );
    } else {
      g.drawRect( x, y, w, h );
    }
  }

  public boolean contains( int some_x, int some_y ) {
    int x = Math.min( x1, x2 );
    int y = Math.min( y1, y2 );
    int w = Math.abs( x2 - x1 );
    int h = Math.abs( y2 - y1 );
    Rectangle r = new Rectangle( x, y, w, h );
    return r.contains( some_x, some_y );
  }
  
}
