/*
 *  File:  DrawableRoundRect.java
 *
 *  A rounded rectangle class
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.*;

public class DrawableRoundRect extends DrawableRectangle {

  // Instance variables:
  protected int arcW, arcH;  // arcWidth and arcHeight
  
  public DrawableRoundRect( int new_x1, int new_y1, int new_x2, int new_y2 ) {
    super( new_x1, new_y1, new_x2, new_y2 );
    arcW = 100; arcH = 50;
  }
  
  public void setArc( int new_arcW, int new_arcH ) {
    arcW = new_arcW; arcH = new_arcH;
  }

  public void paint( Graphics g ) {
    int x = Math.min( x1, x2 );
    int y = Math.min( y1, y2 );
    int w = Math.abs( x2 - x1 );
    int h = Math.abs( y2 - y1 );
    g.setColor( color );
    if ( fill ) {
      g.fillRoundRect( x, y, w, h, arcW, arcH );
    } else {
      g.drawRoundRect( x, y, w, h, arcW, arcH );
    }
  }
  
}
