/*
 *  File:  Drawable.java
 *
 *  Drawable interface
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Component;

public interface Drawable {

   public Color getColor();
   public void setColor( Color color );
   
   public void draw( Graphics g );
   public void draw( Component c );
   
   public void fill( Graphics g );
   public void fill( Component c );
   
}
