/*
 *  File:  DrawablePolygonTest1.java
 *
 *  Rotate a regular octagon
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Point;

public class DrawablePolygonTest1 extends Applet {

   // create a reference to an octagon:
   private Octagon octagon;
   
   // create references to eight points:
   private Point p1, p2, p3, p4, p5, p6, p7, p8;
   
   // create a reference to the point of rotation:
   private Point rotationPoint;
   
   public void init() {
   
      // instantiate eight points (the vertices of a regular octagon):
      p1 = new Point( 269, 225 );
      p2 = new Point( 331, 225 );
      p3 = new Point( 375, 269 );
      p4 = new Point( 375, 331 );
      p5 = new Point( 331, 375 );
      p6 = new Point( 269, 375 );
      p7 = new Point( 225, 331 );
      p8 = new Point( 225, 269 );
      
      // instantiate a regular octagon:
      octagon = new Octagon( p1, p2, p3, p4, p5, p6, p7, p8 );
      
      // fix the point of rotation:
      java.awt.Rectangle r = octagon.getBounds();
      rotationPoint = new Point( r.x, r.y );
      
   }
   
   public void paint( Graphics g ) {

      // make a copy of the octagon:
      Octagon octagon = this.octagon;
      
      // fill the octagon:
      octagon.setColor( Color.red );
      octagon.fill( g );

      // rotate and fill the octagon:
      octagon.rotate( Math.PI/2, rotationPoint ).fill( g );

      // change the color, rotate, and fill the octagon:
      octagon.setColor( Color.yellow );
      octagon.rotate( Math.PI/2, rotationPoint ).fill( g );
      octagon.rotate( Math.PI/2, rotationPoint ).fill( g );

   }
   
}
