/*
 *  File:  DrawablePolygonTest2.java
 *
 *  Animate a regular octagon
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Point;

public class DrawablePolygonTest2 extends Applet implements Runnable {

   // create a reference to a thread:
   private Thread thread;
 
   // create a reference to an octagon:
   private Octagon octagon;
   
   // create references to eight points:
   private Point p1, p2, p3, p4, p5, p6, p7, p8;
   
   // create a reference to the point of rotation:
   private Point rotationPoint;
   
   public void init() {
   
      // instantiate eight points (the vertices of a regular octagon):
      p1 = new Point( 269, 225 );
      p2 = new Point( 331, 225 );
      p3 = new Point( 375, 269 );
      p4 = new Point( 375, 331 );
      p5 = new Point( 331, 375 );
      p6 = new Point( 269, 375 );
      p7 = new Point( 225, 331 );
      p8 = new Point( 225, 269 );
      
      // instantiate a regular octagon:
      octagon = new Octagon( p1, p2, p3, p4, p5, p6, p7, p8 );
      
      // fix the point of rotation:
      java.awt.Rectangle r = octagon.getBounds();
      rotationPoint = new Point( r.x, r.y );
      
   }
   
   // Override java.applet.Applet.start():
   public void start() {
      if ( thread == null ) {
        // Start a new thread:
        thread = new Thread( this );
        thread.start();
      }
   }
 
   // Override java.applet.Applet.stop():
   public void stop() {
      if ( thread != null ) {
        thread.stop();
        thread = null;
      }
   }
 
   // Implement java.lang.Runnable.run():
   public void run() {
      while ( thread != null ) {
         repaint();
         try {
            // sleep for one second:
            Thread.sleep( 1000 );
         } catch ( InterruptedException e ) {
            // Do nothing   
         };
      }
   }

   public void paint( Graphics g ) {

      // make a copy of the octagon:
      Octagon octagon = this.octagon;
      
      // erase the current octagon:
      octagon.setColor( getBackground() );
      octagon.fill( g );
      
      // rotate and fill a new octagon:
      octagon.setColor( Color.green );
      octagon.rotate( Math.PI/16, rotationPoint ).fill( g );

   }

}
