/*
 *  File:  HexagonTest.java
 *
 *  Rotate a regular hexagon
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;

public class HexagonTest extends Applet {

   // create a reference to a hexagon:
   private Hexagon hexagon;
   
   // center of regular hexagon:
   private int x, y;
   
   // radius of regular hexagon:
   private int r;

   // number of rotations:
   private int n = 7;
   
   // rotation angle:
   private double theta = 2 * Math.PI / n;
   
   public void init() {
     x = y = Math.min( getSize().width, getSize().height )/2;
     r = x - 15;
   }

   public void paint( Graphics g ) {

      // instantiate a regular hexagon:
      hexagon = new Hexagon( x, y, r );
    
      // rotate and draw:
      for ( int i = 0; i < n; i++ ) {
         hexagon.centerRotate( theta ).draw( g );
      }

   }
   
}
