/*
 *  File:  MovablePolygon.java
 *
 *  Movable polygon class for Java 1.1
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.*;

public class MovablePolygon extends DrawablePolygon {

   // Displacement in the  x  and  y  directions:
   private int dx, dy;

   // MovablePolygon constructor #1:
   public MovablePolygon() {

      // invoke the no-argument constructor of the superclass:
      super();

      dx = dy = 1;  //default values

   }

   // MovablePolygon constructor #2:
   public MovablePolygon( int[] xpoints, int[] ypoints, int npoints ) {
       
      // invoke a constructor of the superclass:
      super( xpoints, ypoints, npoints );
      
      dx = dy = 1;  //default values

   }

   // MovablePolygon constructor #3:
   public MovablePolygon( Point[] points, int npoints ) {
      
      // invoke a constructor of the superclass:
      super( points, npoints );
      
      dx = dy = 1;  //default values

   }

   /*
    *  MovablePolygon constructor #4
    *
    *  A regular n-gon with center (x,y) and radius r
    *
    */
    
   public MovablePolygon( int x, int y, int r, int n ) {
       
      // invoke a constructor of the superclass:
      super( x, y, r, n );
      
      dx = dy = 1;  //default values

   }

   public void setDelta( int dx, int dy ) {
      this.dx = dx; this.dy = dy;
   }

   public void move() {
      // the translate method is inherited from Polygon:
      this.translate( dx, dy );
   }

   public void checkBounds( java.awt.Rectangle r ) {

      java.awt.Rectangle bb = this.getBounds();

      int w = bb.width, h = bb.height;
      int nx = bb.x + dx, ny = bb.y + dy;

      if ( ( nx < r.x ) || ( nx + w > r.x + r.width ) )  dx *= -1;
      if ( ( ny < r.y ) || ( ny + h > r.y + r.height ) )  dy *= -1;

   }

}
