/*
 *  File:  ParallelogramTest.java
 *
 *  Draw a parallelogram
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class ParallelogramTest extends Applet {

   // create references to two parallelograms:
   private Parallelogram parallelogram1, parallelogram2;
   
   public void init() {
   
      // top left-hand corner of the parallelogram:
      int x = 125, y = 50;
      // side lengths:
      int side1 = 75, side2 = 50;
      // included angle:
      double alpha = 2 * Math.PI/3;
      // rotation angle:
      double theta = Math.PI;
      
      // instantiate two parallelograms:
      parallelogram1 = 
         new Parallelogram( x, y, side1, side2, alpha );
      parallelogram2 = 
         new Parallelogram( x, y, side1, side2, alpha, theta );
      /*
       *  here's another way to compute parallelogram2:
       *  parallelogram2 = parallelogram1.rotate( theta );
       *
       */

      // color the parallelograms:
      parallelogram1.setColor( Color.green );
      parallelogram2.setColor( Color.yellow );

   }
   
   public void paint( Graphics g ) {

      // fill the first parallelogram:
      parallelogram1.fill( g );

      // fill the second parallelogram:
      parallelogram2.fill( g );

   }
   
}
