/*
 *  File:  RhombusTest.java
 *
 *  Draw a rhombus
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class RhombusTest extends Applet {

   // create a reference to a rhombus:
   private Rhombus rhombus;
   
   // rhombus parameters:
   private final int length = 20;
   private final double alpha = 3 * Math.PI/5;
   private int d, h, xoffset;
   
   public void init() {
   
      // a prototype rhombus:
      rhombus = new Rhombus( 0, 0, length, alpha );
      d = rhombus.getDisplacement();
      h = rhombus.getHeight();
      xoffset = ( d < 0 ) ? 0: 8*d; 

   }

   public void paint( Graphics g ) {

      g.setColor( Color.magenta );

      // local variables:
      int x, y;
      
      // draw an 8x8 checkerboard of rhombi:
      y = 0;
      for ( int i = 0; i < 8; i++ ) {
         x = xoffset - i*d; y += h;
         for ( int j = 0; j < 8; j++ ) {
            x += length;
            rhombus = new Rhombus( x, y, length, alpha );
            rhombus.draw( g );
         }
      }

   }
   
}
