/*
 *  File:  FileListEnumerator.java
 *
 *  A subclass of Enumeration used in conjunction with Concatenate.java
 *
 */

import java.util.Enumeration;
import java.io.InputStream;
import java.util.NoSuchElementException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

class FileListEnumerator implements Enumeration {

  String[] listOfFiles;
  int current = 0;

  FileListEnumerator( String[] listOfFiles ) {
    this.listOfFiles = listOfFiles;
  }

  public boolean hasMoreElements() {
    return ( current < listOfFiles.length );
  }

  public Object nextElement() {
    InputStream in = null;
    if ( !hasMoreElements() )
      throw new NoSuchElementException( "No more files!" );
    else {
      try {
        String nextElement = listOfFiles[ current++ ];
        in = new FileInputStream( nextElement );
      } catch ( FileNotFoundException e ) {
        System.out.println( "ListOfFiles: " + e );
      }
    }
    return in;
  }

} // end class FileListEnumerator
