import java.awt.*;

/**
 * GBC - A convenience class built to aid in implementing GridBagLayouts.
 *
 * @author Jayme Manning
 * @version $Revision: 1.1 $<BR>
 *          $Date: 1998/12/15 05:04:38 $<P>
 *
 * <PRE>
 * $Log: GBC.java,v $
 * Revision 1.1  1998/12/15 05:04:38  cps606
 * GBC - Created convenience class to assist with setting GridBagConstraints.
 *
 * </PRE>
 *
 * <P ALIGN=CENTER><B>
 *                              Paul Kronenwetter<BR>
 * 				  Jayme Manning<BR>
 *                      Trade Secrets and/or Confidential<BR>
 *                      Commercial or Financial Information<BR>
 *                   Exempt From Disclosure Under the Freedom<BR>
 *                      of Information Act (5 USC 552(b)(3)<BR>
 *                  and 5 USC 552(b)(4)) and Under 18 USC 1905<BR>
 * </B></P>
 * <P ALIGN=CENTER>
 *                      <B>Proprietary Information Notice</B><BR>
 * <HL ALIGN=CENTER>
 * This document contains information proprietary to, and is the
 * sole property of, Paul Kronenwetter and Jayme Manning.  It shall not
 * be reproduced, used or disclosed in any manner or for any purpose 
 * not authorized in writing by both Paul Kronenwetter and 
 * Jayme Manning, and except, as retention may be so authorized, it
 * shall be returned to Paul Kronenwetter or Jayme Manning upon
 * request.</P>
 * <P ALIGN=CENTER><B>&copy 1998 by Paul Kronenwetter and Jayme
 * Manning<BR> All Rights Reserved</B></P>
 *
 */
public class GBC extends GridBagConstraints
{
	/**
	 * GBC - Simple constructor, no data initialization, just call
	 * the parent constructor.
	 */
	public GBC()
	{
		// Call the parent Constructor
		super();
	}

       /**
        * setupConstraints - Convenience method used to facilitate the 
        * construction of parameters for the GridBagLayout.
        * 
        * @param xCoord The x coordinate for the grid location.
        * @param yCoord The y coordinate for the grid location.
        * @param width How many columns this component will span.
        * @param height How many rows this component will span.
        * @param xWieght The weight of this component in the x vector.
        * @param yWieght The weight of this component in the y vector.
        * @param position The relative positioning of this component.
        * @param newFill The fill parameters for this component.
        * @param newPad Uniform ammount of space to add to a components border.
        */
        public void setupConstraints(int xCoord, int yCoord, int width,
                int height, int xWeight, int yWeight, int position, 
                int newFill, int newPad)
        {
                gridx = xCoord;
                gridy = yCoord;
                gridwidth = width;
                gridheight = height;
                weightx = xWeight;
                weighty = yWeight;
                anchor = position;
                fill = newFill;
                insets = new Insets(newPad,newPad,newPad,newPad);
        }
}
