import java.awt.*;
import java.awt.event.*;
import java.lang.Integer;
import java.util.Calendar;
import java.io.File;
import javax.swing.*;
import javax.swing.event.*;

/**
 * TextScrollPane - Scrolling pane for text entry.
 *
 * @author Paul Kronenwetter
 * @author Jayme Manning
 *
 * <P ALIGN=CENTER><B>
 *                              Paul Kronenwetter<BR>
 * 				  Jayme Manning<BR>
 *                      Trade Secrets and/or Confidential<BR>
 *                      Commercial or Financial Information<BR>
 *                   Exempt From Disclosure Under the Freedom<BR>
 *                      of Information Act (5 USC 552(b)(3)<BR>
 *                  and 5 USC 552(b)(4)) and Under 18 USC 1905<BR>
 * </B></P>
 * <P ALIGN=CENTER>
 *                      <B>Proprietary Information Notice</B><BR>
 * <HL ALIGN=CENTER>
 * This document contains information proprietary to, and is the
 * sole property of, Paul Kronenwetter and Jayme Manning.  It shall not
 * be reproduced, used or disclosed in any manner or for any purpose 
 * not authorized in writing by both Paul Kronenwetter and 
 * Jayme Manning, and except, as retention may be so authorized, it
 * shall be returned to Paul Kronenwetter or Jayme Manning upon
 * request.</P>
 * <P ALIGN=CENTER><B>&copy 1998 by Paul Kronenwetter and Jayme
 * Manning<BR> All Rights Reserved</B></P>
 *
 * @version
 * $Revision: 1.2 $ <br>
 * $Date: 1998/12/17 17:16:20 $ <p>
 * 
 * <pre>
 * $Log: TextScrollPane.java,v $
 * Revision 1.2  1998/12/17 17:16:20  cps606
 * Added method to retrieve text.
 *
 * Revision 1.1  1998/12/17 03:25:50  cps606
 * Created to deal with creating a scrolling text panel.
 *
 * </pre>
 */

public class TextScrollPane extends JScrollPane {
  private final String rcsId="$Id: TextScrollPane.java,v 1.2 1998/12/17 17:16:20 cps606 Exp $";
  private JScrollPane scrollPane;
  private JTextArea textArea;

  /**
   * Replies to requests for this component's preferred size.
   *
   * @return The preferred size of this panel in a Dimension.
   */
  public Dimension getPreferredSize()
  {
	return new Dimension(250,150);
  }
 

// Start of private methods and classes.

  /**
   * This is the method that does the "real" work of setting up the
   * variables and other objects needed to make this panel work.
   */
  public TextScrollPane() {

    // Create the text area...
    textArea = new JTextArea();
    add(textArea);
    setViewportView(textArea);
    setHorizontalScrollBarPolicy(HORIZONTAL_SCROLLBAR_NEVER);
    setVerticalScrollBarPolicy(VERTICAL_SCROLLBAR_ALWAYS);
    setVisible(true);
  }

  /**
   * clearText - Method used to clear the JTextArea for further processing.
   */
  public void clearText()
  {
	textArea.setText("");
  }

  /** 
   * getText - Method used to retrieve the text of our embedded JTextArea 
   * component.
   *
   * @return String - The text from the JTextArea.
   */
  public String getText()
  {
	return textArea.getText();
  }
}
