# Makefile for the TextEditor Java Bean.

CLASSFILES= \
	sunw/demo/TextEditor/TextEditor.class \
	sunw/demo/TextEditor/TextEditorBeanInfo.class 
DATAFILES= \
	sunw/demo/TextEditor/ImageScaleIconColor16.gif \
	sunw/demo/TextEditor/ImageScaleIconColor32.gif \
	sunw/demo/TextEditor/ImageScaleIconMono16.gif \
	sunw/demo/TextEditor/ImageScaleIconMono32.gif \
	sunw/demo/TextEditor/faces.gif

JARFILE= /usr/npac/BDK/jars/TextEditor.jar

all: $(JARFILE)

# Build a new JAR file with an appropriate manifest.

$(JARFILE): $(CLASSFILES) $(DATAFILES)
	echo "Name: sunw/demo/TextEditor/TextEditor.class">> manifest.tmp
	echo "Java-Bean: True" >> manifest.tmp
	jar cfm $(JARFILE) manifest.tmp sunw/demo/TextEditor/*.class $(DATAFILES)
	@/bin/rm manifest.tmp

.SUFFIXES: .java .class

{sunw/demo/TextEditor}.java{sunw/demo/TextEditor}.class :
%.class: %.java
	export CLASSPATH; CLASSPATH=. ; \
	javac $<

clean:
	/bin/rm -f sunw/demo/TextEditor/*.class
	/bin/rm -f $(JARFILE)


