/* myDatabase.java
 * This class provides methods to access the Oracle database via JDBC
 * API:  void open()
 *    void find(String word, Stringbuffer s1, Stringbuffer s2, Stringbuffer s3)
 *    void close ()
 * Exceptions are printed.
 */

import java.sql.*;
import java.util.Properties;

class myDatabase {
  
  private Connection conn;
  
  public void open() {
    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
      conn = DriverManager.getConnection
          ("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe", "njm", "njm");
      System.out.println("Connection Open");
    }
    catch (Exception e) { System.err.println("Error connection: " + e);}
  }
  
  public void find(String word, StringBuffer s1, StringBuffer s2, StringBuffer s3) {
    
    try {
      System.out.println("name passed = " + word);
      // binding input parameters to SQL call
      PreparedStatement pstmt = conn.prepareStatement("select * from persontable where NAME = ?");
      pstmt.setString(1,word);
     // Execute the SQL, ResultSet is row(s) of data returned by database query
      ResultSet rs = pstmt.executeQuery();
      // return the fields of the first row of the result set      
      rs.next();
      s1.append(rs.getString("NAME"));	
      s2.append(rs.getString("AGE"));	
      s3.append(rs.getString("OCCUP"));
      // closing statement
      pstmt.close();
    }
    catch (Exception e) {
      System.err.println("Error in dbase");
      e.printStackTrace();
    }
  }	
  
  public void close() {
    try {
      conn.close();
      System.out.println("Connection Closed");
    }
    catch (Exception e) {System.err.println("Error in closing dbase");}
  }
}

