import java.awt.*;
import java.net.*;
import java.io.*;
import java.applet.*;

public class Client extends Applet {
	
	private DisplayPanel dp;	

	public Client() {
	  	setBackground(Color.pink);
		add("North",  new HeaderPanel(this));
		add("Center", dp = new DisplayPanel());
		add("South",  new ControlPanel(this));
	}

	public void showData(String name, String age, String occ) {
		PersonalData pd = new PersonalData(name, age, occ);
		dp.show(pd);
		dp.repaint();
	}

	public void getData(String a, String b, String c) {
		if (a.equals("")) {
			dp.showerr();
			dp.repaint();
		}
		else showData(a,b,c);
	}
	
	public void search(String a) {
		myDatabase database = new myDatabase();
		StringBuffer asb = new StringBuffer();
		StringBuffer bsb = new StringBuffer();
		StringBuffer csb = new StringBuffer();

		database.open();
		database.find(a, asb, bsb, csb);
		System.out.println("got back from db: " + asb.toString());
		getData(asb.toString(), bsb.toString(), csb.toString());
		database.close();
	}
}

class HeaderPanel extends Panel {

	private Label header;
	private Client par;

	public HeaderPanel(Client c) {
		par = c;
		setFont(new Font("Helvitica", Font.BOLD, 24));
		add(header = new Label("Database Connectivity Test"));
	}
}

class ControlPanel extends Panel {

	private Client parent;
	private TextField name;
	private Label lbl;

	public ControlPanel(Client clt) {
		parent = clt;
		setFont(new Font("Helvitica", Font.BOLD, 14));
		add(lbl = new Label("Enter name to search"));
		add(name = new TextField(20));
		add(new Button("Search"));
		add(new Button("Clear"));
	}

	public boolean action(Event e, Object what) {
		if(what.equals("Search")) {
			try {
				System.out.println("search for name: " + name.getText());
				parent.search(name.getText());
			}
			catch (Exception ex) {return false;}
			return true;
		}
		if(what.equals("Clear")) {
			name.setText("");
			return true;
		}
		return false;
	}
}

class DisplayPanel extends Canvas {

	private PersonalData pdata;
	private boolean nodata = false;

	String header = "Search Information";
	String nodatagot = "Sorry! There is no such person by that name.";

	public DisplayPanel() {
		pdata=null;
		resize(500,300);
	}

	public void show(PersonalData per) {
		pdata = per;
	}
		
	public void showerr() {
		pdata = null;
		nodata = true;
	}

	public void paint(Graphics g) {
		setBackground(Color.orange);
		g.setFont( new Font("Times-Roman",Font.BOLD,22));
		g.setColor(new java.awt.Color(255,0,0));
		g.drawString(header,150,25);
		if(pdata!=null) {
			g.setFont( new Font("Times-Roman",Font.BOLD,18));
			g.setColor(new java.awt.Color(0,0,0));
			g.drawString("Name       : " + pdata.getName(), 50, 60);
			g.drawString("Age        : " + String.valueOf(pdata.getAge()), 50, 80);
			g.drawString("Occupation : " + pdata.getOcc(), 50, 100);
		}
		if(pdata==null && (nodata)) {
			g.setFont( new Font("Times-Roman",Font.BOLD,18));
			g.setColor(new java.awt.Color(0,0,0));
			g.drawString(nodatagot, 50, 60);
		}
	}		       		
}

class PersonalData {
	private String Name;
	private String Age;
	private String Occ;

	public PersonalData(String name, String age, String occ) {
		Name = name;
		Age = age;
		Occ = occ;
	}

	public String getName() { return Name;}
	public String getAge()	{ return Age;}
	public String getOcc()	{ return Occ;}
}
